SystemOrganization addCategory: #'PharoMorphicView-Core'!
SystemOrganization addCategory: #'PharoMorphicView-Core-App'!
SystemOrganization addCategory: #'PharoMorphicView-Core-App-Examples'!
SystemOrganization addCategory: #'PharoMorphicView-Core-App-Others'!
SystemOrganization addCategory: #'PharoMorphicView-Core-App-Tests'!
SystemOrganization addCategory: #'PharoMorphicView-Core-Examples-BankAccount'!
SystemOrganization addCategory: #'PharoMorphicView-Core-Examples-BankAccountTests'!
SystemOrganization addCategory: #'PharoMorphicView-Core-Widgets'!

!Morph methodsFor: '*PharoMorphicView-Core-App' stamp: 'Skrish 7/8/2012 12:15'!
submorphsDo: aBlock 
	(submorphs select: [ :ea | ea visible ] ) do: aBlock! !

!Morph methodsFor: '*PharoMorphicView-Core-App' stamp: 'Skrish 1/18/2012 06:08'!
tabKey: event 
	"Check for tab key activity and change focus as appropriate."
	event controlKeyPressed
		ifFalse: [event keyCharacter = Character tab
				ifTrue: [event commandKeyPressed
						ifTrue: [World tabOpenWindows: event].
					event shiftPressed
						ifTrue: [self navigateFocusBackward]
						ifFalse: [self navigateFocusForward].
					^ true]].
	^ false! !

Error subclass: #MorphicViewException
	instanceVariableNames: 'defaultType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Others'!

!MorphicViewException commentStamp: 'skrish 1/17/2012 10:55' prior: 0!
A MorphicViewErrorHandler is to transparently handle errors to raise hard errors, log to file /transcript/stream , raise dialogs in UI dependent on the setting or API method invoked
Most apps in deployment do not need hard errors but need to have a catch all handler to get stacktrace etc, Also batch jobs vs UI may need to share the same semantics of error invocation but handle it differently to raise or not raise a dialog on screen

Can add capability to dump serialized object dump, stack trace,  for better offline debugging from an online app
.

Instance Variables
!

!MorphicViewException methodsFor: 'accessing' stamp: 'skrish 1/31/2012 06:59'!
defaultAction
	"will code later to handle the different types to raise dialog/ halt/ hard
	error or logger redirect"
	LoggerManager current log: messageText.
	^ super defaultAction! !

!MorphicViewException methodsFor: 'accessing' stamp: 'skrish 2/14/2012 00:25'!
type
	"One of #( morphic batch devimage ) and can add later"
	^ defaultType
		ifNil: [#devimage]! !

!MorphicViewException methodsFor: 'accessing' stamp: 'skrish 1/31/2012 06:57'!
type: aType 
	"One of #( morphic batch devimage ) and can add later"
	defaultType := aType! !

!PluggableButtonMorph methodsFor: '*pharomorphicview-core-app' stamp: 'skrish 2/14/2012 00:32'!
defaultBounds

	^0@0 corner: 200@30! !

!String methodsFor: '*PharoMorphicView-Core-App-Others' stamp: 'skrish 1/12/2012 10:47'!
getLocale: localeIdString 
	"localeId string is in 'en_US' format"
	^ LocaleLanguageTranslator getLocaleString: self forLocale: localeIdString! !

!String methodsFor: '*PharoMorphicView-Core-App-Others' stamp: 'skrish 1/12/2012 11:06'!
getLocaleString
	| localeIdString |
	localeIdString := LocaleLanguageTranslator getCurrentLocaleIdString.
	^ LocaleLanguageTranslator getLocaleString: self forLocale: localeIdString! !

!String methodsFor: '*PharoMorphicView-Core-App-Others' stamp: 'skr 1/13/2012 21:52'!
log
	"one from: #(#all #debug #info #notice #warn #error #crit #alert
	#emerg #panic #fatal #off #none )
	Push to LoggerManager which knows the category.. and the default level settings..
	"
	LoggerManager current log: self ! !

!String methodsFor: '*PharoMorphicView-Core-App-Others' stamp: 'skr 1/13/2012 21:46'!
logLevel: level
" one  from: #(#all #debug #info #notice #warn #error #crit #alert #emerg #panic #fatal #off #none )
Push to LoggerManager which knows the category.. for now
"

	LoggerManager current log: self level: level.! !

!String methodsFor: '*PharoMorphicView-Core-App-Others' stamp: 'skr 1/13/2012 21:47'!
logLevel: level category: cat 
	"one from: #(#all #debug #info #notice #warn #error #crit #alert
	#emerg #panic #fatal #off #none )
	Push to LoggerManager for consistency... 
	"
	LoggerManager current
		log: self
		category: cat
		level: level! !

MorphTreeNodeModel subclass: #MorphicViewGridNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-Widgets'!

!MorphicViewGridNode methodsFor: 'accessing' stamp: 'Skrish 8/2/2012 10:43'!
doesNotUnderstand: aMessage 
self halt.
	^self textMorphFor: aMessage selector! !

!MorphicViewGridNode methodsFor: 'accessing' stamp: 'Skrish 8/13/2012 10:49'!
propertyName
	| tm lbl |
	lbl := item propertyName size > 15
		ifTrue: [ (	item propertyName copyFrom: 1 to: 12 ) , '...' ]
		ifFalse: [ item propertyName ].
	tm := LabelMorph new contents: lbl.
	tm assureExtension .
	tm extension balloonText: item propertyName .
	^tm! !

!MorphicViewGridNode methodsFor: 'accessing' stamp: 'Skrish 8/13/2012 10:37'!
propertyValue
	| tm |

	tm := MorphicViewPropertyGrid createRowMorphForPropertySymbol: self item propertyName asSymbol .
	tm ifNil: [ tm := self textMorphFor: #propertyValue].
	tm model: self item.

	(tm respondsTo: #content:)
		ifTrue: [ tm content: self item propertyValue].
	
	item list ifNotNil: [ tm listSelectionIndex:  (item list indexOf: item propertyValue ) ].	
		
	tm extent: 210@20; hResizing: #rigid ; vResizing: #rigid.
	^tm
	
	! !

!MorphicViewGridNode methodsFor: 'accessing' stamp: 'Skrish 7/26/2012 10:02'!
textMorphFor: varSymbol
	| tm |

	tm := PluggableTextFieldMorph new on: item text: varSymbol accept: ( varSymbol,':' ) asSymbol readSelection: nil menu: nil.
	tm extent: 350@20.
	tm acceptOnFocusChange: true; acceptOnCR: true.
	^tm! !

EventHandler subclass: #MorphicViewEventHandler
	instanceVariableNames: 'eventsRegistered view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Others'!

!MorphicViewEventHandler commentStamp: 'skrish 1/29/2012 20:32' prior: 0!
A MorphicViewEventHandler is the keyboard and mouse event handler that defaults all of mouse actions but provides for a simpler keyboard handler registry.

Instance Variables
	eventsRegistered:		dictionary of keyboard events registered with their default receiver and action method
	view:		the primary view associated

eventsRegistered
	- xxxxx

view
	- xxxxx
!

!MorphicViewEventHandler methodsFor: 'api' stamp: 'skrish 1/18/2012 17:28'!
eventsRegistered 
	^ eventsRegistered
		ifNil: [eventsRegistered := Dictionary new]! !

!MorphicViewEventHandler methodsFor: 'api' stamp: 'Skrish 1/18/2012 15:56'!
eventsRegisteredAtKey: keyValue
"Return the registered events as complete KeyboardEvent instance with the source, buttons, keyValue set as required"
	^self eventsRegistered at: keyValue ifAbsent: []! !

!MorphicViewEventHandler methodsFor: 'private' stamp: 'Skrish 1/18/2012 06:48'!
handlesKeyboard: evt 
  ^true! !

!MorphicViewEventHandler methodsFor: 'private' stamp: 'skrish 1/18/2012 18:13'!
keyStroke: anEvent 

	^ false! !

!MorphicViewEventHandler methodsFor: 'private' stamp: 'skrish 1/18/2012 17:35'!
keyStroke: anEvent fromMorph: aMorph 
" potentially in a subclass can use the morph to get attributes/ value if reqd"
	| eventAndSelector |
	(eventAndSelector := self  eventsRegisteredAtKey: anEvent keyCharacter charCode).
	eventAndSelector ifNotNil: [
	eventAndSelector first buttons = anEvent buttons 
		ifTrue: [ eventAndSelector first hand perform: eventAndSelector last. 
			^true ]. 
		].
	"else pass through to super handler"
	(self keyStroke: anEvent )
	ifFalse: [
		super keyStroke: anEvent fromMorph: aMorph ].
! !

!MorphicViewEventHandler methodsFor: 'private' stamp: 'skrish 1/29/2012 11:40'!
mouseEnterDragging: event fromView: aView
" from a view rather than a morph"
	^ self
		send: mouseEnterDraggingSelector
		to: mouseEnterDraggingRecipient
		withEvent: event
		fromMorph: aView! !

!MorphicViewEventHandler methodsFor: 'api' stamp: 'skrish 1/18/2012 17:10'!
registerEventAtKey: keyValue event: anEventAndSelector 
	"Send in the fully filled instance of KeyboardEvent with the selector to
	invoke on match. This be a simple array of { event . #selectorName }"
	self eventsRegistered at: keyValue put: anEventAndSelector! !

MorphicViewEventHandler subclass: #TestEventHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Tests'!

!TestEventHandler methodsFor: 'event-handler' stamp: 'skrish 1/18/2012 17:03'!
keyStroke: anEvent 
	(#($k $m ) includes: anEvent keyCharacter)
		ifTrue: [UIManager default inform: 'Got It in #keystroke:  of eventHandler'.
			^ true].
	^ false! !

PluggableTextFieldMorph subclass: #NewEntryFieldMorph
	instanceVariableNames: 'initialContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-Widgets'!

!NewEntryFieldMorph methodsFor: 'init-accessing' stamp: 'skrish 1/23/2012 11:45'!
initialize
	super initialize.
	initialContents := ''! !

!NewEntryFieldMorph methodsFor: 'init-accessing' stamp: 'skrish 1/23/2012 11:41'!
isDirty
"handle this better later"
	^false! !

!NewEntryFieldMorph methodsFor: 'init-accessing' stamp: 'skrish 5/16/2012 20:32'!
padding: aNum! !

!NewEntryFieldMorph methodsFor: 'init-accessing' stamp: 'skrish 5/16/2012 20:32'!
readOnly: bool! !

!NewEntryFieldMorph methodsFor: 'init-accessing' stamp: 'skrish 1/23/2012 11:58'!
selectionColor
	^ Color gray alpha: 0.1! !

!PluggableTextFieldMorph methodsFor: '*pharomorphicview-core-app' stamp: 'skrish 2/14/2012 23:41'!
defaultBounds
"30 is the minimum height it takes..??..."
	^0@0 corner: 300@30! !

!PluggableTextFieldMorph methodsFor: '*pharomorphicview-core-app' stamp: 'skrish 2/14/2012 23:41'!
defaultExtent

	^300@30! !

!PluggableTextFieldMorph methodsFor: '*pharomorphicview-core-app' stamp: 'Skrish 2/26/2013 08:57'!
initialize 

	super initialize.
	self valueOfProperty: #noHScrollBarPlease ifAbsentPut: [ true].
	self valueOfProperty: #noVScrollBarPlease ifAbsentPut: [ true].
	textMorphClass := TextMorphForFieldView.
	self beDecrypted	
	textMorph owner bounds: self defaultBounds.
! !

NaturalLanguageTranslator subclass: #LocaleLanguageTranslator
	instanceVariableNames: ''
	classVariableNames: 'DefaultPath TextDictionary'
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Others'!

LocaleLanguageTranslator class
	instanceVariableNames: 'useLanguageFile defaultLanguageFile'!

!LocaleLanguageTranslator commentStamp: 'Skrish 8/15/2012 08:09' prior: 0!
Am I required or should be retired in favor of Pharo Translator that is built in.. but I find that broken "traslate" does something else in relation to Morphs..

Instance Variables
!

LocaleLanguageTranslator class
	instanceVariableNames: 'useLanguageFile defaultLanguageFile'!

!LocaleLanguageTranslator class methodsFor: 'accessing' stamp: 'skrish 1/19/2012 10:53'!
TextDictionary
	^ TextDictionary
		ifNil: [
			TextDictionary := Dictionary new at: 'en-US' put: ( Dictionary new at: 'Welcome to Pharo' put: 'Bienvenue au Pharo' ; yourself) ]! !

!LocaleLanguageTranslator class methodsFor: 'accessing' stamp: 'skrish 1/16/2012 09:44'!
defaultLanguageFile
	^self languageFile: self getCurrentLocaleIdString! !

!LocaleLanguageTranslator class methodsFor: 'accessing' stamp: 'Skrish 2/26/2013 09:05'!
defaultPath

^DefaultPath
    ifNil: [ FileSystem disk workingDirectory  fullName ]! !

!LocaleLanguageTranslator class methodsFor: 'translate' stamp: 'skrish 1/16/2012 09:40'!
getCurrentLocaleIdString
	| localeId |
	localeId := Locale determineCurrentLocale.
	"bug in isoCountry returns an extra 0"
	localeId isoCountry
		ifNil: [localeId := localeId isoLanguage]
		ifNotNil: [localeId := localeId isoLanguage , '-'
						, (localeId isoCountry copyFrom: 1 to: 2)].
	^ localeId! !

!LocaleLanguageTranslator class methodsFor: 'translate' stamp: 'skrish 1/16/2012 10:17'!
getLocaleString: text forLocale: localeIdString 
	"search for the dict for locale and then inside it for the text"
	| dict |
	self readLanguageFile: localeIdString.
	dict :=  self TextDictionary
		at: localeIdString ifAbsent: [] .
	dict ifNil: [ ^text]
		 ifNotNil: [ 
			^dict
				at: text asString
				ifAbsent: [text] ].! !

!LocaleLanguageTranslator class methodsFor: 'validating' stamp: 'Skrish 2/26/2013 09:07'!
isLanguageFileValid: localeString 
	
	^FileSystem disk exists: ( self languageFile: localeString)! !

!LocaleLanguageTranslator class methodsFor: 'accessing' stamp: 'Skrish 2/26/2013 09:07'!
languageFile: localeString
	| fullFileName filePath  |
	filePath := self defaultPath.
	fullFileName := WriteStream on: ''.
	fullFileName nextPutAll: filePath;
		 nextPut: FileSystem disk delimiter;
		 nextPutAll: localeString;
		 nextPut: $_;
		 nextPutAll: 'PharoNLS.csv'.
	^ defaultLanguageFile := fullFileName contents! !

!LocaleLanguageTranslator class methodsFor: 'translate' stamp: 'skrish 1/19/2012 19:40'!
parseTextToDictionary: csvText  forLocale: localeString
	"presume simple csv for now and extend to the multi line and other
	nuisances later. copy from HTMLBuilder a more complete csv parser.
	this will be just pairs of original text as key and its translated text as
	value both quoted and separated by separator defined"
	|  csvStream aPair aLocaleDict |
	
	 aLocaleDict  := Dictionary new .
	TextDictionary :=  self TextDictionary.
	TextDictionary at: localeString put:  (aLocaleDict) .
	
	csvStream := ReadStream on: csvText.
	[csvStream atEnd]
		whileFalse: [aPair := (CsvStreamReader named: 'ApplicationFramework.csvReader' ) lineEnd: String lf;
						 readEachRow: csvStream upto: 2.
			aPair first trimBoth
				ifNotEmpty: [aLocaleDict at: aPair first put: aPair last]].
! !

!LocaleLanguageTranslator class methodsFor: 'translate' stamp: 'skrish 1/16/2012 09:43'!
readLanguageFile
	self readLanguageFile: self getCurrentLocaleIdString! !

!LocaleLanguageTranslator class methodsFor: 'translate' stamp: 'Skrish 1/18/2012 13:14'!
readLanguageFile: localeString 
	"read the default language file at startup and store it in the
	TextDictionary. localeString is in 'en_US' format so search for
	en_US_PharoNLS.csv file"
	| fullFileName text fileStream |
	TextDictionary
		ifNotNil: [^ self].
	"Use cached or reset prior to fetching localeString"
	(self isLanguageFileValid: localeString)
		ifTrue: [[fileStream := FileStream
						fileNamed: (self languageFile: localeString).
			text := fileStream contents]
				ensure: [fileStream close].
	self parseTextToDictionary: text forLocale: localeString]! !

!LocaleLanguageTranslator class methodsFor: 'accessing' stamp: 'skrish 1/16/2012 10:05'!
resetDefaultPath

DefaultPath := nil
  ! !

!LocaleLanguageTranslator class methodsFor: 'accessing' stamp: 'skrish 1/16/2012 10:22'!
resetLanguageDictionary
	TextDictionary := nil! !

!LocaleLanguageTranslator methodsFor: 'methodsCopyToSuperClass' stamp: 'skrish 1/11/2012 11:52'!
getLocaleString: textSymbolString 
	"All classes using this translator copies this method in the super most class "
	^ self class getLocaleString: textSymbolString! !

!PasteUpMorph methodsFor: '*PharoMorphicView-Core-App' stamp: 'Skrish 1/18/2012 05:58'!
keyStroke: anEvent 
	"A keystroke has been made. Service event handlers and, if it's a
	keystroke presented to the world, dispatch it to
	#unfocusedKeystroke:"
	| selected |
	super keyStroke: anEvent.
	"Give event handlers a chance"
	selected := self selectedObject.
	selected isNil
		ifFalse: [selected moveOrResizeFromKeystroke: anEvent].
	anEvent keyCharacter == Character tab
		ifTrue: [self tabAmongFields
				ifTrue: [ 
					anEvent  commandKeyPressed
						ifTrue: [^ self tabOpenWindows: anEvent].
					^ self tabHitWithEvent: anEvent]].
	self isWorldMorph
		ifTrue: [self keystrokeInWorld: anEvent]! !

!PasteUpMorph methodsFor: '*PharoMorphicView-Core-App' stamp: 'Skrish 1/18/2012 06:05'!
tabOpenWindows: aKeyboardEvent 
	| currentFocus index |
	currentFocus := aKeyboardEvent hand keyboardFocus.
	SystemWindow noteTopWindowIn: self.
	SystemWindow topWindow sendToBack.
! !

!CheckboxMorph methodsFor: '*pharomorphicview-core-app' stamp: 'skrish 2/13/2012 11:17'!
defaultBounds
"answer the default bounds for the receiver "
	^ 0 @ 0 corner: 100 @ 30! !

!CheckboxMorph methodsFor: '*pharomorphicview-core-app' stamp: 'skrish 2/13/2012 11:16'!
selected: aValue

	self enabled ifFalse: [^self].
	self model ifNil: [^self].
	(self setStateSelector ifNil: [^self]) numArgs = 0
		ifTrue: [self model perform: self setStateSelector].
	self setStateSelector numArgs = 1
		ifTrue: [	self model perform: self setStateSelector with: aValue].
	self updateSelection! !

CheckboxMorph subclass: #RadioButtonMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Examples'!

!RadioButtonMorph methodsFor: 'user-interface' stamp: 'skrish 2/12/2012 00:25'!
initialize
"(Morph new color: Color transparent ; addMorph: (self new label: 'one')) openInWorld"
	super initialize .
	self beRadioButton! !

!RadioButtonMorph methodsFor: 'user-interface' stamp: 'skrish 2/7/2012 18:44'!
isSelected
	"Answer whether the receiver is selected."

	self model ifNil: [^false].
	^self model perform: (self getStateSelector ifNil: [^false]) with: self! !

!RadioButtonMorph methodsFor: 'user-interface' stamp: 'skrish 2/7/2012 18:40'!
toggleSelected
	"Toggle the selection state."

	self enabled ifFalse: [^self].
	self model ifNil: [^self].
	(self setStateSelector ifNil: [^self]) numArgs = 0
		ifTrue: [self model perform: self setStateSelector].
	self setStateSelector numArgs = 1
		ifTrue: [	self model perform: self setStateSelector with: self ].
	self updateSelection
	! !

!Inspector methodsFor: '*pharomorphicview-core-app' stamp: 'skrish 2/11/2012 19:14'!
arrowKey: aChar from: view
	"backstop; all the PluggableList* classes actually handle arrow keys, and the models handle other keys."
	^false! !

PluggableDialogWindow subclass: #NewDialogWindow
	instanceVariableNames: 'useThemedFillStyle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-Widgets'!

!NewDialogWindow commentStamp: 'skr 1/8/2012 10:28' prior: 0!
A NewDialogWindow is overriding the DialogWindow to provide some opportunity to intervene in methods as used ....

Instance Variables
!

!NewDialogWindow methodsFor: 'accessing' stamp: 'Skrish 2/26/2013 09:14'!
useThemedFillStyle

	^ useThemedFillStyle ifNil: [ false] .
	! !

!NewDialogWindow methodsFor: 'accessing' stamp: 'Skrish 2/26/2013 09:14'!
useThemedFillStyle: aBool
"hacking it up to allow color of window/ dialog be retained"

	 useThemedFillStyle := aBool! !

TestCase subclass: #BankAccountDropListViewTests
	instanceVariableNames: 'aWin dropListView delay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-Examples-BankAccountTests'!

!BankAccountDropListViewTests methodsFor: 'tests' stamp: 'skrish 1/20/2012 00:38'!
setUp
	dropListView := BankAccountsDropListView named: 'ApplicationFrameworkTests.BankAccountsDropListView'.
	dropListView reinitialize.
	aWin := dropListView primaryWindow
				ifNil: [aWin := dropListView createPrimaryView].
	aWin openCenteredInWorld
		extent: (dropListView class guiConstants at: 'bankAccountsDropListViewExtent').
	delay := 1000! !

!BankAccountDropListViewTests methodsFor: 'tests' stamp: 'skrish 1/11/2012 08:04'!
step: aBlock with: view at: nextTime
	World
		addAlarm: #value:
		withArguments: {view}
		for: aBlock
		at: nextTime! !

!BankAccountDropListViewTests methodsFor: 'tests' stamp: 'skrish 1/11/2012 07:55'!
tearDown
	World
		addAlarm: #delete
		withArguments: {}
		for: aWin
		at: Time millisecondClockValue + delay! !

!BankAccountDropListViewTests methodsFor: 'tests' stamp: 'skrish 1/20/2012 06:38'!
testDropListView
	"self new setTestSelector: #testDropListView ;
	runCase"
	dropListView createAccount.
	dropListView createAccount.
	self assert: dropListView bankAccountList size = 2 description: ' two new accounts not created'.
	self assert: (dropListView bankAccountList last dependents first primaryWindow = dropListView  primaryWindow ) description: 'added view as dependent'! !

!BankAccountDropListViewTests methodsFor: 'tests' stamp: 'skrish 1/19/2012 19:51'!
testHaveFun
	"self new setTestSelector: #testHaveFun ;
	runCase"
	delay := 5000.
	self assert: (dropListView primaryWindow submorphs
			select: [:ea | (ea isKindOf: AbstractResizerMorph) not]) size < 4 description: 'basic morphs on screen'.
	dropListView createAccount; createAccount; createAccount.
	self
		step: [:view | 
			view getBankAccountView runsNum: 1.
			view bankAccountList first name: 'ChangedName'.
			self assert: (view getBankAccountView morphsDictionary at: 'accountNameText') textMorph contents = 'ChangedName' description: 'Should change the name'.
			view getBankAccountView controller openHistoryMorph]
		with: dropListView
		at: Time millisecondClockValue + 1000.
	self
		step: [:view | 
			view getBankAccountView runsNum: 3.
			view bankAccountList last name: 'New Name'.
			self assert: (view getBankAccountView morphsDictionary at: 'accountNameText') textMorph contents = 'New Name' description: 'Should change the name'.
			view getBankAccountView controller openHistoryMorph]
		with: dropListView
		at: Time millisecondClockValue + 2000.
	self
		step: [:view | 
			| reportMorph |
			view getBankAccountView runsNum: 5.
			(view bankAccountList at: 2)
				name: 'Second'.
			self assert: (view getBankAccountView morphsDictionary at: 'accountNameText') textMorph contents = 'Second' description: 'Should change the name'.
			reportMorph := view getBankAccountView controller openHistoryMorph.
			reportMorph delete]
		with: dropListView
		at: Time millisecondClockValue + 3000! !

!BankAccountDropListViewTests methodsFor: 'tests' stamp: 'skrish 1/20/2012 00:01'!
testInitializedView
	"self new setTestSelector: #testInitializedView ;
	runCase"
	| aList |
	aList := #('One' 'Two' 'Three' )
				collect: [:ea | BankAccount named: 'BankAccountView.', ea	].
	dropListView bankAccountList: aList asOrderedCollection.
	(dropListView morphsDictionary at: 'bankAccountList') updateList.
	self assert: (dropListView primaryWindow submorphs
			select: [:ea | (ea isKindOf: AbstractResizerMorph) not]) size < 4 description: 'basic morphs on screen'.
	self assert: (dropListView morphsDictionary at: 'bankAccountList') getList size = 3 description: 'three items in the list..'! !

!BankAccountDropListViewTests methodsFor: 'tests' stamp: 'skr 1/10/2012 00:10'!
testOpenedView
	"self new setTestSelector: #testOpenedView ;
	runCase"
	dropListView createAccount.
	dropListView createAccount.
	self assert: dropListView primaryWindow submorphs size > 7 description: 'all morphs on screen, unless more added... later'.
	self assert: (dropListView morphsDictionary at: 'bankAccountList') getList size = 2   description: 'two items on screen'! !

TestCase subclass: #BankAccountReportTests
	instanceVariableNames: 'bankAccount report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-Examples-BankAccountTests'!

!BankAccountReportTests methodsFor: 'tests' stamp: 'skrish 1/20/2012 00:15'!
setUp
	bankAccount := BankAccount createNewAccount.
	bankAccount deposit: 1.
	report := BankAccountReportView new: bankAccount! !

!BankAccountReportTests methodsFor: 'tests' stamp: 'skr 1/5/2012 17:46'!
testBankAccountReportCreation
	"self new setTestSelector: #testBankAccountReportCreation ;
	runCase"
	| morph |
	morph := report historyMorph.
	self assert: morph submorphs size = 2 description: 'Should have default single bar'.
	morph delete.! !

!BankAccountReportTests methodsFor: 'tests' stamp: 'skrish 1/31/2012 07:03'!
testBankAccountReportCreationError
	"self new setTestSelector: #testBankAccountReportCreationError ;
	runCase"
	| anAccount |
	anAccount := BankAccount createNewAccount.
	[BankAccountReportView new: anAccount]
		on: Error
		do: [:ex | self assert: ex description = 'MorphicViewException: Invalid Account' description: 'Not the expected exception']! !

!BankAccountReportTests methodsFor: 'tests' stamp: 'skrish 1/20/2012 00:42'!
testBankAccountReportView
	"self new setTestSelector: #testBankAccountReportView ;
	runCase"
	| morph |
	1
		to: 10
		do: [:ea | bankAccount deposit: 10 * ea].
	1
		to: 7
		do: [:ea | bankAccount withdraw: 7 * ea].
	morph := report openHistoryMorph.
	self assert: morph submorphs size = 19 description: 'Should have default single bar'.
	self assert: (  'NewAccount*' match: morph submorphs first contents ) description: 'Name morph not added'.
	morph delete! !

TestCase subclass: #BankAccountTests
	instanceVariableNames: 'bankAccount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-Examples-BankAccountTests'!

!BankAccountTests methodsFor: 'tests' stamp: 'skrish 1/20/2012 00:16'!
setUp
	bankAccount := BankAccount createNewAccount! !

!BankAccountTests methodsFor: 'tests' stamp: 'skrish 1/20/2012 00:16'!
testBankAccountId
	"self new setTestSelector: #testBankAccountId ; runCase"
	self assert: bankAccount accountId > BankAccount minId & bankAccount accountId < BankAccount maxId description: 'Account Id should be in this range'! !

!BankAccountTests methodsFor: 'tests' stamp: 'skrish 1/20/2012 00:16'!
testBankDeposit
	"self new setTestSelector: #testBankDeposit ; runCase"
	bankAccount deposit: 10.
	self assert: bankAccount balance = 10.
	self assert: bankAccount history first = 10! !

!BankAccountTests methodsFor: 'tests' stamp: 'skrish 1/20/2012 00:16'!
testBankInitialize
	"self new setTestSelector: #testBankInitialize ; runCase"
	self assert: bankAccount balance = 0.
	self assert: bankAccount history isEmpty! !

!BankAccountTests methodsFor: 'tests' stamp: 'skrish 1/20/2012 00:16'!
testBankWithdraw
	"self new setTestSelector: #testBankDeposit ; runCase"
	bankAccount deposit: 10.
	bankAccount withdraw: 7.
	self assert: bankAccount balance = 3.
	self assert: bankAccount history last = 3! !

!BankAccountTests methodsFor: 'tests' stamp: 'skrish 1/31/2012 07:02'!
testBankWithdrawError
	"self new setTestSelector: #testBankWithdrawError ; runCase"
	bankAccount deposit: 10.
	[bankAccount withdraw: 17]
		on: Error
		do: [:ex | self assert: ex description = 'MorphicViewException: Withdrawal: Exceeds Funds Available' description: 'Not the expected error']! !

TestCase subclass: #BankAccountViewController
	instanceVariableNames: 'bankAccountView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-Examples-BankAccount'!

!BankAccountViewController class methodsFor: 'as yet unclassified' stamp: 'skr 1/9/2012 10:57'!
funWithMultipleAccountsAndSingleView

! !

!BankAccountViewController class methodsFor: 'as yet unclassified' stamp: 'skr 1/9/2012 00:00'!
new

 self shouldNotImplement! !

!BankAccountViewController class methodsFor: 'as yet unclassified' stamp: 'skr 1/9/2012 00:14'!
new: aView
	
	| viewController |
	viewController := super new.
	viewController bankAccountView: aView.
	^viewController! !

!BankAccountViewController methodsFor: 'accessing' stamp: 'skr 1/9/2012 22:04'!
bankAccountModel
	^ bankAccountView bankAccount! !

!BankAccountViewController methodsFor: 'accessing' stamp: 'skr 1/9/2012 00:01'!
bankAccountView
	^bankAccountView! !

!BankAccountViewController methodsFor: 'accessing' stamp: 'skr 1/9/2012 00:01'!
bankAccountView: aView

	bankAccountView := aView! !

!BankAccountViewController methodsFor: 'accessing' stamp: 'skrish 2/14/2012 00:11'!
name
	^self bankAccountModel name
		! !

!BankAccountViewController methodsFor: 'accessing' stamp: 'skrish 2/14/2012 00:11'!
name: aName 
	aName = self bankAccountModel name
		ifFalse: [self bankAccountModel name: aName]! !

!BankAccountViewController methodsFor: 'actions' stamp: 'Skrish 8/14/2012 19:57'!
openHistoryMorph
	| report reportMorph morphsDictionary |
	morphsDictionary := bankAccountView morphsDictionary.
	bankAccountView resetStatusField.
	bankAccountView resetFields.
	reportMorph
		ifNotNil: [:r | r delete].
	[(bankAccountView resetFieldsLinkedModel: bankAccountView bankAccount) .
	self runRandomTrans: bankAccountView runsNum.
	"triggers their action methods on accept"
	^bankAccountView openHistoryMorph: self bankAccountModel]
		on: Error
		do: [:ex | (morphsDictionary at: 'statusField')
				setText: ex description]! !

!BankAccountViewController methodsFor: 'actions' stamp: 'skrish 2/14/2012 00:11'!
resetHistory
	self bankAccountModel balance: 0.
	self bankAccountModel history removeAll.
	bankAccountView resetStatusField! !

!BankAccountViewController methodsFor: 'actions' stamp: 'Skrish 8/14/2012 20:04'!
runRandomTrans: num 
	"random for now.. but take input value to modify"
	| tranNum morphsDictionary bankAccount |
	bankAccount := self bankAccountModel.
	morphsDictionary := bankAccountView morphsDictionary.
	num = 0 ifTrue: [ ^self ].
	num < 1 | (num > 10)
		ifTrue: [^ UIManager default inform: 'Enter in the range 1 - 10'].
	tranNum := (Random new next * num) asInteger + 3.
	1
		to: tranNum
		do: [:ea | bankAccount deposit: 10 * ea].
	tranNum := (Random new next * num) asInteger + 3.
	[1
		to: tranNum
		do: [:ea | bankAccount withdraw: 7 * ea]]
		on: Error
		do: [:ex | ^ (morphsDictionary at: 'statusField')
				setText: ex description].
	(morphsDictionary at: 'statusField')
		setText: 'run random deposits and withdrawals'! !

TestCase subclass: #BankAccountViewTests
	instanceVariableNames: 'bankAccount view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-Examples-BankAccountTests'!

!BankAccountViewTests methodsFor: 'tests' stamp: 'skr 1/10/2012 10:27'!
setUp
	view := BankAccountView basicNew initialize! !

!BankAccountViewTests methodsFor: 'tests' stamp: 'skrish 1/19/2012 11:46'!
tearDown
	view primaryWindow delete! !

!BankAccountViewTests methodsFor: 'tests' stamp: 'skrish 1/20/2012 00:18'!
testBankAccountView
	"self new setTestSelector: #testBankAccountView ; runCase"
	"| morph view |
	view := BankAccountView basicNew initialize.
	view bankAccount:
	BankAccount new initialize.
	view controller: (BankAccountViewController new: view).
	morph := view createPrimaryView.
	^ morph openCenteredInWorld; extent: 450 @ 250"
	"Need to fix the crash in all coverage tests..."
	| morph |
	view bankAccount: BankAccount createNewAccount.
	view
		controller: (BankAccountViewController new: view).
	morph := view createPrimaryView.
	view primaryWindow openInWorld.
	self assert: true description: 'Need to complete this testcase'! !

TestCase subclass: #BasicIniReaderTests
	instanceVariableNames: 'iniText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Tests'!

!BasicIniReaderTests methodsFor: 'tests' stamp: 'skrish 1/19/2012 00:18'!
setUp
	iniText := ' [ Section 1 ]
#comment line
key1 = Value1
Key2 = Value2

 [ Section 2 ]
#comment line
key21 = Value21
Key22 = Value22
Key23 = Value23
'! !

!BasicIniReaderTests methodsFor: 'tests' stamp: 'skrish 1/20/2012 00:54'!
testBasicIniReader
	"( self selector: #testBasicIniReader) runCase"
	| iniReader iniDict |
	iniReader := BasicIniReader named: 'ApplicationFramework.configIniReader' .
	iniReader parseIniText: iniText.
	iniDict := iniReader iniDictionary.
	self assert: iniDict size = 2 description: 'Should get the two sections of key values'.
	self
		assert: (iniDict values first size = 2
				and: [iniDict values last size = 3])
		description: 'The two sections should have these many items only'.
	self assert: (iniReader getValueAt: 'key1' atSection: 'Section 1')
			= 'Value1' description: 'Key value check'.
	self assert: (iniReader getValueAt: 'Key23' atSection: 'Section 2')
			= 'Value23' description: 'Key value check'! !

TestCase subclass: #ConfigurationTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Tests'!

!ConfigurationTests methodsFor: 'tests' stamp: 'skrish 1/19/2012 01:10'!
sampleIniFile
	^ '[MorphicViewConstants]
viewExtent = 20@20 corner: ( #RealEstateAgent #maximumUsableAreaInWorld: ) corner - 20 
defaultWindowType = #Window
primaryWindowColor = gray


'! !

!ConfigurationTests methodsFor: 'tests' stamp: 'skrish 2/8/2012 15:06'!
setUp
	| aFs |
	[aFs := FileStream fileNamed: 'application_properties.ini.test'.
	aFs nextPutAll: self sampleIniFile]
		ensure: [aFs close]! !

!ConfigurationTests methodsFor: 'tests' stamp: 'skrish 1/19/2012 18:41'!
testPrototypeNamed
	"( self selector: #testPrototypeNamed) runCase"
	| config |
	config := Configuration named: 'ApplicationFrameworkTests.Configuration'.
	self
		assert: (config notNil
				and: [config
						= (Configuration named: 'ApplicationFrameworkTests.Configuration')])
		description: 'Should be the same valid instance'.
	config := Configuration named: 'ApplicationFramework.notAllowed'.
	self assert: config isNil description: 'Should be the same valid instance'! !

!ConfigurationTests methodsFor: 'tests' stamp: 'skrish 2/8/2012 15:04'!
testReadApplicationConstantsFile
	"( self selector: #testReadApplicationConstantsFile) runCase"
	| viewExtent iniReader viewExtentText config |
	config := (Configuration named: 'ApplicationFrameworkTests.Configuration')
				readApplicationConstants: #tests.
	iniReader := config iniReader.
	iniReader resetIniDictionary.
	config readApplicationConstants: #tests..
	viewExtentText := iniReader getValueAt: 'viewExtent' atSection: 'MorphicViewConstants'.
	self assert: viewExtentText = '20@20 corner: ( #RealEstateAgent #maximumUsableAreaInWorld: ) corner - 20' description: 'Expected text not substituted and evaluated'.
	self assert: (iniReader evaluate: viewExtentText for: 'viewExtent')
			= (20 @ 20 corner: (RealEstateAgent maximumUsableAreaInWorld: World) corner - 20) description: 'Full Bounds margin of 20 expected'! !

TestCase subclass: #LanguageTranslatorTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Tests'!

!LanguageTranslatorTests methodsFor: 'tests' stamp: 'skrish 2/8/2012 15:13'!
sampleNLSFile

	^'Welcome to Pharo , Bienvenue au Pharo' , String crlf , '
Good Bye, Au Revoir'! !

!LanguageTranslatorTests methodsFor: 'tests' stamp: 'skrish 2/8/2012 15:18'!
setUp
	| aFs |
	[aFs := FileStream fileNamed: 'fr_FR_PharoNLS.csv'.
	aFs nextPutAll: self sampleNLSFile]
		ensure: [aFs close].

	[aFs := FileStream fileNamed: 'en-US_PharoNLS.csv'.
	aFs nextPutAll: self sampleNLSFile]
		ensure: [aFs close]		.

	LocaleLanguageTranslator resetLanguageDictionary ! !

!LanguageTranslatorTests methodsFor: 'tests' stamp: 'skrish 1/12/2012 11:11'!
testForDefaultString
	
	self assert: ( 'Welcome to Pharo' getLocaleString = 'Bienvenue au Pharo' ) description: 'This is the default string'! !

!LanguageTranslatorTests methodsFor: 'tests' stamp: 'skrish 1/12/2012 11:12'!
testForNotTranslatedString
	self assert: 'Not Translated' getLocaleString = 'Not Translated' description: 'This is the default string'! !

!LanguageTranslatorTests methodsFor: 'tests' stamp: 'skrish 1/19/2012 19:40'!
testReadCSVFile
	"self new setTestSelector: #testReadCSVFile; runCase"
	| aFs  aPair text csvStream nlsDict |
	[ aFs := FileStream fileNamed: 'fr_FR_PharoNLS.csv'.
	 text := aFs contents ]
	ensure: [ aFs close ].

	nlsDict := Dictionary new.
	csvStream := ReadStream on: text .
	[csvStream atEnd]
		whileFalse: [	aPair :=  (CsvStreamReader named: 'ApplicationFramework.csvReader' ) lineEnd: (String lf) ; readEachRow:  csvStream  upto: 2.
					aPair first trimBoth ifNotEmpty: [
							nlsDict at: aPair first put: aPair last ]. 
					].
	
	self assert: ( nlsDict size > 1 ) description: 'Did not get the values from a valid file '.
	self assert: ( 'Welcome to Pharo' getLocaleString = 'Bienvenue au Pharo' ) description: 'This is the default string'! !

!LanguageTranslatorTests methodsFor: 'tests' stamp: 'skrish 1/19/2012 10:52'!
testReadCurrentLanguageFile
	"self new setTestSelector: #testReadCSVFile; runCase"
	"Presume current language file is available.. en_US_PharoNLS.csv dump
	it from setup.. for better predictability later.."
	LocaleLanguageTranslator resetLanguageDictionary; readLanguageFile: 'en-US'.
	self assert: ( (LocaleLanguageTranslator TextDictionary at: 'en-US' ifAbsent: [] ) notNil ) description: 'Should atleast have three key-val pairs in the file'.
	self assert: 'Welcome to Pharo' getLocaleString = 'Bienvenue au Pharo' description: 'This is the default string'! !

TestCase subclass: #LoggerTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Tests'!

!LoggerTests methodsFor: 'tests' stamp: 'skrish 1/18/2012 19:05'!
setUp

	LoggerManager loggersStart: #( transcript).
	! !

!LoggerTests methodsFor: 'tests' stamp: 'skrish 1/19/2012 10:55'!
tearDown
	LoggerManager loggersStop; reset.
	Transcript closeAllViews! !

!LoggerTests methodsFor: 'tests' stamp: 'skrish 1/18/2012 19:07'!
testLoggerWorks
	"(self  selector: #testLoggerWorks ) runCase"
	LoggerManager current log: 'test'! !

TestCase subclass: #MorphicViewTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Tests'!

!MorphicViewTests methodsFor: 'tests' stamp: 'Skrish 2/26/2013 09:32'!
testPanelViewInitializeSpecs
	"(self selector: #testPanelViewInitializeSpecs) runCase"
	| view originalSource newSource originalMethod |
	view := AbstractMorphicView new.
	originalMethod := AbstractMorphicView compiledMethodAt: #panelViewInitializeSpecs.
	newSource := 'panelViewInitializeSpecs ^{''panel1'' -> { #viewController: -> #MorphicViewController.
	#viewModel: -> #Object}	} '.
	view panels at: 'panel1' put: AbstractMorphicView new.
	[AbstractMorphicView
		compile: newSource
		classified: originalMethod category
		withStamp: Author changeStamp
		notifying: Transcript
		logSource: false.
	view panelViewInitialize.
	self assert: ((view panels at: 'panel1')
			instVarNamed: 'viewController') class name = #MorphicViewController description: ''.
	self assert: ((view panels at: 'panel1')
			instVarNamed: 'viewModel') class name = #Object description: ''.
	self assert: ((view panels at: 'panel1')
			instVarNamed: 'viewController') controllerModel class name = #Object description: '']
		ensure: [AbstractMorphicView methodDict at: #panelViewInitializeSpecs put: originalMethod]! !

!MorphicViewTests methodsFor: 'tests' stamp: 'Skrish 7/11/2012 07:57'!
testSimpleMorphicViewKeyStringSpecs

	| aView | 
	
		aView :=  SimpleImplicitMorphicView new
					 createMorphsSpecs: { 'text1' -> #TextField . 'btn1' -> #Button };
					 morphsPrimaryPropertiesSpecs: {};
					 morphsSecondaryPropertiesSpecs: { 'text1' -> '{ #extent: -> { 123@20} . #color: -> { Color red} }' . 'btn1' -> '{ #extent: -> { 100@20} . #color: -> { Color red}  }'};
					setAllMorphsToResizeOrWrap: #spaceFill;					
					yourself .
		aView createPrimaryView .
		self assert:( (aView morphsDictionary at: 'text1') extent = ( 123@20)) description: 'Could not compile specs'! !

TestCase subclass: #NamedPrototypeTests
	instanceVariableNames: 'prototypes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Tests'!

!NamedPrototypeTests methodsFor: 'tests' stamp: 'skrish 1/29/2012 12:26'!
setUp

	prototypes := NamedPrototype instance.
	prototypes resetFlag: true;
		 resetNamedPrototypeAt: 'tests'.! !

!NamedPrototypeTests methodsFor: 'tests' stamp: 'skrish 1/11/2012 09:18'!
testAddNamedPrototype
	"self new setTestSelector: #testAddNamedPrototype ; runCase"
	| aMorph3 aMorph2 |
	prototypes new: #Morph named: 'tests.TestMorph'.
	aMorph2 := prototypes at: 'tests.TestMorph'.
	aMorph2 extent: 100 @ 100.
	prototypes add: aMorph2 named: 'tests.TestMorph2'.
	aMorph3 := prototypes at: 'tests.TestMorph2'.
	self assert: aMorph3 extent = aMorph2 extent description: 'the prototype given is a copy..'! !

!NamedPrototypeTests methodsFor: 'tests' stamp: 'skrish 1/11/2012 09:21'!
testCreateNamedPrototype
	"self new setTestSelector: #testCreateNamedPrototype ; runCase"
	| aMorph aMorph2 |
	aMorph := prototypes new: #Morph named: 'tests.PrototypeTestMorph'.
	aMorph extent: 100 @ 100.
	aMorph2 := prototypes at: 'tests.PrototypeTestMorph'.
	self assert: aMorph extent = aMorph2 extent description: 'the prototype given is a copy..'! !

!NamedPrototypeTests methodsFor: 'tests' stamp: 'skrish 1/11/2012 09:22'!
testReplaceNamedPrototype
	"self new setTestSelector: #testReplaceNamedPrototype ; runCase"
	| aMorph3 aMorph2 |
	prototypes new: #Morph named: 'tests.TestMorph'.
	aMorph2 := prototypes at: 'tests.TestMorph'.
	aMorph2 extent: 100 @ 100.
	prototypes add: aMorph2 named: 'tests.TestMorph2'.
	aMorph2 extent: 200 @ 200.
	prototypes replace:  'tests.TestMorph2' with: aMorph2.
	aMorph3 := prototypes at: 'tests.TestMorph2'.
	self assert: aMorph3 extent = aMorph2 extent description: 'the prototype given is a copy..'! !

TestCase subclass: #PharoCoreTests
	instanceVariableNames: 'aWin aView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Tests'!

!PharoCoreTests commentStamp: 'skrish 1/11/2012 11:47' prior: 0!
A PharoCoreTests is through the TestNewMorphicView test all of the PharoSKRCore capabilities...

Instance Variables
!

!PharoCoreTests methodsFor: 'init' stamp: 'skrish 1/19/2012 10:57'!
setUp
	aView  := TestNewProportionalMorphicView new.
	aView open! !

!PharoCoreTests methodsFor: 'init' stamp: 'skrish 1/19/2012 10:57'!
tearDown
	aView primaryWindow delete! !

!PharoCoreTests methodsFor: 'init' stamp: 'skrish 1/19/2012 10:58'!
testAbstractMorphicView
	self assert: aView morphsDictionary size = 3 description: 'Currently expect 7 items'! !

TestCase subclass: #TestNewImplicitMorphicView
	instanceVariableNames: 'aView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Tests'!

!TestNewImplicitMorphicView methodsFor: 'tests' stamp: 'skrish 2/11/2012 11:09'!
setUp

   aView := SimpleImplicitMorphicView new windowType: #Window.

		
	! !

!TestNewImplicitMorphicView methodsFor: 'tests' stamp: 'skrish 2/8/2012 19:39'!
tearDown

   aView primaryWindow delete
		
	! !

!TestNewImplicitMorphicView methodsFor: 'tests' stamp: 'Skrish 8/24/2012 20:43'!
testSimpleViewImplicitSpecs
	"self new setUp testSimpleViewImplicitSpecs"

	" (self selector: #testSimpleViewImplicitSpecs) runCase"

	aView
		createMorphsSpecs:
			{('label1' -> #LabelMorph).
			('text1' -> #PluggableTextMorph).
			('button1' -> #PluggableButtonMorph).
			('check1' -> #CheckboxMorph).
			('textField' -> #PluggableTextMorph)}.
	aView
		morphsPrimaryPropertiesSpecs:
			{('button1'->
					(#on:getState:action:label:menu:->
							{[ UIManager default inform: 'Welcome to MorphicView Framework' ]. nil. #value. nil. nil}))}.
	aView
		morphsSecondaryPropertiesSpecs:
			{('label1' ->
					{(#vResizing: -> {#rigid}).
					(#extent: -> {(400 @ 30)})}).
			('button1' ->
					{(#hResizing: -> {#rigid}).
					(#vResizing: -> {#rigid}).
					(#extent: -> {(400 @ 30)}).
					(#label: -> {'Button B'})}).
			('check1' ->
				 	{(#vResizing: -> {#rigid}).
					(#extent: -> {(400 @ 30)})}).
			('textField' ->
					{(#vResizing: -> {#rigid}).
					#acceptOnCR: -> { true}.
					(#extent: -> {(400 @ 36)})})}.
	aView open.
	self assert: aView morphsDictionary size = 5 description: ''! !

!PluggableTextMorph methodsFor: '*pharomorphicview-core-app' stamp: 'skrish 2/12/2012 00:37'!
defaultBounds

	^ 0@0 corner: 300@150.
	! !

!PluggableTextMorph methodsFor: '*pharomorphicview-core-app' stamp: 'skrish 2/11/2012 23:20'!
defaultExtent

	^300@150.
	! !

!PluggableTextMorph methodsFor: '*pharomorphicview-core-app' stamp: 'Skrish 2/26/2013 09:01'!
initialize
	"initialize the state of the receiver"
	super initialize.
	textMorph 
		ifNotNil: [
			self setText: ''.
			textMorph bounds: self defaultBounds].
	hasUnacceptedEdits := false.
	hasEditingConflicts := false.
	askBeforeDiscardingEdits := true.
	enabled := true.
	highlights := OrderedCollection new! !

!PluggableTextMorph methodsFor: '*pharomorphicview-core-app' stamp: 'skrish 2/11/2012 19:00'!
keyboardFocusChange: aBoolean
	"Pass on to text morph."
	self textMorph ifNil: [ ^self].
	aBoolean ifTrue: [self textMorph takeKeyboardFocus]! !

!PluggableTextMorph methodsFor: '*pharomorphicview-core-app' stamp: 'Skrish 2/26/2013 09:47'!
resetTextBounds

	textMorph ifNotNil: [
				textMorph wrapFlag:  true.
				textMorph bounds: ( 0@0 corner: self extent)]! !

Object subclass: #BankAccountReportView
	instanceVariableNames: 'bankAccount reportViewMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-Examples-BankAccount'!

!BankAccountReportView class methodsFor: 'instance creation' stamp: 'skr 1/5/2012 09:06'!
new
	^self shouldNotImplement! !

!BankAccountReportView class methodsFor: 'instance creation' stamp: 'skr 1/5/2012 09:19'!
new: aBankAccount
	
	| aReport |
	aBankAccount validate.
	aReport := self basicNew .
	aReport bankAccount: aBankAccount.
	^aReport! !

!BankAccountReportView methodsFor: 'accessing' stamp: 'skr 1/5/2012 09:08'!
bankAccount: aBankAccount

	bankAccount := aBankAccount

	! !

!BankAccountReportView methodsFor: 'user interface' stamp: 'skrish 1/19/2012 12:04'!
close
	reportViewMorph delete! !

!BankAccountReportView methodsFor: 'user interface' stamp: 'skrish 1/19/2012 12:04'!
historyMorph
	| bars oldVal |
	oldVal := 0.
	bars := bankAccount history
				collect: [:v | 
					| amt amtStr |
					amt := v - oldVal.
					amtStr := ''.
					amt < 0
						ifTrue: [amtStr := amt abs asString , ' DR'].
					amt > 0
						ifTrue: [amtStr := amt asString , ' CR'].
					oldVal := v.
					Morph new extent: 30 @ v;
						 borderWidth: 1;
						 setBalloonText: amtStr].
	reportViewMorph := AlignmentMorph newRow
				color: (Color lightBlue alpha: 0.4);
				 hResizing: #shrinkWrap;
				 vResizing: #shrinkWrap;
				 cellPositioning: #bottomRight.
	reportViewMorph setBalloonText: bankAccount detailsString.
	reportViewMorph addAllMorphs: bars.
	reportViewMorph addMorph: bankAccount name asMorph.
	^ reportViewMorph! !

!BankAccountReportView methodsFor: 'user interface' stamp: 'skrish 1/19/2012 12:13'!
openHistoryMorph

	reportViewMorph := 
		reportViewMorph ifNil: [ self historyMorph].
	reportViewMorph openCenteredInWorld.
	reportViewMorph
		on: #click
		send: #delete
		to: reportViewMorph.
	^ reportViewMorph! !

Object subclass: #NamedPrototype
	instanceVariableNames: 'namedPrototypeDictionary backupDictionary resetFlag prototypeHolder'
	classVariableNames: 'NamedPrototypeInstance'
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Others'!

!NamedPrototype commentStamp: 'Skrish 8/15/2012 08:20' prior: 0!
The class to realize the capabilities of Spring: Singleton, factory thorugh named prototypes..

Class intention
	Allow all classes to invoke the named: / related api methods to instantiate a singleton per name/ alias

Class collaborations
	I usually do not work in isolation but with the help of ...

Class main API
	My main public API is ...My subclasses may want to override such specific hooks ...
Implementation notes
!

!NamedPrototype class methodsFor: 'instance creation' stamp: 'skr 1/9/2012 10:51'!
instance

	NamedPrototypeInstance ifNil: [ 
			NamedPrototypeInstance := self  basicNew].
	^NamedPrototypeInstance
! !

!NamedPrototype class methodsFor: 'instance creation' stamp: 'skr 1/9/2012 10:22'!
new
	self shouldNotImplement! !

!NamedPrototype class methodsFor: 'instance creation' stamp: 'Skrish 8/14/2012 22:16'!
resetNamedPrototypeInstance

	NamedPrototypeInstance := nil! !

!NamedPrototype methodsFor: 'add replace' stamp: 'skrish 1/16/2012 23:29'!
add: prototype named: aName 
	| appAndName |
	appAndName := self validateName: aName.
	(self exists: appAndName last)
		ifTrue: [self error: 'Named Prototype Exists' getLocaleString].
	^ (self namedPrototypeDictionary at: appAndName first)
		at: appAndName last
		put: prototype"ifAbsent: ..."! !

!NamedPrototype methodsFor: 'api' stamp: 'skr 1/13/2012 22:03'!
at: aName 
	| namedInstances prototype appAndName |
	appAndName := self validateName: aName.
	prototype := (self namedPrototypeDictionary at: appAndName first)
				at: appAndName last
				ifAbsent: [^ self
						error:  'Prototype Not Found' getLocaleString].
	^ prototype! !

!NamedPrototype methodsFor: 'api' stamp: 'skr 1/13/2012 22:04'!
copy: aName to: newName 
"create a copy of the prototype with a new named instance"
	| namedInstances prototype appAndName |
	appAndName := self validateName: aName.
	prototype := (self namedPrototypeDictionary at: appAndName first)
				at: appAndName last
				ifAbsent: [^ self
						error:  'Prototype Not Found' getLocaleString].
	^ self add: newName named: prototype veryDeepCopy! !

!NamedPrototype methodsFor: 'api' stamp: 'skr 1/10/2012 09:47'!
exists: aName
	
	^(self namedPrototypeDictionary
		at: aName
		ifAbsent: [])
		notNil! !

!NamedPrototype methodsFor: 'others' stamp: 'skrish 1/11/2012 09:12'!
getLocaleString: textSymbolString 
	^ self class getLocaleString: textSymbolString! !

!NamedPrototype methodsFor: 'accessing' stamp: 'skrish 1/20/2012 00:34'!
namedPrototypeDictionary
	namedPrototypeDictionary
		ifNil: [namedPrototypeDictionary := Dictionary new.
			backupDictionary := Dictionary new].
	^ namedPrototypeDictionary! !

!NamedPrototype methodsFor: 'api' stamp: 'skrish 1/31/2012 06:11'!
new: aClassSymbol named: aName 
	"Ideal if this is used in #new for any of the classes that must
	participate in this framework"
	| prototype appAndName |
	appAndName := self validateName: aName.
	Smalltalk
		at: aClassSymbol
		ifAbsent: [self error: 'Class Does Not Exist' getLocaleString].
	(self exists: appAndName last)
		ifTrue: [self flag: 'Error is too much of a block.. think through'].
	prototype := (Smalltalk at: aClassSymbol) basicNew initialize. 
	(self namedPrototypeDictionary
		at: appAndName first
		ifAbsentPut: [self prototypeHolder])
		at: appAndName last
		put: prototype.
	^ prototype! !

!NamedPrototype methodsFor: 'api' stamp: 'skrish 1/31/2012 06:11'!
new: aClassSymbol namedOrExisting: aName 
	"Ideal if this is used in #new for any of the classes that must
	participate in this framework"
	| prototype appAndName |
	appAndName := self validateName: aName.
	Smalltalk
		at: aClassSymbol
		ifAbsent: [self error: 'Class Does not Exist' getLocaleString].
	prototype := (self namedPrototypeDictionary
				at: appAndName first
				ifAbsentPut: [self prototypeHolder])
				at: appAndName last
				ifAbsent: [].
	prototype
		ifNil: [prototype := (Smalltalk at: aClassSymbol) basicNew initialize.
			(self namedPrototypeDictionary at: appAndName first)
				at: appAndName last
				put: prototype].
	^ prototype! !

!NamedPrototype methodsFor: 'others' stamp: 'skrish 1/29/2012 12:44'!
prototypeHolder
	"convinient to allow extending NamedPrototypes to function as
	Application wide Cached dictionary strong/ weak as required"
	^ prototypeHolder
		ifNil: [prototypeHolder := WeakValueDictionary new]! !

!NamedPrototype methodsFor: 'others' stamp: 'skrish 1/29/2012 12:42'!
prototypeHolder: aWeakOrNormalDictionary 
	prototypeHolder := aWeakOrNormalDictionary ! !

!NamedPrototype methodsFor: 'add replace' stamp: 'skrish 1/16/2012 23:29'!
replace: aName with: prototype 
	"should be used carefully"
	| appAndName |
	appAndName := self validateName: aName.
	^ (self namedPrototypeDictionary at: appAndName first)
		at: appAndName last
		put: prototype! !

!NamedPrototype methodsFor: 'accessing' stamp: 'skr 1/10/2012 10:06'!
resetFlag
	^resetFlag ifNil: [ true] ifNotNil: [ resetFlag].! !

!NamedPrototype methodsFor: 'accessing' stamp: 'skr 1/10/2012 10:07'!
resetFlag: aBool 
"will presume you know what you are doing to the prototypes dict if you set this and call #reset"
	resetFlag := aBool! !

!NamedPrototype methodsFor: 'others' stamp: 'Skrish 8/15/2012 07:50'!
resetNamedPrototype
	"Should there be any warning.. for non empty dictionary to prevent
	blowing out all instances for the image..?"
	self resetFlag
		ifFalse: [^ self].

	backupDictionary :=  namedPrototypeDictionary 
	namedPrototypeDictionary keys do: [ :eaApp  |
			namedPrototypeDictionary at: eaApp put:  self class new prototypeHolder ].
					
			! !

!NamedPrototype methodsFor: 'others' stamp: 'Skrish 2/26/2013 09:37'!
resetNamedPrototypeAt: app 
	"Should there be any warning.. for non empty dictionary to prevent
	blowing out all instances for the image..?"
	self resetFlag
		ifFalse: [^ self].
	self namedPrototypeDictionary
		at: app
		ifAbsentPut: [WeakValueDictionary new].
	backupDictionary at: app put: (namedPrototypeDictionary at: app) copy.
	"shallow copy should be adequate here, physically restore it when
	needed..a backdoor for now"
	self class = NamedPrototype
		ifFalse:  [ namedPrototypeDictionary at: app put: self class new prototypeHolder]! !

!NamedPrototype methodsFor: 'validate' stamp: 'skr 1/13/2012 22:06'!
validateName: aName 
	| appAndName |
	aName  isString not
		ifTrue: [self
				error:  'Name Must Be String' getLocaleString].
	appAndName := aName subStrings: '.'.
	appAndName size = 2
		ifFalse: [self
				error: ( 'Expects App.Name Format' getLocaleString )].
	^ appAndName! !

Object subclass: #PharoMorphicObject
	instanceVariableNames: 'prototypeName logger'
	classVariableNames: 'GuiConstants'
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App'!

PharoMorphicObject subclass: #AbstractMorphicView
	instanceVariableNames: 'primaryWindow morphsDictionary panelWindow windowType panels eventHandler viewController viewModel mouseListener useDefaultOKButton bounds useDefaultBounds valueWrapperClass resizing panelOwner okBtnActionBlock windowTitle dialogAnswer worldOrMorphOwner defaultDialogButtons defaultScrollBars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App'!

AbstractMorphicView class
	instanceVariableNames: 'useLanguageFile'!

!AbstractMorphicView commentStamp: 'skrish 1/30/2012 10:17' prior: 0!
An AbstractMorphicView is an abstract class for view composition.

The "subclass responsibility" and "override-in-subclass" category defines methods that must/ can be overridden

This is extensible in future to serve as a convinient superclass to create complex views

Instance Variables
	morphsDictionary:		<Dictionary of submorphs>
	primaryWindow:		<SystemWindow or can be a DialogWindow>

morphsDictionary
	- xxxxx

primaryWindow
	- xxxxx
!

AbstractMorphicView class
	instanceVariableNames: 'useLanguageFile'!

!AbstractMorphicView class methodsFor: 'user interface' stamp: 'skr 1/6/2012 21:32'!
applicationWindow

	^self new createPrimaryView! !

!AbstractMorphicView class methodsFor: 'translation' stamp: 'Skrish 7/13/2012 13:00'!
guiConstants
	| guiConstants offset |
	

     ^super guiConstants
		at: 'primaryWindowColor'
		ifAbsentPut: (Color darkGray alpha: 0.9);
		
		at: 'panelWindowColor'
		ifAbsentPut: (Color gray lighter alpha: 0.2);
		
		at: 'viewBounds'
		ifAbsentPut: ( 50 @ 30  corner: (RealEstateAgent maximumUsableAreaInWorld: World) corner - ( 20@ 10 ));
		
		at: 'defaultViewFont'
		put: ( LogicalFont
		familyName: 'Comic Sans MS'
		pointSize: 10
		stretchValue: nil
		weightValue: nil
		slantValue:nil);
		
	yourself! !

!AbstractMorphicView class methodsFor: 'user interface' stamp: 'skrish 3/9/2012 20:37'!
isView: aClass

	^aClass basicNew isKindOf: self! !

!AbstractMorphicView class methodsFor: 'user interface' stamp: 'skr 1/10/2012 21:50'!
open
	"open it the way required with bounds / centered etc.."
	^ self new open! !

!AbstractMorphicView methodsFor: 'events' stamp: 'Skrish 2/26/2013 13:47'!
addAlarm: aSelector withArguments: args at: scheduledTime
	"Not sure if I have a good use case for this method here.. .. "
	
	(self primaryWindow owner notNil and: [ primaryWindow owner isWorldMorph ])
			ifTrue: [ primaryWindow owner addAlarm: aSelector withArguments: args for: self at: scheduledTime].! !

!AbstractMorphicView methodsFor: 'default-settings' stamp: 'Skrish 2/26/2013 13:47'!
allMorphsDefaultSpecs
"defaults that will be applied to all the morphs if they can respond to it: see setAllMorphsDefaultSpecs"
	^{
		"#hResizing: -> [:assoc | { #shrinkWrap}].
		#vResizing: -> [:assoc | { #shrinkWrap}]."
		#cornerStyle: -> [ :assoc | { #rounded}].
		
		}! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'Skrish 2/26/2013 13:47'!
bounds


	^bounds ifNil: [ self defaultBounds ]
	! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'Skrish 2/26/2013 13:47'!
bounds: aBounds

	bounds := aBounds
	! !

!AbstractMorphicView methodsFor: 'menu' stamp: 'Skrish 2/26/2013 13:47'!
buildMenuBarMorph
"menu bar for the view"
	|  menuArray dock |
	menuArray := self createMenuArray.
	dock := primaryWindow newToolDockingBar.
	menuArray do: [ :eaMenuArray  | 
		self flag: 'does not pop up correctly for embedding this StandardWindow inside another MorphicView panelWindow..?. issue with bounds vs boundsInWorld'.
		dock
			add: ( eaMenuArray  first)
			font: (eaMenuArray  at: 2)
			icon: (eaMenuArray at: 3)
			help: (eaMenuArray at: 4)
			subMenu: (eaMenuArray at: 5 ).		
		].
	^dock color: Color transparent! !

!AbstractMorphicView methodsFor: 'user interface' stamp: 'Skrish 2/26/2013 13:47'!
canOpenInTabbedPane
"default dev tabbed pane will subsume all windows as a pane unless the extension param is set to false"
	^false! !

!AbstractMorphicView methodsFor: 'actions' stamp: 'Skrish 9/3/2012 09:30'!
close
"Should nil out all other components.. viz panelWindow, morphsDictionary.. ?"
	self resetPanelView .
	primaryWindow ifNotNil: [ primaryWindow delete]! !

!AbstractMorphicView methodsFor: 'internal processing' stamp: 'skrish 2/15/2012 10:28'!
collectMorphs

	^morphsDictionary values collect: [ :ea |
			(self isValueWrapper: ea ) 
				ifTrue: [ ea morph]
				ifFalse: [ ea] ]! !

!AbstractMorphicView methodsFor: 'internal processing' stamp: 'Skrish 9/2/2012 10:14'!
composeMorphs
	"compose the morphs into the primaryWindow as is with
	morphsDictionary or with further composition in complex layout.
	"
	| m |
	m := panelWindow .
	m hResizing: #spaceFill; vResizing: #spaceFill.		
	primaryWindow
		addMorph: (m layoutFrame: self panelWindowLayoutFrame).
	panelWindow color: (Color transparent ).
		! !

!AbstractMorphicView methodsFor: 'internal processing' stamp: 'Skrish 8/21/2012 01:24'!
composePanelWindow
	"compose the morphs into the primaryWindow as is with
	morphsDictionary or with further composition in complex layout.
	This takes the default ProportionalLayout and to get TableLayout we
	need to go for SimpleMorphicView
	"
	| collectMorphs |
	panelWindow := self panelWindow layoutPolicy: ProportionalLayout new.
	useDefaultBounds ifTrue: [ panelWindow bounds: self bounds]. 
	collectMorphs := self collectMorphs. 
	collectMorphs do: [ :eaMorph | panelWindow addMorph: eaMorph fullFrame: eaMorph layoutFrame ].

! !

!AbstractMorphicView methodsFor: 'helper' stamp: 'skrish 6/22/2012 09:49'!
createAllMorphsVarsAndGetters

	| vars |
	vars :=  OrderedCollection new.
	self recurseSpec: self createMorphsSpecs vars: vars.
	self createMorphsVarsAndGetters: vars silently: false.! !

!AbstractMorphicView methodsFor: 'user interface' stamp: 'Skrish 9/3/2012 09:18'!
createDefaultDialogButtons
	"currently uses the PluggableDialogWindow's #useDefaultOKButton. This can override to provide richer actions.
	 the default extension ok button to be created for dialogs or morphs "	

	| buttonRow |
	(windowType = #Dialog and: [ primaryWindow buttons notEmpty])
		ifTrue: [ 	panelWindow := self panelWindow .
					(buttonRow := primaryWindow newButtonRow) extent: 120@30.
					buttonRow  layoutFrame: (LayoutFrame fractions: (0@1 corner: 1@1) offsets: ( 0@ -40 corner: 0@0)).
					primaryWindow addMorphFront: buttonRow .
					buttonRow color: Color transparent ].
	"for morphs by default, can be used for all others also for the ability to set ok actionBlock"
	defaultDialogButtons = #OK
	 ifTrue: [
		primaryWindow
		addMorph: ( (PluggableButtonMorph new on: self getState: nil action: #okBtnAction label: nil menu: nil ) label: 'OK' )
		fullFrame: (LayoutFrame
				fractions: (1@1  corner: 1 @ 1)
				offsets: (-80 @ -34 corner: -10 @ -4)) ]! !

!AbstractMorphicView methodsFor: 'menu' stamp: 'Skrish 8/13/2012 12:34'!
createMenuArray

	^{}! !

!AbstractMorphicView methodsFor: 'internal processing' stamp: 'Skrish 8/16/2012 09:52'!
createMorphsDictionary
	"add the morphs to the morphsDictionary variable for access to set
	and modify properties as required later. Use all of the Pluggable** ,
	LabelMorph (or any of the Morph subclasses if your know what they
	do and how.) to add to this dictionary in the order laid out viz:
	"
	morphsDictionary ifNotEmpty: [ ^morphsDictionary ].
	self createMorphsSpecs
		do: [:eaAssoc | 
			self handleCreationOfMorphs: eaAssoc ]! !

!AbstractMorphicView methodsFor: 'subclass responsibility' stamp: 'skrish 2/15/2012 10:55'!
createMorphsSpecs
	"subclass need to specify their morps collection
	^{
	'label1' -> #LabelMorph.
	'text1' -> #PluggableTextMorph.
	'button1' -> #PluggableButtonMorph.
	} 
	"
	^ self subclassResponsibility! !

!AbstractMorphicView methodsFor: 'helper' stamp: 'skrish 6/20/2012 09:22'!
createMorphsVarsAndGetters: varKeys 

	| aClass varsColl |
	
	varsColl := (varKeys copy removeAllFoundIn: self class instVarNames; yourself).
	varsColl do: [ :eaVar | 
		self class addInstVarNamed: eaVar.		
		].
	aClass := self class.
		varKeys do: [ :each | | suffix |
		     ( aClass methodDict keys includes: each asSymbol  )
				ifFalse: [ aClass compile: (each , '\\' withCRs ,String tab, '^', each) classified: 'accessing'].
			 ].
	! !

!AbstractMorphicView methodsFor: 'helper' stamp: 'skrish 6/22/2012 09:51'!
createMorphsVarsAndGetters: varKeys silently: bool

	| vars |
	vars := varKeys.
	bool ifFalse: [ 
			vars := MultiSelectListWidget new list: varKeys ; windowTitle: 'Variables Select' ; openModal ; answer. 
			vars isEmptyOrNil ifTrue:  [ ^self]  ].
	self createMorphsVarsAndGetters: vars! !

!AbstractMorphicView methodsFor: 'user interface' stamp: 'Skrish 8/21/2012 09:03'!
createPrimaryDialogWindow
	"create  DialogWindow as the primary pane"
	primaryWindow := (PluggableDialogWindow
				labelled: (self name asString getLocaleString ))
				color: (self class guiConstants at: 'primaryWindowColor' );
				 beUnresizeable.
	primaryWindow title: self windowTitle.
	"Figure out why #useDefaultOKButton does not render the button for DialogWindow"
! !

!AbstractMorphicView methodsFor: 'user interface' stamp: 'Skrish 8/24/2012 20:23'!
createPrimaryMorph
	"create plain morph as the primary pane"
	primaryWindow := Morph new layoutPolicy: ProportionalLayout new;
								color: (self class guiConstants at: #primaryWindowColor).! !

!AbstractMorphicView methodsFor: 'user interface' stamp: 'Skrish 9/3/2012 09:20'!
createPrimaryNewDialogWindow
	"create a NewDialogWindow as	the primary pane, This is a place holder for specialized type of Window. Possibly extensions to support animation hooks / events through #drawOn: / step can be later supported as part of the framework"
	primaryWindow := ( NewDialogWindow
				labelled: (self name asString getLocaleString ))
				color: (self class guiConstants at: 'primaryWindowColor' );
				 beUnresizeable.
	primaryWindow title: self windowTitle.! !

!AbstractMorphicView methodsFor: 'user interface' stamp: 'Skrish 8/17/2012 10:22'!
createPrimaryStandardWindow
	"create StandardWindow as the primary pane"
	
	primaryWindow := (StandardWindow labelled: self windowTitle )
				color: (self class guiConstants at: 'primaryWindowColor')! !

!AbstractMorphicView methodsFor: 'user interface' stamp: 'Skrish 9/2/2012 10:20'!
createPrimarySystemWindow
	"create SystemWindow as the primary pane"
	primaryWindow := SystemWindow new
				color: (self class guiConstants at: 'primaryWindowColor')! !

!AbstractMorphicView methodsFor: 'user interface' stamp: 'Skrish 8/22/2012 10:32'!
createPrimaryView
	"createPrimaryView"
	self createMorphsDictionary.
	self panelViewInitialize.
	self setMorphsPrimaryProperties.
	self setMorphsSecondaryProperties.
	self layoutSpecs.
	self createPrimaryWindow.
	self composePanelWindow.
	self postCreateInitialize.
	self setViewBounds.
	self composeMorphs.
	self setWindowSpecs .! !

!AbstractMorphicView methodsFor: 'user interface' stamp: 'Skrish 8/24/2012 10:30'!
createPrimaryWindow
	"create the primary SystemWindow, Dialog or probably plain morph as
	the primary pane"
	
	primaryWindow ifNotNil: [ :p |" p owner ifNotNil: [ "^self "]" ].
	
	windowType ifNil: [ windowType := #Window].
	windowType = #Dialog
		ifTrue: [self createPrimaryDialogWindow].
	windowType = #Morph
		ifTrue: [self createPrimaryMorph].
	windowType = #Window
		ifTrue: [self createPrimarySystemWindow].
	windowType = #StandardWindow
		ifTrue: [self createPrimaryStandardWindow].		
	windowType = #NewDialog
		ifTrue: [self createPrimaryNewDialogWindow].	
		
	primaryWindow eventHandler: self eventHandler.
	 
	primaryWindow assureExtension valueOfProperty: #canOpenInTabbedPane ifAbsentPut: [self canOpenInTabbedPane ]! !

!AbstractMorphicView methodsFor: 'user interface' stamp: 'Skrish 9/2/2012 09:55'!
createScrollPaneMorph
"Will bring in the horizontal / vertical options later.."
	| scrollPaneMorph |
	
	defaultScrollBars = #both
	ifTrue: [ 	scrollPaneMorph := ScrollPane new layoutPolicy: ProportionalLayout new.
				scrollPaneMorph scroller addMorphFront: (self panelWindow layoutFrame: self panelWindowLayoutFrame ).
				panelWindow := scrollPaneMorph ]! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 2/15/2012 10:28'!
defaultBounds

	^self class guiConstants at: 'viewBounds' 
	! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'Skrish 8/21/2012 09:07'!
defaultDialogButtons: symbol
"Ref createDefaultDialogButtons for the symbol variants"

	defaultDialogButtons := symbol ! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'Skrish 8/23/2012 11:09'!
defaultScrollBars: symbol
"Ref createScrollPaneMorph for the variants"

	defaultScrollBars := symbol ! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'Skrish 7/27/2012 11:21'!
dialogAnswer 

	^dialogAnswer  ifNil: [ dialogAnswer := OrderedCollection  new]! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 2/15/2012 10:28'!
eventHandler
	eventHandler := eventHandler
				ifNil: [(Smalltalk at: #MorphicViewEventHandler ifAbsent: []) ifNotNil: [ :ev | ev basicNew] ]
				ifNotNil: [(eventHandler class isKindOf: Metaclass)
						ifTrue: [eventHandler basicNew]
						ifFalse: [eventHandler]].
	^ eventHandler! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 2/15/2012 10:28'!
eventHandler: customEventHandler 

	(customEventHandler isKindOf: MorphicViewEventHandler) 
		ifFalse: [ self error: ( 'Should be an instance of: <1s>' getLocaleString expandMacrosWith: 'MorphicViewEventHandler' ) ].
	eventHandler := customEventHandler! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 2/15/2012 10:28'!
extent: anExtent

	bounds := 20@20 corner: anExtent.! !

!AbstractMorphicView methodsFor: 'default-settings' stamp: 'skrish 2/15/2012 10:28'!
fixPrimaryWindowBounds
" find a simpler algorithm to get the correct bounds set..or probably a hack like openAsIn: aWorld "
  |  newExtent  | 

 "add the layoutFrame compensation wrt to the window bounds, twice to compensate layoutFrame otherwise shrinking the panelWindow on addMorph call.."
   newExtent :=( ((self panelWindowLayoutFrame minExtentFrom: primaryWindow extent) - (primaryWindow extent)) abs) + (8@8).
"add up the primaryWindow top title bar y"
  newExtent := newExtent + (0 @ primaryWindow layoutBounds origin y).
"compensate for borders.."
  newExtent := newExtent +(((primaryWindow borderWidth) @(primaryWindow borderWidth)) * 2) .
 ^panelWindow fullBounds extendBy:  newExtent.! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 5/20/2012 21:41'!
getAllFieldValues

^(morphsDictionary select: [ :ea | 
		[ ea value notNil ] on: Error do: [:ex | false] ]) collect: [ :ea |
		 ea value]! !

!AbstractMorphicView methodsFor: 'internal processing' stamp: 'Skrish 8/25/2012 11:40'!
hackSettingWindowColorToNewTheme
"Themes override setting per window color..!!!!.. except for Vistary... so there.. will run through this in detail later.."

	(self windowSpecs detect: [ :ea |
			ea key = #color: ] ifNone: [])
				ifNil: [ primaryWindow theme: nil]
				ifNotNil: [ primaryWindow theme: UIThemeVistary new].
	! !

!AbstractMorphicView methodsFor: 'internal processing' stamp: 'Skrish 8/15/2012 21:48'!
handleCreationOfMorphs: eaAssoc 

	| morphKeyValuePairs  |
	( ('row*' match: eaAssoc key) or: [ 'col*' match: eaAssoc key  ] )
		 ifTrue: [
			morphKeyValuePairs := eaAssoc value select: [ :ea | ea key ~= #resizing].
			morphKeyValuePairs do: [:eaPair | self handleCreationOfMorphs: eaPair ]
			]
	      ifFalse: [self insertWidgetInMorphsDictionary: eaAssoc] ! !

!AbstractMorphicView methodsFor: 'events' stamp: 'skrish 2/2/2012 11:06'!
handleListenEvent: anEvent 
	"Handle the given event. This message is sent if the receiver is a
	registered listener for the given event."
	| view |
	(self viewIsTopWindow: anEvent position)
		ifTrue: [
			mouseListener
				ifNotNil: [
					anEvent sentTo: self mouseListener
]]! !

!AbstractMorphicView methodsFor: 'viewer' stamp: 'Skrish 9/3/2012 09:29'!
imageForm
"the view as a form for bitmap representation: debate if it ought to be the panelWindow or primaryWindow eventually"
	^ primaryWindow ifNotNil: [ primaryWindow imageFormForRectangle:  primaryWindow fullBounds]
		ifNil: [ Form default ]! !

!AbstractMorphicView methodsFor: 'init' stamp: 'Skrish 8/23/2012 11:12'!
initialize

 	morphsDictionary := Dictionary new.
	useDefaultBounds := false.
	panelWindow := nil.
	panels := Dictionary new.
! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 6/19/2012 09:00'!
initializeMorphValues: aDictOfValues
"dictionary of morphId->value pairs"

  morphsDictionary keysAndValuesDo:  [ :eaKey :eaValue |
	   ( ( aDictOfValues keys includes: eaKey) and: [self  isValueWrapper:   eaValue]) 
	      ifTrue: [ eaValue value: ( aDictOfValues at: eaKey ifAbsent: [''] ) ]] 
	
		! !

!AbstractMorphicView methodsFor: 'helper' stamp: 'Skrish 7/13/2012 11:37'!
insertWidgetInMorphsDictionary: associationOfKeyAndMorphSymbol

	| instance  eaAssoc morphSymbol | 
	eaAssoc := associationOfKeyAndMorphSymbol.
	instance := self morphFrom: eaAssoc value.
	instance ifNil: [ morphsDictionary at: eaAssoc key put: eaAssoc value ].
	(self isMorphicView: instance)
	ifTrue: [
		self panels at: eaAssoc key put: instance.
		instance panelOwner: self.
		instance createPrimaryView.
		(self  class instVarNames includes:  eaAssoc key asString)
			ifTrue: [ self instVarNamed: eaAssoc key asString put: instance morph ].
		morphsDictionary at: eaAssoc key put: instance panelWindow].
	eaAssoc value = #LabelAndTextField
		ifTrue: [ instance labelAttributeAt: #contents: put: {eaAssoc key  asString}.
				 instance panelWindow vResizing: #shrinkWrap ].
	instance isMorph
		ifTrue: [
			(instance morph isKindOf: LabelMorph )
					ifTrue: [instance contents: eaAssoc key].
			(self  class instVarNames includes:  eaAssoc key asString)
				ifTrue: [self instVarNamed: eaAssoc key asString put: instance].					
			morphsDictionary at: eaAssoc key put: instance]! !

!AbstractMorphicView methodsFor: 'validate' stamp: 'skrish 2/11/2012 20:06'!
isMorphicView

	^true

	 ! !

!AbstractMorphicView methodsFor: 'validate' stamp: 'skrish 2/11/2012 20:07'!
isMorphicView: aViewOrMorph

	^[ aViewOrMorph isMorphicView ]
		on: MessageNotUnderstood  do: [ :ex |
			ex return: false	]! !

!AbstractMorphicView methodsFor: 'validate' stamp: 'Skrish 8/12/2012 11:15'!
isPrimaryWindowActive
	
  ^self primaryWindow notNil and: [self primaryWindow owner notNil]! !

!AbstractMorphicView methodsFor: 'validate' stamp: 'skrish 2/11/2012 07:01'!
isValueWrapper: anObject

	^[ anObject isValueWrapper ]
		on: MessageNotUnderstood do: [ :ex | ex return: false]! !

!AbstractMorphicView methodsFor: 'validate' stamp: 'Skrish 7/12/2012 22:45'!
isView: aClass

	^aClass basicNew isKindOf: self! !

!AbstractMorphicView methodsFor: 'events' stamp: 'skrish 1/18/2012 22:53'!
keyEventInfoArray
	"example:
	^ {{64. $L. model. #keyAltOrCTRLAndCapsLPressed}. {8. $G. model.
	#keyShiftAndSmallGPressed} }"
	"Array of arrays of ( command key code . keyChar . model .
	methodName) to execute"
	^ {}! !

!AbstractMorphicView methodsFor: 'internal processing' stamp: 'Skrish 9/3/2012 09:42'!
layoutSpecs
	"self shouldNotOverride. this is never to be overridden by any
	subclass"
	| specsArray aColl |
	specsArray := self layoutSpecsArray.
	"Ensure all morphs have a layout spec"
	aColl := morphsDictionary keys asSet.
	aColl removeAllFoundIn: (specsArray
			collect: [:ea | ea key]) asSet.
	aColl
		ifNotEmpty: [^ self
				error: ('Missing layoutSpec for: <1s> ' getLocaleString expandMacrosWith: aColl asString)].
	"Iterate to set the layout specs to each morph"
	specsArray
		do: [:eaSpec | 
			| aFrame |
			aFrame := LayoutFrame fractions: eaSpec value first value offsets: eaSpec value last value.
			self validateLayoutSpecFrame: aFrame for: eaSpec key .
			(morphsDictionary
				at: eaSpec key
				ifAbsent: [^ self error: 'Not defined in morphs dictionary' getLocaleString])
				layoutFrame: aFrame]! !

!AbstractMorphicView methodsFor: 'subclass responsibility' stamp: 'skrish 6/19/2012 09:03'!
layoutSpecsArray
	"Add the layoutFrame: for each of the submorphs/ mainmorph with fractions:offsets: specArray specified as per sample below
	Do remember to leave it untouched for TableLayouts.. they do not honor these specs.. but prefer the extent being specified.. to flow the layout in rows/ columns"
	"^{
	'widgetNameInMorphsDictionary' -> {
				#fractions -> (0 @ 0 corner: 1 @ 0.5).  '' fractional value 0 to 1 range ''
				#offsets -> (10 @ 10 corner: 0 @ 0).    '' offsets relative to the fractional position ''
				}.
		}"
	self subclassResponsibility! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 6/27/2012 09:27'!
morphFrom: aClassSymbol
"Using ValueWrappers.. else just return (Smalltalk at: aClassSymbol) new"

		aClassSymbol isSymbol ifFalse: [ ^nil ].
		^self valueWrapperClass  morphFrom: aClassSymbol! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skr 1/9/2012 20:14'!
morphsDictionary

^morphsDictionary! !

!AbstractMorphicView methodsFor: 'subclass responsibility' stamp: 'skrish 5/24/2012 09:21'!
morphsPrimaryPropertiesSpecs
	"Though not essential for bare view prototypes, will need to be overridden for almost all implementations"
	"call super setMorphsPrimaryProperties if default settings are reqd"
			
	"set the primary action/ model attributes to the morphs specially the
	widgets that require model linked selector invocations"
	"Specs example:	
	^{
	'label1'->( #selector1 -> { argumentsArray1 }).

	'text1' -> ( #selector1 -> { argumentsArray1 }).
	}
	"
	
	^{}.! !

!AbstractMorphicView methodsFor: 'subclass responsibility' stamp: 'Skrish 8/14/2012 13:14'!
morphsSecondaryPropertiesSpecs

	^ {}! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 3/18/2012 23:44'!
mouseListener
	mouseListener
		ifNil: [mouseListener := (Smalltalk at: #MorphicViewMouseListener ifAbsent: []) ifNotNil: [ :ml | ml  view: self] ] .
	^ mouseListener! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 1/29/2012 12:10'!
mouseListener: aMouseListener 

	"Moot if we should do a type check.. at all.. but for beginners this is a image crash saver... atleast till we fix the infinite loop problem"
	(aMouseListener isKindOf: MorphicViewMouseListener) 
		ifFalse: [ self error: ( 'Should be an instance of: <1s>' getLocaleString expandMacrosWith:'MorphicViewMouseListener' ) ].
	mouseListener := aMouseListener view: self.
! !

!AbstractMorphicView methodsFor: 'actions' stamp: 'Skrish 8/11/2012 21:36'!
okBtnAction 

	self okBtnAction: true
	! !

!AbstractMorphicView methodsFor: 'actions' stamp: 'Skrish 8/11/2012 21:36'!
okBtnAction: closeWindowBool

	okBtnActionBlock
		 ifNil: [ primaryWindow delete] 
		ifNotNil: [  dialogAnswer := okBtnActionBlock value: self . closeWindowBool ifTrue: [primaryWindow delete] ]
	! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 5/22/2012 23:02'!
okBtnActionBlock: aBlockToExecute 

	okBtnActionBlock := aBlockToExecute ! !

!AbstractMorphicView methodsFor: 'internal processing' stamp: 'Skrish 8/16/2012 00:03'!
open
"Preferably never to be overridden by subclasses.. but need to solve the open bounds/ properties override after opening properly..
 the bug seems to be in layout composition, overrides any bounds/ extent setting apriori with defaults defined on per widget / primaryWindow 
Other properties also seems to have similar soft bug... "
 
	self isPrimaryWindowActive
		ifTrue: [ morphsDictionary := nil. panelWindow := nil ].
	self createPrimaryView.
	self postCreateOpen.
	self postOpen! !

!AbstractMorphicView methodsFor: 'actions' stamp: 'Skrish 8/22/2012 10:29'!
openModal
	"Open the given window locking the receiver until it is dismissed.
	Answer the system window.
	Restore the original keyboard focus when closed."

	self createPrimaryView .
	self openWindowModal.
	self postOpen.
	^primaryWindow! !

!AbstractMorphicView methodsFor: 'actions' stamp: 'Skrish 8/22/2012 10:29'!
openWindowModal
	
	|area mySysWin keyboardFocus|
	keyboardFocus := World activeHand keyboardFocus.
	mySysWin := World isSystemWindow ifTrue: [World] ifFalse: [World ownerThatIsA: SystemWindow].
	mySysWin ifNil: [mySysWin := World].
	mySysWin modalLockTo: primaryWindow.
	area := RealEstateAgent maximumUsableArea.
	"primaryWindow extent: primaryWindow initialExtent." "just this commented out to ensure no widget is default clipped out..just bcos its a panelmorph with other morphs inset"
	primaryWindow position = (0@0)
		ifTrue: [primaryWindow
				position: World activeHand position - (primaryWindow extent // 2)].
	primaryWindow
		bounds: (primaryWindow bounds translatedToBeWithin: area).
		 primaryWindow openAsIs.
	[ |aWidget | 
	aWidget := primaryWindow openAsIs.
	[aWidget world notNil] whileTrue: [
		aWidget outermostWorldMorph doOneCycle]]
		ensure: [mySysWin modalUnlockFrom: primaryWindow.
				World activeHand newKeyboardFocus: keyboardFocus].! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 2/11/2012 20:10'!
owner
"guess should be the current World"
	^nil! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 5/1/2012 19:05'!
panelOwner
	^ panelOwner! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 5/1/2012 19:05'!
panelOwner: anObject
	panelOwner := anObject! !

!AbstractMorphicView methodsFor: 'internal processing' stamp: 'Skrish 2/26/2013 13:39'!
panelViewInitialize
	"allow panels to be initialized with their controller/ model"
	| panelView |
  	self panelViewInitializeSpecs
		do: [:ea | 
			panelView := self panels
						at: ea key
						ifAbsent: [].
			panelView
				ifNotNil: [ea value
						do: [:eaAssoc | 
							| instanceOrSymbol |
							instanceOrSymbol := eaAssoc value.
							instanceOrSymbol isSymbol
								ifTrue: [instanceOrSymbol := (Smalltalk
												at: instanceOrSymbol
												ifAbsent: [ Array new ])
												ifNotNil: [:e | Array with: e new]].
							panelView perform: eaAssoc key withArguments: instanceOrSymbol]]].
! !

!AbstractMorphicView methodsFor: 'override-in-subclass' stamp: 'skrish 1/27/2012 19:27'!
panelViewInitializeSpecs
	"3. specs to set attributes..specially the controller.."
	"viz: 
	^{
	'panelView1' -> {
	#viewController: -> #MorphicViewController.
	#viewModel: -> #Object }
	}
	OR:
	^{
	'panelView1' -> {
	#viewController: -> MorphicViewController new.
	#viewModel: -> Object new }
	}	
	"
	^ {}! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'Skrish 8/21/2012 01:00'!
panelWindow
	^ panelWindow
		ifNil: [ AlignmentMorph new  ]! !

!AbstractMorphicView methodsFor: 'internal processing' stamp: 'Skrish 8/24/2012 22:11'!
panelWindowLayoutFrame

	| layout dialogWindowLayout |
	layout :=  LayoutFrame fractions: ( 0@0 corner: 1@1) offsets: ( 4@4 corner: -4 @ -4).
	dialogWindowLayout :=  LayoutFrame fractions: ( 0@0 corner: 1@1) offsets: ( (4@ 4) corner: (-4 @ -45)).
	(( (windowType = #NewDialog) | (windowType = #Dialog) | (windowType = #Morph) ) and: [ defaultDialogButtons ~= #None] )
		ifTrue: [ layout := dialogWindowLayout ].
	self createMenuArray ifNotEmpty: [ layout topOffset: 30 ].
	^layout.	
! !

!AbstractMorphicView methodsFor: 'init' stamp: 'skrish 1/17/2012 02:32'!
panels
	^panels ifNil: [ 
		panels := Dictionary new]! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 5/29/2012 22:59'!
panelsProperties
"implement the required properties setter her.. not specs.."! !

!AbstractMorphicView methodsFor: 'internal processing' stamp: 'Skrish 8/25/2012 12:26'!
performSpecMessages: specs 
	
	specs  do: [:ea |
		(primaryWindow respondsTo: ea key)
			ifTrue: [ primaryWindow perform: ea key withArguments: ( ea value)].
		ea key = #color:
			ifTrue: [ 	primaryWindow isSystemWindow
							ifTrue: [ primaryWindow setWindowColor: ea value first].
						panelWindow color: ea value first]
			].
	(windowType = #Dialog | (windowType = #Morph))
		ifTrue: [ 	self createDefaultDialogButtons].	! !

!AbstractMorphicView methodsFor: 'override-in-subclass' stamp: 'skrish 5/29/2012 23:22'!
postCreateInitialize
" should invoke super postCreateInitialize in subclasses for mouse  event listener at view level"
	self primaryWindow activeHand addMouseListener: self.
 	^ self! !

!AbstractMorphicView methodsFor: 'user interface' stamp: 'Skrish 8/23/2012 23:32'!
postCreateOpen
"actually open the view in world or another morph"
	worldOrMorphOwner ifNil: [ 
		worldOrMorphOwner := self currentWorld].
     self postCreateOpen:  worldOrMorphOwner! !

!AbstractMorphicView methodsFor: 'user interface' stamp: 'Skrish 8/23/2012 23:32'!
postCreateOpen: aMorph
"actually open the view in morph"
	aMorph isWorldMorph ifFalse: [ ^aMorph layoutPolicy: ProportionalLayout new ; addMorph: primaryWindow].
     primaryWindow owner ifNil: [
	(primaryWindow isKindOf: SystemWindow )
		ifTrue: [ primaryWindow  openAsIsIn: aMorph ]
		ifFalse: [ primaryWindow openInWorld ]].! !

!AbstractMorphicView methodsFor: 'internal processing' stamp: 'Skrish 8/25/2012 11:37'!
postOpen

	self resetTextFieldsMorphBounds.	
	self setAllToDefaultViewFont.	
	self hackSettingWindowColorToNewTheme.				
	self setWindowSpecs. "hack to call this again after open to reset bounds / other specs"
	self setMenu .	
	self primaryWindow isSystemWindow ifTrue: [ self primaryWindow restoreAndActivate	]
	! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skr 1/9/2012 11:56'!
primaryWindow

 ^primaryWindow! !

!AbstractMorphicView methodsFor: 'internal processing' stamp: 'Skrish 7/31/2012 00:36'!
recurseSpec: specsColl vars: varsColl
	
	specsColl do: [ :eaSpec |  | widget |
	((eaSpec key beginsWith: 'row' ) | (eaSpec key beginsWith: 'col' ) and: [ eaSpec value isSymbol not ] )
				ifTrue: [ self recurseSpec:  eaSpec value vars: varsColl]
				ifFalse: [ 
					widget := (MorphicViewValueWrapper morphFrom: eaSpec value).
					((widget isKindOf: LabelMorph ) or: [ widget isKindOf: PluggableButtonMorph ])
						ifFalse: [varsColl add: eaSpec key ] ]
				]! !

!AbstractMorphicView methodsFor: 'events' stamp: 'Skrish 9/3/2012 09:28'!
registerKeyboardShortcuts
"register key shortcuts here on the MorphicView: use the #keyEventInfoArray for the registeration"
	self keyEventInfoArray
		do: [:eaArray | 
			| evt |
			evt := KeyboardEvent new
						setType: #keystroke
						buttons: eaArray first
						position: nil
						keyValue: (eaArray at: 2) charCode
						hand: (eaArray at: 3)
						stamp: nil.
			self eventHandler ifNotNil: [ :ev | ev registerEventAtKey: eaArray second charCode event: {evt. eaArray last}]]! !

!AbstractMorphicView methodsFor: 'internal processing' stamp: 'Skrish 8/27/2012 22:23'!
resetPanelView 
"using the same view instance.. you need to first reset the view.."

	morphsDictionary := nil.
	panelWindow 
			ifNotNil: [ :p | p delete. ].
	panelWindow := AlignmentMorph new.! !

!AbstractMorphicView methodsFor: 'default-settings' stamp: 'Skrish 8/14/2012 19:32'!
resetTextFieldsMorphBounds
	" hack to ensure the TextFieldMorph inside is of the same bounds as the TextMorph"
	
	 ( morphsDictionary values select: [ :ea | (ea  isKindOf: PluggableTextMorph )])
		do: [:eaMorph | eaMorph resetTextBounds ]! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 2/14/2012 08:57'!
resizing

	^resizing ifNil: [ #spaceFill]! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 2/14/2012 08:54'!
resizing: resizeSymbol

	resizing := resizeSymbol! !

!AbstractMorphicView methodsFor: 'default-settings' stamp: 'Skrish 8/14/2012 13:25'!
setAllLabelMorphsRigidHorizontal
	(morphsDictionary values select: [ :ea | 
		(ea isKindOf: LabelMorph  )])
			do: [:eaMorph | eaMorph extent:  120@16 . eaMorph vResizing: #rigid. eaMorph hResizing: #rigid ] ! !

!AbstractMorphicView methodsFor: 'default-settings' stamp: 'Skrish 8/14/2012 13:04'!
setAllMorphsDefaultSpecs

	(self allMorphsDefaultSpecs select: [ :e | 
			(e isKindOf: PluggableButtonMorph )not])	
		do: [ :eaAssoc |
			morphsDictionary keysAndValuesDo: [ :key :val | 
				( val  respondsTo: eaAssoc key)
					ifTrue: [ val perform: eaAssoc  key withArguments: (eaAssoc value value: key-> val )] ].
		].
! !

!AbstractMorphicView methodsFor: 'default-settings' stamp: 'Skrish 7/13/2012 12:33'!
setAllMorphsToResizeOrWrap: spaceFillOrShrinkWrap 
	(morphsDictionary values select: [ :ea | 
		(ea isKindOf: PluggableButtonMorph )not])
			do: [:eaMorph | eaMorph hResizing: spaceFillOrShrinkWrap;
				 vResizing: spaceFillOrShrinkWrap]! !

!AbstractMorphicView methodsFor: 'default-settings' stamp: 'Skrish 7/13/2012 22:33'!
setAllToDefaultViewFont
     true ifTrue: [ ^self].
	(morphsDictionary values
		select: [:e | e respondsTo: #morph])
		do: [:ea | (ea morph respondsTo: #font:)
				ifTrue: [ ea
						font: (self class guiConstants at: 'defaultViewFont')]]! !

!AbstractMorphicView methodsFor: 'internal processing' stamp: 'Skrish 9/3/2012 09:53'!
setMenu
"if the menu is specified already by #createMenuArray, this will set the menu to the window only for StandardWindow type.. "
		windowType = #StandardWindow 
		ifTrue: [	
				self createMenuArray ifNotEmpty: 
					[primaryWindow addMorph: (self buildMenuBarMorph layoutFrame: ( LayoutFrame fractions: ( 0.01@0 corner: 0.99@0) offsets: (0@1 corner: 0@30)))] ].! !

!AbstractMorphicView methodsFor: 'internal processing' stamp: 'Skrish 7/29/2012 22:37'!
setMorphsPrimaryProperties
	"self shouldNotOverride.. typically expect the specs to be overriden
	does a check on selector args matching the args array size"
	self morphsPrimaryPropertiesSpecs
		do: [:eaAssoc | 
			self validateArgsArray: eaAssoc value.
			[( panels at: eaAssoc key ifAbsent: []) 
				ifNil: [
			(morphsDictionary at: eaAssoc key)
				perform: eaAssoc value key
				withArguments: eaAssoc value value]
				ifNotNil: [
			(panels at: eaAssoc key)
				perform: eaAssoc value key
				withArguments: eaAssoc value value	
					] ] on: Error do: [ :ex| Transcript show: ex description " ignore for now.."] ]  ! !

!AbstractMorphicView methodsFor: 'internal processing' stamp: 'Skrish 8/15/2012 21:34'!
setMorphsSecondaryProperties
	"set the secondary properties of color, extents, etc.. any others as
	required per morph	does a check on selector args matching the args array size"

	self setAllMorphsDefaultSpecs.
	self setAllLabelMorphsRigidHorizontal.
	self morphsSecondaryPropertiesSpecs
		do: [:eaAssoc | eaAssoc value
				do: [:eachSelectorArgsAssoc | 
					self validateArgsArray: eachSelectorArgsAssoc.
					[(morphsDictionary at: eaAssoc key)
						perform: eachSelectorArgsAssoc key
						withArguments: eachSelectorArgsAssoc value] on: Error do: [ :ex | ] ]]! !

!AbstractMorphicView methodsFor: 'default-settings' stamp: 'Skrish 8/25/2012 11:53'!
setNoDialogButtons 
"For Dialogs the default buttons are reset"

	( self createPrimaryWindow primaryWindow class instVarNames  
		detect: [ :ea | ea = #buttons ] ifNone: [])
			ifNotNil: [ primaryWindow instVarNamed: #buttons put: {} ]! !

!AbstractMorphicView methodsFor: 'internal processing' stamp: 'skrish 5/19/2012 19:50'!
setViewBounds
"This is a hack.. to set proper bounds before addMorph:fullFrame: call.. should fix it in there to get it right..?"
	(useDefaultBounds or: [ primaryWindow  extent > Display extent ]) 
		ifTrue: [ primaryWindow bounds: self bounds]
		ifFalse: [ primaryWindow bounds: (self fixPrimaryWindowBounds) .
			 primaryWindow hResizing: #spaceFill ; vResizing: #spaceFill].
! !

!AbstractMorphicView methodsFor: 'internal processing' stamp: 'Skrish 9/2/2012 10:21'!
setWindowSpecs
	
	primaryWindow ifNotNil: [
			(primaryWindow isKindOf: SystemWindow )
					ifTrue: [ primaryWindow setLabel: self windowTitle ]].
	self performSpecMessages: self windowSpecs.
! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 2/11/2012 14:14'!
useDefaultBounds: bool

	useDefaultBounds := bool! !

!AbstractMorphicView methodsFor: 'validate' stamp: 'skrish 1/17/2012 01:14'!
validateArgsArray: eachSelectorArgsAssoc

	eachSelectorArgsAssoc key numArgs = eachSelectorArgsAssoc value size 
		ifFalse: [
			^self error: 'selectors number of arguments do not match values array' ].! !

!AbstractMorphicView methodsFor: 'validate' stamp: 'skrish 2/23/2012 07:03'!
validateLayoutSpecFrame: aFrame for: morphOrViewSymbol
	"check that the corner x > origin x and corner y > origin y
	can later add other validations to avoid silly mistakes ppl can commit in layouts.. viz: check on intersecting origin/corner.."
	| extent |
	extent := aFrame minExtentFrom: 1800 @ 1400.
	(extent x < 0
			or: [extent y < 0])
		ifTrue: [self error: ( 'Layout specs corner < origin : <1s>' getLocaleString expandMacrosWith: morphOrViewSymbol) ]! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 5/20/2012 21:40'!
valueForId: morphId

^(morphsDictionary at: morphId ifAbsent:[])
    ifNotNil:  [ :morph | 
		[ morph value notNil ] on: Error do: [:ex | ex return: nil].
		 morph value]! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 2/13/2012 13:08'!
valueWrapperClass

	^valueWrapperClass ifNil:  [MorphicViewValueWrapper ]! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 2/13/2012 13:08'!
valueWrapperClass: aValueWrapperClass

	valueWrapperClass := aValueWrapperClass! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 3/18/2012 23:45'!
viewController
	^viewController! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 1/29/2012 12:33'!
viewController: aController 
	"Controller or the presenter..? has a model and we set the view with
	the pair"
	viewController := aController. 
	" set our SupervisingController with the view to allow for direct interaction if reqd"
	viewController view: self.! !

!AbstractMorphicView methodsFor: 'validate' stamp: 'skrish 1/29/2012 10:51'!
viewIsTopWindow: eventPosition 
	"either I am the top window or my owner is the top window: give
	precendence to the internal panels.."
	| win |
	win := self primaryWindow.
	^ (((win owner isKindOf: AbstractMorphicView)
				and: [win owner primaryWindow = SystemWindow topWindow])
			or: [win = SystemWindow topWindow])
		and: [win bounds containsPoint: eventPosition]! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 3/18/2012 20:38'!
viewModel
	
	^viewModel! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 3/18/2012 23:04'!
viewModel:  aModel 
	"set the controller model too.."
	viewModel := aModel. 
	" set our SupervisingController with the view model: 
	viewController should be set first "
	viewController ifNotNil: [
		viewController controllerModel:  aModel].
	viewModel addDependent: self.! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'Skrish 7/11/2012 09:27'!
viewParser

	^AbstractMorphicViewParser named: 'View.singleton'! !

!AbstractMorphicView methodsFor: 'override-in-subclass' stamp: 'Skrish 8/21/2012 21:05'!
windowSpecs

	^{
	#useDefaultOKCancelButton -> {}  }! !

!AbstractMorphicView methodsFor: 'override-in-subclass' stamp: 'Skrish 9/2/2012 10:21'!
windowTitle
"Always expected to be overridden in subclasses"

	^ (windowTitle ifNil: [self class name ]) getLocaleString! !

!AbstractMorphicView methodsFor: 'override-in-subclass' stamp: 'Skrish 9/2/2012 10:17'!
windowTitle: aTitle
"Always expected to be overridden in subclasses"

	windowTitle := aTitle! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'Skrish 8/12/2012 09:57'!
windowType

	^windowType ! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'skrish 6/19/2012 09:19'!
windowType: aType
"ref #createPrimaryWindow for all supported windowTypes"
	windowType := aType ! !

!AbstractMorphicView methodsFor: 'accessing' stamp: 'Skrish 8/14/2012 07:56'!
worldOrMorphOwner: aWorldOrMorph

	worldOrMorphOwner := aWorldOrMorph  ! !

AbstractMorphicView subclass: #AbstractSimpleMorphicView
	instanceVariableNames: 'panelType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App'!

!AbstractSimpleMorphicView commentStamp: 'skrish 1/29/2012 20:32' prior: 0!
An AbstractSimpleMorphicView is simplified interface to provide for TableLayout aka a flow layout...

Instance Variables
	panelType:		<Object>

panelType
	- xxxxx
!

!AbstractSimpleMorphicView methodsFor: 'subclass responsibility' stamp: 'Skrish 8/13/2012 17:04'!
composePanelWindow
	"compose the morphs into the primaryWindow as is with
	morphsDictionary or with further composition in complex layout.
	Should override this method and compose with #newRow: and
	#newColumn: #newLabelGroup: etc ... look through
	ExampleBuilderMorph methods as required..
	"
	| orderedMorphs| 
	panelWindow := self panelWindow layoutPolicy: ( TableLayout new ).
	panelWindow color: Color transparent.
	useDefaultBounds ifTrue: [ panelWindow bounds: self bounds].
	panelWindow  hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	self panelType = #newColumn
		ifTrue: [panelWindow listDirection: #topToBottom;  cellInset: 10 ; cellPositioning:  #topLeft].
	self panelType = #newRow
		ifTrue: [panelWindow listDirection: #leftToRight; wrapCentering: #topLeft].
	orderedMorphs := self reorderMorphDictionary. 
	panelWindow  submorphs ifNotEmpty: [ :sm | panelWindow removeAllMorphsIn:  orderedMorphs ]. " hack for now.. in case we are reusing the panel"	
	panelWindow addAllMorphs: orderedMorphs ! !

!AbstractSimpleMorphicView methodsFor: 'user interface' stamp: 'Skrish 8/15/2012 21:37'!
createMorphsDictionary

	morphsDictionary 
		ifNil: [ morphsDictionary := Dictionary new].
	morphsDictionary notEmpty ifTrue:  [  ^morphsDictionary ].
	self createMorphsSpecs 
		do: [:eaAssoc | 
			|  morphs panel |
			( ('row*' match: eaAssoc key) or: [ 'col*' match: eaAssoc key  ] )
				ifTrue: [self createRowOrColPanel: eaAssoc]
			       ifFalse: [self insertWidgetInMorphsDictionary: eaAssoc] ]! !

!AbstractSimpleMorphicView methodsFor: 'subclass responsibility' stamp: 'skrish 2/15/2012 11:05'!
createMorphsSpecs
	"^{
	 #row ->  {
	'label1' -> #LabelMorph.
	'text1' -> #PluggableTextMorph }.
	#col ->  {  
	'label1' -> #LabelMorph.
	'text1' -> #PluggableTextMorph }.	
	'button1' ->#PluggableButtonMorph.
	} ."
	
	^self subclassResponsibility 
	! !

!AbstractSimpleMorphicView methodsFor: 'user interface' stamp: 'Skrish 8/15/2012 21:52'!
createRowOrColMorphsFromSpecs: assocMorphNameKeyValue 
	
 	^assocMorphNameKeyValue collect: [ :ea | | m  p| 
				( ('row*' match: ea key) or: [ 'col*' match: ea key  ] )
				ifTrue: [ p := self createRowOrColPanel: ea .
						panels at: ea key put: p.
						self valueWrapperClass basicNew morph: p]
				ifFalse: [
				m := self valueWrapperClass morphFrom: ea value.
				(self  class instVarNames includes:  ea key asString)
					ifTrue: [ self instVarNamed: ea key asString put: m  ].					
				(m morph isKindOf: LabelMorph ) 
					ifTrue: [ m contents: ea key]. 
					m] ] .	! !

!AbstractSimpleMorphicView methodsFor: 'user interface' stamp: 'Skrish 8/15/2012 21:55'!
createRowOrColPanel: associationOfKeyAndMorphsArray

	| eaAssoc morphs panel aResizeSymbol assocMorphNameKeyValue morphsColl |

	eaAssoc := associationOfKeyAndMorphsArray.	
	eaAssoc value first key = #resizing
		ifTrue: [ aResizeSymbol := eaAssoc value first value]
		ifFalse: [ aResizeSymbol := #spaceFill].
	assocMorphNameKeyValue := eaAssoc value select: [ :ea | ea key ~= #resizing].
	morphs := self createRowOrColMorphsFromSpecs: assocMorphNameKeyValue .
	morphsColl :=  morphs collect: [ :ea | 
		(ea morph isKindOf: AbstractMorphicView )
			ifTrue: [ ea createPrimaryView ; panelWindow]
			ifFalse: [ea morph] ].
		
	panel := self newRowOrColumn: eaAssoc key for: morphsColl resize: aResizeSymbol.	
	( morphsDictionary ifNil: [ morphsDictionary := Dictionary new] )  at: eaAssoc key put: panel.
	
	self setMorphsOrPanelDictionaries: assocMorphNameKeyValue with: morphs .
	
	^panel.! !

!AbstractSimpleMorphicView methodsFor: 'subclass responsibility' stamp: 'skrish 1/12/2012 09:57'!
layoutSpecs
"In this SimpleMorphicView, conceptually we do not need LayoutFrame, just the extents and the TableLayout flows from #composeMorph
but if you need to override this in subclass to set the extents of the widgets. But DO NOT use extent and LayoutFrame together in the same View"! !

!AbstractSimpleMorphicView methodsFor: 'subclass responsibility' stamp: 'Skrish 8/15/2012 21:35'!
morphsSecondaryPropertiesSpecs

	^{ }! !

!AbstractSimpleMorphicView methodsFor: 'user interface' stamp: 'skrish 3/2/2012 23:45'!
newRowOrColumn: rowOrCol for: controls resize: aResizeSymbol
	"Answer a morph laid out with a row of controls."

	| aMorph  |
	aMorph := PanelMorph new
		hResizing: aResizeSymbol;
		vResizing: aResizeSymbol;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		cellPositioning: #center.
		
	('row*' match: rowOrCol  )
		ifTrue: [ aMorph listDirection: #leftToRight]
		ifFalse: [ aMorph listDirection: #topToBottom].
		
	controls do: [:m | 
		(m isKindOf: AbstractMorphicView )
			ifTrue: [ aMorph addMorphBack: m createPrimaryView ; panelWindow  ]
			ifFalse: [ aMorph addMorphBack: m]].
	aMorph fullBounds.
	^aMorph
			! !

!AbstractSimpleMorphicView methodsFor: 'accessing' stamp: 'Skrish 1/18/2012 08:32'!
panelType
	^ panelType
		ifNil: [#newColumn]! !

!AbstractSimpleMorphicView methodsFor: 'accessing' stamp: 'Skrish 1/18/2012 08:31'!
panelType: columnOrRow
" is it newColumn: or a newRow: "

	panelType := columnOrRow! !

!AbstractSimpleMorphicView methodsFor: 'user interface' stamp: 'Skrish 7/13/2012 23:09'!
postCreateInitialize
" Labels in button morphs bring in alignment morphs that do not allow using bounds/ extents thereafter"
	
	morphsDictionary values do: [ :eaMorph | |ext |

			( eaMorph isKindOf: PluggableButtonMorph)
				ifTrue: [
					"currently nothing fixes this problem.. need to find a solution here if not generically to ensure labels and extents are honored properly"
					 eaMorph submorphs  ifNotEmpty: [:mphs | mphs first bounds: eaMorph bounds]  ].
				].
			

	! !

!AbstractSimpleMorphicView methodsFor: 'user interface' stamp: 'Skrish 8/25/2012 12:42'!
reorderMorphDictionary
	| orderedMorphs |
	orderedMorphs := OrderedCollection  new.
	self createMorphsSpecs do: [ :eaAssoc | | mh |
		mh := morphsDictionary at: eaAssoc key ifAbsent: [ panels at: eaAssoc key ifAbsent: []] .
	     mh ifNotNil: [
		orderedMorphs add: ( 
			(self isValueWrapper: mh)
				ifTrue: [ mh morph ]
				ifFalse: [ mh ]  )]].
	^orderedMorphs
	 ! !

!AbstractSimpleMorphicView methodsFor: 'user interface' stamp: 'Skrish 8/15/2012 21:55'!
setMorphsOrPanelDictionaries: assocMorphNameKeyValue with: morphs 
	
 assocMorphNameKeyValue with: morphs do: [ :ea  :m | 
		panels ifNil: [ panels := Dictionary new].
		(self  class instVarNames includes:  ea key asString)
			ifTrue: [ self instVarNamed: ea key asString put: m morph ].		
		(m morph isKindOf: AbstractMorphicView )
			ifTrue: [ panels at: ea key put: m ]
			ifFalse: [ morphsDictionary at: ea key put: m]
			].! !

AbstractSimpleMorphicView subclass: #LabelAndTextFieldViewMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-Widgets'!

!LabelAndTextFieldViewMorph class methodsFor: 'constants' stamp: 'skrish 5/29/2012 22:35'!
guiConstants
	| guiConstants offset |
	
     ^super guiConstants
		at: 'thisViewBounds'
		ifAbsentPut: ( 200@200 corner: ( 600@600));		
	yourself! !

!LabelAndTextFieldViewMorph methodsFor: 'subclass responsibility' stamp: 'skrish 5/29/2012 23:36'!
createMorphsSpecs
"Specify the pair of id and morph class or just Label , Text, TextField, Button, DropList, AlphaImage by stripping 'Pluggable' / 'Morph' "
	^{
	#row1 -> {
		'label' -> #LabelMorph.
		'spacer' -> #PanelMorph .
		'textFld' -> #TextField
		}
	}! !

!LabelAndTextFieldViewMorph methodsFor: 'init' stamp: 'skrish 5/29/2012 23:40'!
initialize 

	super initialize.
	windowType := #Window. 
! !

!LabelAndTextFieldViewMorph methodsFor: 'user interface' stamp: 'Skrish 7/13/2012 19:33'!
label: aString

	self labelAttributeAt: #contents: put: aString.! !

!LabelAndTextFieldViewMorph methodsFor: 'user interface' stamp: 'skrish 5/30/2012 01:12'!
labelAttributeAt: aSymbol put: aValue

	(morphsDictionary at: #label ) perform: aSymbol withArguments:  aValue ! !

!LabelAndTextFieldViewMorph methodsFor: 'subclass responsibility' stamp: 'skrish 5/29/2012 22:36'!
morphsPrimaryPropertiesSpecs
	"set the primary action/ model attributes with #on:** method to the morphs specially the widgets that require model linked selector invocations"
	"^{
	'text1' -> ( #on:text:accept:readSelection:menu: -> { viewModel. #text1. #text1: . nil. nil  }).
	}
	"
	super morphsPrimaryPropertiesSpecs .
	^{
	'textFld' -> ( #on:text:accept:readSelection:menu: ->  { self. nil.  nil.  nil.  nil.   } ). 

	}! !

!LabelAndTextFieldViewMorph methodsFor: 'subclass responsibility' stamp: 'skrish 5/31/2012 10:55'!
morphsSecondaryPropertiesSpecs
	"set the secondary properties of color, extents, etc.. any others as required per morph"
	
	super morphsSecondaryPropertiesSpecs .
	^{
	'label'-> { 
		#hResizing: -> { #spaceFill}.
		#contents: -> { 'Label1' getLocaleString }. 
		#font: -> {StandardFonts defaultFont emphasis: 2}.
	}.
	'spacer' -> {
		#extent: -> { 10@30}.
		#hResizing: -> { #rigid}.
	}.
	'textFld' -> { 
	" replace with method - args assoc"   } . 

	}! !

!LabelAndTextFieldViewMorph methodsFor: 'user interface' stamp: 'skrish 5/29/2012 22:47'!
on: model text: getTextSel accept: setTextSel readSelection: readTextSel menu: menu

	( morphsDictionary at: 'textFld') on: model text: getTextSel accept: setTextSel readSelection: readTextSel menu: menu
! !

!LabelAndTextFieldViewMorph methodsFor: 'override-in-subclass' stamp: 'skrish 5/29/2012 22:35'!
postOpen

	primaryWindow bounds: (self class guiConstants at: 'thisViewBounds')! !

!LabelAndTextFieldViewMorph methodsFor: 'user interface' stamp: 'skrish 5/30/2012 01:24'!
textFieldAttributeAt: aSymbol put: aValue

	(morphsDictionary at: #textFld ) perform: aSymbol withArguments:  aValue ! !

!LabelAndTextFieldViewMorph methodsFor: 'user interface' stamp: 'skrish 5/30/2012 01:25'!
value

	^(morphsDictionary at: #textFld ) value! !

!LabelAndTextFieldViewMorph methodsFor: 'user interface' stamp: 'skrish 5/30/2012 01:25'!
value: aValue

	(morphsDictionary at: #textFld ) value: aValue! !

!LabelAndTextFieldViewMorph methodsFor: 'override-in-subclass' stamp: 'skrish 5/29/2012 22:35'!
windowTitle

	^'Sample Window' getLocaleString! !

AbstractSimpleMorphicView subclass: #MultiSelectListWidget
	instanceVariableNames: 'choiceList selectedItems listSelections selectedIndex answer aTitle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-Widgets'!

!MultiSelectListWidget commentStamp: 'Skrish 8/15/2012 08:15' prior: 0!
A compund widget that allows multi select in combination with add/ remove from the list as a dialog view

Class intention
	A compound morph as a view class

Class collaborations
	I usually do not work in isolation but with the help of ...

Class main API
	My main public API is ...My subclasses may want to override such specific hooks ...
Implementation notes
!

!MultiSelectListWidget class methodsFor: 'constants' stamp: 'skrish 5/21/2012 14:05'!
guiConstants
	| guiConstants offset |
	
     ^super guiConstants
		at: 'thisViewBounds'
		ifAbsentPut: ( 200@200 corner: ( 600@600));		
	yourself! !

!MultiSelectListWidget methodsFor: 'actions' stamp: 'skrish 5/21/2012 15:28'!
addToListBtnAction
	| val  listWidget|

	val := (self valueForId: 'addToListText') asString.
	val isEmptyOrNil 
		ifTrue: [ ^self ].
	listWidget := (self morphsDictionary at: 'multiList' ) .
	choiceList := ( listWidget getList asOrderedCollection add: val ; yourself ).
	listWidget updateList.! !

!MultiSelectListWidget methodsFor: 'actions' stamp: 'skrish 5/27/2012 11:13'!
answer
	^answer! !

!MultiSelectListWidget methodsFor: 'subclass responsibility' stamp: 'skrish 5/27/2012 11:17'!
createMorphsSpecs
"Specify the pair of id and morph class or just Label , Text, TextField, Button, DropList, AlphaImage by stripping 'Pluggable' / 'Morph' "
	^{
	'multiList' -> #List.
	#rowAddToList -> { 
		'addToListText' -> #TextField. 
		'addToListBtn' -> #Button
	}.  
	}! !

!MultiSelectListWidget methodsFor: 'accessing' stamp: 'skrish 5/27/2012 10:49'!
getList

	listSelections := Array new: choiceList size withAll: false.
	^choiceList ! !

!MultiSelectListWidget methodsFor: 'accessing' stamp: 'skrish 5/27/2012 11:01'!
getSelectedItem
	
	^selectedIndex ! !

!MultiSelectListWidget methodsFor: 'init' stamp: 'Skrish 8/24/2012 10:47'!
initialize 

	super initialize.
	windowType := #Dialog. 
	choiceList := { 'def' }.
	selectedIndex := 0.
	listSelections := Array new: choiceList size withAll: false.
	bounds := ( 0@0 corner: 400@250).
	useDefaultBounds := true.
	defaultDialogButtons := #OK.
	self setNoDialogButtons .
	"self okBtnActionBlock: [ self okBtnAction ]."
	"replace ...Controller / ...Model  with the name of generated Controller/ Model class"
	"self viewController: ...Controller new.
	 self viewModel: ..Model new."! !

!MultiSelectListWidget methodsFor: 'accessing' stamp: 'skrish 6/21/2012 09:38'!
itemSelected: itemIndex
	
	| menu |
	itemIndex = 0 ifTrue: [ ^self].
	selectedIndex := itemIndex .
	listSelections at: itemIndex put: true.
	^choiceList at: itemIndex! !

!MultiSelectListWidget methodsFor: 'init' stamp: 'skrish 5/27/2012 11:18'!
list: aList

	choiceList := aList! !

!MultiSelectListWidget methodsFor: 'accessing' stamp: 'skrish 5/27/2012 11:02'!
listSelectionAt: indx

	^listSelections at: indx! !

!MultiSelectListWidget methodsFor: 'accessing' stamp: 'skrish 5/27/2012 11:02'!
listSelectionAt: indx put: aVal

	listSelections at: indx put: aVal! !

!MultiSelectListWidget methodsFor: 'subclass responsibility' stamp: 'skrish 6/21/2012 09:42'!
morphsPrimaryPropertiesSpecs
	"set the primary action/ model attributes with #on:** method to the morphs specially the widgets that require model linked selector invocations"
	"^{
	'text1' -> ( #on:text:accept:readSelection:menu: -> { viewModel. #text1. #text1: . nil. nil  }).
	}
	"
	super morphsPrimaryPropertiesSpecs .
	^{
	'addToListBtn' -> ( #on:getState:action:label:menu: ->  { self. nil.  #addToListBtnAction.  nil.  nil.   } ).
	'multiList' -> ( #on:list:primarySelection:changePrimarySelection:listSelection:changeListSelection:menu:keystroke: ->  { self. #getList.  #getSelectedItem.  #itemSelected: .  #listSelectionAt:.  #listSelectionAt:put:. #popUpMenu: .nil   } ). 
	'addToListText' -> ( #on:text:accept:readSelection:menu: ->  { self. nil.  nil.  nil.  nil.   } ).
	}! !

!MultiSelectListWidget methodsFor: 'subclass responsibility' stamp: 'skrish 5/27/2012 11:17'!
morphsSecondaryPropertiesSpecs
	"set the secondary properties of color, extents, etc.. any others as required per morph"
	
	super morphsSecondaryPropertiesSpecs .
	^{
	'rowAddToList' -> { 
	" replace with method - args assoc"   } . 
	'multiList' -> {	
	#hResizing: -> {  #spaceFill}.
	" replace with method - args assoc"   } . 
	'addToListText' -> { 
	#hResizing: -> {  #spaceFill}.
	" replace with method - args assoc"   } . 
	'addToListBtn' -> { 
	#label: -> { 'Add'}.
	" replace with method - args assoc"   } . 
	'addToListText' -> { 
	" replace with method - args assoc"   } . 

	}! !

!MultiSelectListWidget methodsFor: 'actions' stamp: 'skrish 6/21/2012 09:53'!
okBtnAction

	| aColl |
	aColl := OrderedCollection new.
	listSelections 
		doWithIndex: [ :ea :idx |
			ea ifTrue: [	aColl add: (choiceList at: idx )]
			].
	self close.
	answer := aColl! !

!MultiSelectListWidget methodsFor: 'nil' stamp: 'skrish 6/21/2012 09:40'!
popUpMenu


	| menu itemIndex |
	menu := MenuMorph new.
	itemIndex := choiceList indexOf: self getSelectedItem.
	menu add: 'Delete' target: [ choiceList removeAt: itemIndex ] selector: #value .
      menu popUpInWorld .
	( morphsDictionary at: 'multiList') updateList! !

!MultiSelectListWidget methodsFor: 'as yet unclassified' stamp: 'skrish 6/21/2012 09:48'!
popUpMenu: menu


	menu add: 'Delete' target:  self   selector: #removeCurrentSelection .
	^menu
	! !

!MultiSelectListWidget methodsFor: 'override-in-subclass' stamp: 'skrish 5/21/2012 14:05'!
postOpen

	primaryWindow bounds: (self class guiConstants at: 'thisViewBounds')! !

!MultiSelectListWidget methodsFor: 'as yet unclassified' stamp: 'skrish 6/21/2012 09:48'!
removeCurrentSelection

	choiceList removeAt: self getSelectedItem .
	(self morphsDictionary at: 'multiList') updateList.
! !

!MultiSelectListWidget methodsFor: 'override-in-subclass' stamp: 'Skrish 8/24/2012 10:45'!
windowSpecs 

	^{}! !

!MultiSelectListWidget methodsFor: 'override-in-subclass' stamp: 'skrish 6/20/2012 08:52'!
windowTitle

	^(aTitle ifNil:  ['']) getLocaleString! !

!MultiSelectListWidget methodsFor: 'accessing' stamp: 'skrish 5/27/2012 11:23'!
windowTitle: aLabel

	aTitle := aLabel ! !

AbstractSimpleMorphicView subclass: #ProportionalComposedView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Examples'!

!ProportionalComposedView methodsFor: 'user-interface' stamp: 'Skrish 2/26/2013 10:50'!
createMorphsSpecs
	"self open	"

	^ {('Panel1' -> #ProportionalPanelOne).
	('Panel2' -> #ProportionalPanelTwo).
	('Panel3' -> #ProportionalPanelThree)}! !

!ProportionalComposedView methodsFor: 'user-interface' stamp: 'skrish 2/15/2012 00:29'!
initialize
" self open "
	super initialize.
	self bounds: (20@20 corner: 1024@740).
	self useDefaultBounds: true.
	windowType := #Window.
	panelType := #newRow.! !

!ProportionalComposedView methodsFor: 'user-interface' stamp: 'pooja 2/8/2012 11:34'!
morphsPrimaryPropertiesSpecs

super morphsPrimaryPropertiesSpecs.
^{}.! !

!ProportionalComposedView methodsFor: 'user-interface' stamp: 'pooja 2/8/2012 11:34'!
morphsSecondaryPropertiesSpecs

super morphsSecondaryPropertiesSpecs .
^{}.! !

!ProportionalComposedView methodsFor: 'user-interface' stamp: 'Skrish 8/25/2012 11:16'!
windowSpecs

	^{
		#bounds: -> {75@10 corner: 1200@740}
		}! !

AbstractSimpleMorphicView subclass: #RadioButtonGroup
	instanceVariableNames: 'labelsList radioSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Examples'!

!RadioButtonGroup commentStamp: '<historical>' prior: 0!
A RadioButtonGroup is a group for radio buttons which ensure that only radio button of this group is activated at the same time.!

!RadioButtonGroup methodsFor: 'protocol' stamp: ''!
addRadioButton: aButton

	buttons do: [:b | 
		aButton whenActivatedDo: [ b privateSetState: false ].
		b whenActivatedDo: [ aButton privateSetState: false ]].
		
	buttons add: aButton.
	aButton privateSetState: false! !

!RadioButtonGroup methodsFor: 'user-interface' stamp: 'skrish 2/12/2012 01:30'!
createMorphsSpecs
"(self new list: { 'one' . 'two' . 'three'}) open"
	| specsArray |
	specsArray := OrderedCollection new.
	self list do: [ :ea |
			specsArray add: ( Association key: ea value: #RadioButtonMorph )
			].
		
	^specsArray! !

!RadioButtonGroup methodsFor: 'protocol' stamp: ''!
default: aButton

	aButton privateSetState: true.
	aButton takeKeyboardFocus.! !

!RadioButtonGroup methodsFor: 'initialization' stamp: 'skrish 2/12/2012 01:30'!
initialize

	super initialize .
	self bounds: ( 20@20 corner: 300@50).
	self useDefaultBounds: true.
	windowType := #Morph.
	panelType := #newRow.
	viewModel := ExampleRadioButtonModel new! !

!RadioButtonGroup methodsFor: 'accessing' stamp: 'skrish 2/7/2012 18:46'!
isSelected: aMorph

	radioSelection ifNil: [ ^false].
	^radioSelection = aMorph
	! !

!RadioButtonGroup methodsFor: 'user-interface' stamp: 'skrish 2/9/2012 16:48'!
list

	^labelsList ifNil: [ 
			{ 'one' }
			]! !

!RadioButtonGroup methodsFor: 'user-interface' stamp: 'skrish 3/8/2012 23:24'!
list: aLabelsList

	| pwOwner pos |
	labelsList := aLabelsList.
	panelWindow ifNotNil: [ 
		morphsDictionary := Dictionary new.
		pwOwner := panelWindow owner.
		pos := pwOwner submorphs indexOf: panelWindow .
		panelWindow removeAllMorphs.
		self createPrimaryView.
		 pwOwner privateAddMorph: panelWindow atIndex: pos .
		]
! !

!RadioButtonGroup methodsFor: 'user-interface' stamp: 'skrish 2/9/2012 16:45'!
morphsPrimaryPropertiesSpecs 

	| anArray |
	anArray := OrderedCollection new.
	super morphsPrimaryPropertiesSpecs .

	self list do: [ :ea | 
	anArray add: ( Association key: ea value: ( #on:selected:changeSelected: -> {self . #isSelected:  .  #radioSelection: } ) ).
		].
	
	^anArray! !

!RadioButtonGroup methodsFor: 'user-interface' stamp: 'skrish 2/9/2012 16:45'!
morphsSecondaryPropertiesSpecs 

	| anArray |
	anArray := OrderedCollection new.
	super morphsSecondaryPropertiesSpecs .
	self list do: [ :ea |
			anArray add: ( Association key: ea value: (
							Array 	with: (#label: -> (Array with:  ea ) ) 
									with: (#enabled: -> {true}) ) )
			].
		
	^anArray! !

!RadioButtonGroup methodsFor: 'accessing' stamp: 'skrish 3/18/2012 21:37'!
radioSelection: radioMorph 
	radioSelection := radioMorph.
	(morphsDictionary values asOrderedCollection remove: radioMorph ifAbsent: []; yourself  ) do: [ :ea |
			ea buttonMorph selected: false].
	! !

!RadioButtonGroup methodsFor: 'accessing' stamp: 'skrish 5/27/2012 10:21'!
radioSelectionIndex:  anIndex

	| list radioMorph |
	anIndex > labelsList size
		ifTrue: [ ^self  ].
	radioSelection := morphsDictionary at: ( labelsList at: anIndex).
	radioSelection selected: true.
	(morphsDictionary values asOrderedCollection remove: radioSelection ifAbsent: []; yourself  ) do: [ :ea |
			ea buttonMorph selected: false].
	! !

!RadioButtonGroup methodsFor: 'accessing' stamp: 'skrish 2/7/2012 18:56'!
selectedRadio

	^radioSelection! !

AbstractSimpleMorphicView subclass: #SimpleImplicitMorphicView
	instanceVariableNames: 'specsArray morphsPrimarySpecs morphsSecondarySpecs panelViewInitializeSpecs viewName viewCategory viewSpecs primaryWindowSpecs windowSpecs resizeOrWrap menuArray allMorphsDefaultSpecs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App'!

SimpleImplicitMorphicView subclass: #MorphicBuilderView
	instanceVariableNames: 'parent propertyGridView prototypeClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App'!

!MorphicBuilderView class methodsFor: 'as yet unclassified' stamp: 'Skrish 8/15/2012 22:48'!
new: aClass

	^self new 
		prototypeClass: aClass new.! !

!MorphicBuilderView methodsFor: 'subclass responsibility' stamp: 'Skrish 8/14/2012 13:01'!
allMorphsDefaultSpecs

	^super allMorphsDefaultSpecs ! !

!MorphicBuilderView methodsFor: 'user interface' stamp: 'Skrish 8/27/2012 22:22'!
createMorphsDictionary 

	self resetPanelView.
	super createMorphsDictionary.! !

!MorphicBuilderView methodsFor: 'subclass responsibility' stamp: 'Skrish 9/2/2012 10:38'!
createMorphsSpecs 
 
	^prototypeClass
		ifNil: [ super createMorphsSpecs ]
		 ifNotNil: [ prototypeClass createMorphsSpecs ]! !

!MorphicBuilderView methodsFor: 'actions' stamp: 'Skrish 8/11/2012 23:59'!
gridViewOkAction 
	
	propertyGridView ifNotNil: [ :e | [e gridViewOkActionBlock value: nil ] on: Error do: [ :ex | self halt]]! !

!MorphicBuilderView methodsFor: 'subclass responsibility' stamp: 'Skrish 8/15/2012 22:44'!
morphsPrimaryPropertiesSpecs 

	^prototypeClass
		ifNil: [ super morphsPrimaryPropertiesSpecs ]
		 ifNotNil: [ prototypeClass morphsPrimaryPropertiesSpecs ]! !

!MorphicBuilderView methodsFor: 'subclass responsibility' stamp: 'Skrish 8/15/2012 22:44'!
morphsSecondaryPropertiesSpecs 

	^prototypeClass
		ifNil: [ super morphsSecondaryPropertiesSpecs ]
		 ifNotNil: [ prototypeClass morphsSecondaryPropertiesSpecs ]! !

!MorphicBuilderView methodsFor: 'accessing' stamp: 'Skrish 8/9/2012 20:05'!
parent: aParent 

	parent := aParent ! !

!MorphicBuilderView methodsFor: 'user interface' stamp: 'Skrish 8/25/2012 12:44'!
postOpen

		| winSpecs |
	
	self resetTextFieldsMorphBounds.	
	self setAllToDefaultViewFont.	
	self hackSettingWindowColorToNewTheme.	
	winSpecs := self windowSpecs asOrderedCollection .
	winSpecs := winSpecs remove: (winSpecs detect: [ :ea | ea key = #position: ] ifNone: [] )  ifAbsent:[]; yourself.
	self performSpecMessages: ( winSpecs ) . "hack to call this again after open to reset bounds / other specs"
	self setMenu .	
	self primaryWindow isSystemWindow ifTrue: [ self primaryWindow restoreAndActivate	].
	self setAllMorphsBalloonTextToKey.! !

!MorphicBuilderView methodsFor: 'accessing' stamp: 'Skrish 8/11/2012 22:52'!
propertyGridView
	
	^propertyGridView! !

!MorphicBuilderView methodsFor: 'accessing' stamp: 'Skrish 8/11/2012 22:52'!
propertyGridView: gridView

	propertyGridView := gridView! !

!MorphicBuilderView methodsFor: 'accessing' stamp: 'Skrish 8/15/2012 22:42'!
prototypeClass: aClassInstance

	prototypeClass := aClassInstance! !

!MorphicBuilderView methodsFor: 'actions' stamp: 'Skrish 8/16/2012 00:20'!
setAllMorphsBalloonTextToKey
		
			| allInstVars m vStr |
			
		morphsDictionary keysAndValuesDo: [ :key :val | 
			self setBallonTextOnMorph: val for: key].
		self setBallonTextOnMorph: primaryWindow  for: 'Window'
		
! !

!MorphicBuilderView methodsFor: 'actions' stamp: 'Skrish 8/16/2012 00:21'!
setBallonTextOnMorph: val for: key

	| m allInstVars vStr |
	m := val.
			(val class = MorphicViewValueWrapper )
				ifTrue: [ m := val morph].
			allInstVars := (m class allInstVarNames inject: ( WriteStream on: '') into:  [ :str :e |  | v |
						v :=  ( m instVarNamed: e) .
						v 
						   ifNotNil: [
							(v isCollection and: [ v isString not]) ifTrue: [ v := '#( size: ' , v size asString , '  )'].							
							vStr := v asString size > 50 ifTrue: [(v asString copyFrom: 1 to:  45 ) , '  [.....]'  ] ifFalse: [ v asString].							
							vStr trimBoth ifNotEmpty: [	str cr; nextPutAll: e ; nextPutAll: ' >' ; tab; nextPutAll: vStr]] .							
						str ] ) contents.
			val assureExtension .
			((key = 'Window') ifTrue: [val submorphs last] ifFalse: [ val ] )
					extension balloonText: '.        <<', key, '>>        .' ,  allInstVars! !

!MorphicBuilderView methodsFor: 'subclass responsibility' stamp: 'Skrish 8/25/2012 12:37'!
windowSpecs 

	^windowSpecs 
		ifNil: [ super windowSpecs ]
		 ifNotNil: [  windowSpecs ]! !

!SimpleImplicitMorphicView methodsFor: 'misc' stamp: 'Skrish 7/29/2012 22:54'!
addToMorphsPrimarySpecs: primarySpecs

	morphsPrimarySpecs ifNil: [ ^ morphsPrimarySpecs := primarySpecs  ].
	primarySpecs  do: [ :ea |
			( morphsPrimarySpecs detect: [:specs | specs key = ea key] ifNone: [] ) 
				ifNotNil: [ :sp |  morphsPrimarySpecs remove: sp].
			morphsPrimarySpecs := morphsPrimarySpecs asOrderedCollection  add: ea ; yourself.		
			].
! !

!SimpleImplicitMorphicView methodsFor: 'misc' stamp: 'Skrish 7/29/2012 23:12'!
addToMorphsSecondarySpecs:  secondarySpecs

	morphsSecondarySpecs ifNil: [ ^ morphsSecondarySpecs := secondarySpecs ].
	secondarySpecs do: [ :ea |
			(morphsSecondarySpecs detect: [:specs | specs key = ea key] ifNone: [] ) 
				ifNotNil: [ :sp |  morphsSecondarySpecs remove: sp].
			morphsSecondarySpecs := morphsSecondarySpecs asOrderedCollection  add: ea ; yourself.		
			].
! !

!SimpleImplicitMorphicView methodsFor: 'subclass responsibility' stamp: 'Skrish 8/10/2012 15:20'!
allMorphsDefaultSpecs

	^allMorphsDefaultSpecs ifNil: [{}]! !

!SimpleImplicitMorphicView methodsFor: 'subclass responsibility' stamp: 'Skrish 8/14/2012 19:21'!
allMorphsDefaultSpecs: defaultSpecsArray

	allMorphsDefaultSpecs := defaultSpecsArray  ! !

!SimpleImplicitMorphicView methodsFor: 'accessing' stamp: 'Skrish 8/13/2012 14:10'!
createMenuArray 

	^menuArray ifNil: [ {}]! !

!SimpleImplicitMorphicView methodsFor: 'subclass responsibility' stamp: 'Skrish 7/12/2012 23:19'!
createMorphsSpecs

	^specsArray ifNil: [ ^{} ]! !

!SimpleImplicitMorphicView methodsFor: 'accessing' stamp: 'skrish 2/7/2012 22:58'!
createMorphsSpecs: aSpecsArray
	 specsArray := aSpecsArray! !

!SimpleImplicitMorphicView methodsFor: 'accessing' stamp: 'Skrish 7/8/2012 13:30'!
layoutMorphSpecs: specLayoutArray

	"need to work on this one.. "! !

!SimpleImplicitMorphicView methodsFor: 'accessing' stamp: 'Skrish 8/13/2012 12:43'!
menuArray: menuValuesArray

	menuArray := menuValuesArray ! !

!SimpleImplicitMorphicView methodsFor: 'subclass responsibility' stamp: 'Skrish 7/29/2012 22:35'!
morphsPrimaryPropertiesSpecs

	super morphsPrimaryPropertiesSpecs.
	^ morphsPrimarySpecs 
		ifNil: [ {} ]
		ifNotNil: [ 
			(morphsPrimarySpecs notEmpty and: [ morphsPrimarySpecs first value isString])
					ifTrue: [ morphsPrimarySpecs collect: [ :ea |
								ea key -> (Compiler evaluate: ea value for: self logged: false)] ]
				ifFalse: [ morphsPrimarySpecs ] ]! !

!SimpleImplicitMorphicView methodsFor: 'accessing' stamp: 'skrish 2/11/2012 12:08'!
morphsPrimaryPropertiesSpecs: specs

	^ morphsPrimarySpecs := specs! !

!SimpleImplicitMorphicView methodsFor: 'accessing' stamp: 'Skrish 7/29/2012 21:57'!
morphsPrimarySpecs

	^morphsPrimarySpecs ifNil: [ {}]! !

!SimpleImplicitMorphicView methodsFor: 'accessing' stamp: 'Skrish 7/29/2012 22:22'!
morphsPrimarySpecs: values

	morphsPrimarySpecs := values! !

!SimpleImplicitMorphicView methodsFor: 'subclass responsibility' stamp: 'Skrish 8/14/2012 19:26'!
morphsSecondaryPropertiesSpecs
	
	self setAllMorphsDefaultSpecs .
	self setAllLabelMorphsRigidHorizontal.
	^self recurseAndSetSecondaryMorphPropertiesSpecs ! !

!SimpleImplicitMorphicView methodsFor: 'accessing' stamp: 'skrish 2/11/2012 12:08'!
morphsSecondaryPropertiesSpecs: specs 

	^ morphsSecondarySpecs := specs! !

!SimpleImplicitMorphicView methodsFor: 'accessing' stamp: 'Skrish 7/11/2012 11:08'!
morphsSecondarySpecs

	^morphsSecondarySpecs ifNil: [ {}]! !

!SimpleImplicitMorphicView methodsFor: 'user interface' stamp: 'Skrish 9/3/2012 10:09'!
openTabbedSystemWindows:  viewAndNamesAssocs
"Should bump this up the hierachy to AbstractMorphicView later..with a bit of refactoring.."

	self openTabbedSystemWindows: viewAndNamesAssocs modal: true! !

!SimpleImplicitMorphicView methodsFor: 'user interface' stamp: 'Skrish 9/3/2012 18:29'!
openTabbedSystemWindows:  viewAndNamesAssocs modal: bool
"very basic tabbed pane view, extend this to have a extensible pop up menu on the tab button to close/ tab list / and an extensible window menu..  et als.. "
"SimpleImplicitMorphicView  new windowTitle: 'Testing' ;  self new openTabbedSystemWindows: { 'one' -> TrialView01  new  . 'new' -> TrialView01 new.  'two' -> TrialView01  new  .  }"
	| tabGroup tg  specs |

	useDefaultBounds := true.
	bounds ifNil: [  self  bounds: (10@35 corner: 385@500)].
	tabGroup := viewAndNamesAssocs collect: [ :ea | 
			|vw|  
			vw := ea value  . 
			panels add: ea key -> vw.
			ea key -> (vw createPrimaryView; panelWindow) ].
	specs := (self createMorphsSpecs ifNil: [ {}]) asOrderedCollection .
	(specs detect: [:ea | ea key = 'tabs'] ifNone: []) ifNotNil: [ :e | specs remove: e ].
	specs add:  'tabs' -> #TabGroupMorph  ; yourself.
	self createMorphsSpecs: specs .
	(self morphsDictionary at: 'tabs' ifAbsent: [])
		ifNotNil:  [ :e |  
			tg := TabGroupMorph new. 
			e delete. 
			self morphsDictionary at: 'tabs' put: tg .
		     panelWindow addMorph: tg  ].
	self  createMorphsDictionary .
	tg := self morphsDictionary at: 'tabs'.
	self setTabbedGroupPopupMenuSelector: #tabMorphPopup:event:morph: on: self.
	tabGroup do: [ :ea |  
			tg addPage: ea value  label: ea key ]. 
	(self morphsDictionary at: 'tabs') 
			extent: ( 375@300); 
			hResizing: #shrinkWrap ; 
			vResizing: #spaceFill.
	self panelWindow  
			vResizing: #spaceFill; 
			hResizing: #shrinkWrap .
	viewAndNamesAssocs ifNotEmpty: [tg tabSelectorMorph selectedIndex: 1].
	bool ifTrue: [self openModal ] ifFalse: [ self open].! !

!SimpleImplicitMorphicView methodsFor: 'override-in-subclass' stamp: 'skrish 2/9/2012 17:55'!
panelViewInitializeSpecs 

 ^panelViewInitializeSpecs ifNil: [ {}]! !

!SimpleImplicitMorphicView methodsFor: 'accessing' stamp: 'skrish 2/9/2012 17:36'!
panelViewInitializeSpecs: panelSpecs

 panelViewInitializeSpecs  := panelSpecs ! !

!SimpleImplicitMorphicView methodsFor: 'user interface' stamp: 'skrish 2/8/2012 19:05'!
postCreateInitialize
"ensure super is always called"
	super postCreateInitialize.! !

!SimpleImplicitMorphicView methodsFor: 'user interface' stamp: 'Skrish 8/6/2012 23:41'!
postOpen

	super postOpen .

	
	! !

!SimpleImplicitMorphicView methodsFor: 'accessing' stamp: 'Skrish 7/8/2012 13:33'!
primaryWindowSpecs: primaryWindowSpecsArray
"flow / absolute layout, controller class / model class name / creating view attributes / "

	primaryWindowSpecs := primaryWindowSpecsArray! !

!SimpleImplicitMorphicView methodsFor: 'subclass responsibility' stamp: 'Skrish 8/6/2012 14:18'!
recurseAndSetSecondaryMorphPropertiesSpecs

	^(morphsSecondarySpecs
		 ifNil: [ {} ]
		 ifNotNil: [
			(morphsSecondarySpecs notEmpty and: [ morphsSecondarySpecs first value isString])
					ifTrue: [ morphsSecondarySpecs collect: [ :ea |
								ea key -> ( [Compiler evaluate: ea value] on: Exception do: [ :ex | self halt ])] ]
					ifFalse: [ morphsSecondarySpecs ]]) select: [ :e | morphsDictionary keys includes: e key ]! !

!SimpleImplicitMorphicView methodsFor: 'user interface' stamp: 'Skrish 9/3/2012 15:51'!
resetTabbedSystemWindows:  viewAndNamesAssocs 
"very basic tabbed pane view, extend this to have a extensible pop up menu on the tab button to close/ tab list / and an extensible window menu..  et als.. "
"SimpleImplicitMorphicView  new windowTitle: 'Testing' ;  self openTabbedSystemWindows: { 'one' -> TrialView01  new  . 'new' -> TrialView01 new.  'two' -> TrialView01  new  .  }"
	| tabGroup tg  specs |

	tabGroup := viewAndNamesAssocs collect: [ :ea | 
			|vw|  
			vw := ea value  . 
			panels add: ea key -> vw.
			ea key -> (vw createPrimaryView; panelWindow) ].
	specs := (self createMorphsSpecs ifNil: [ {}]) asOrderedCollection .
	(specs detect: [:ea | ea key = 'tabs'] ifNone: []) ifNotNil: [ :e | specs remove: e ].
	specs add:  'tabs' -> #TabGroupMorph  ; yourself.
	self createMorphsSpecs: specs .
	(self morphsDictionary at: 'tabs' ifAbsent: [])
		ifNotNil:  [ :e |  
			tg := TabGroupMorph new. e delete. 
			self morphsDictionary at: 'tabs' put: tg . panelWindow addMorphBack: tg  ].
	tg := self morphsDictionary at: 'tabs'.
	tabGroup do: [ :ea |  
			tg addPage: ea value  label: ea key ]. 
	(self morphsDictionary at: 'tabs') hResizing: #spaceFill ; vResizing: #spaceFill.
	viewAndNamesAssocs ifNotEmpty: [tg tabSelectorMorph selectedIndex: 1].! !

!SimpleImplicitMorphicView methodsFor: 'accessing' stamp: 'Skrish 8/4/2012 11:06'!
resizeOrWrap

	^resizeOrWrap ifNil: [ #shrinkWrap]! !

!SimpleImplicitMorphicView methodsFor: 'accessing' stamp: 'Skrish 8/4/2012 11:02'!
resizeOrWrap: sym

	resizeOrWrap := sym! !

!SimpleImplicitMorphicView methodsFor: 'misc' stamp: 'Skrish 8/13/2012 16:15'!
setAllMorphsToResizeOrWrapHorizontal: spaceFillOrShrinkWrap 
	(morphsDictionary values select: [ :ea | 
		(ea isKindOf: PluggableButtonMorph ) not and: [ 	(AbstractMorphicView isView: ea class ) not] 
		])
			do: [:eaMorph | eaMorph hResizing: spaceFillOrShrinkWrap] ! !

!SimpleImplicitMorphicView methodsFor: 'user interface' stamp: 'Skrish 9/3/2012 18:31'!
setTabbedGroupPopupMenuSelector: selector on: object

	| tabGroup |
	tabGroup := self morphsDictionary at: 'tabs' ifAbsent: [ ^self error: 'should not send this message if tabs are not created as yet'].
	tabGroup tabSelectorMorph setTabsCloseIcon.
		
	tabGroup tabSelectorMorph tabs 
		do: [ :tab | tab on: #mouseDown send: selector to: object ].
	! !

!SimpleImplicitMorphicView methodsFor: 'user interface' stamp: 'Skrish 9/3/2012 16:44'!
tabMorphPopup: obj event: evt morph: morph

	( self tabMorphPopupMenu: obj morph: morph) popUpInWorld ! !

!SimpleImplicitMorphicView methodsFor: 'user interface' stamp: 'Skrish 9/3/2012 16:45'!
tabMorphPopupMenu: obj morph: morph

	^MenuMorph new
		 add: 'Close Tab' target: [ morph owner owner removePageIndex: (morph owner submorphs indexOf: morph) ] selector: #value ;
		yourself! !

!SimpleImplicitMorphicView methodsFor: 'misc' stamp: 'skrish 2/15/2012 10:34'!
testCreateViewPackageBrowserView: packageName
" self testCreateViewPackageBrowserView"

	| aView viewModel  packageNamesList index classesList |
	aView := SimpleImplicitMorphicView new windowType: #Window.

	"create a model instance and set attributes for view"
	viewModel := MorphicViewBrowserModel new.

	classesList :=  (PackageOrganizer default packageNamed: packageName ifAbsent: [ ^self error: 'package name unknown' ]) classes  .

	viewModel classList: classesList.
	aView windowTitle: packageName.
	aView useDefaultBounds: true.
	
	"list of widgets on your screen:"	
	aView createMorphsSpecs: 
	{
		#row1-> { 'classList' -> #PluggableListMorph . 	'methodList' -> #PluggableListMorph .}.
		#row2 -> { #resizing -> #shrinkWrap. 'instanceButton' -> #PluggableButtonMorph . 'classButton' -> #PluggableButtonMorph }.
		'sourceText' -> #PluggableTextMorph .
		}.
	
	"basic model and action setters"
	aView morphsPrimaryPropertiesSpecs:  {
		'classList' -> (#on:list:selected:changeSelected:menu:keystroke: -> { viewModel. #classList . #classSelectionIndex . #classSelectionIndex: . nil . nil} ).
		'methodList' -> ( #on:list:selected:changeSelected:menu:keystroke: -> {viewModel . #methodList . #methodSelectionIndex . #methodSelectionIndex: . nil . nil }).
		'sourceText' -> ( #on:text:accept:readSelection:menu: -> {viewModel . #methodSource . #methodSource: . nil . nil  }).
		'instanceButton' -> ( #on:getState:action:label:menu:  -> { [viewModel instanceOrClass: #instance. viewModel classSelectionIndex: viewModel classSelectionIndex ] . nil. #value . nil. nil }).
		'classButton' -> ( #on:getState:action:label:menu:  -> { [viewModel instanceOrClass: #class. viewModel classSelectionIndex: viewModel classSelectionIndex ] . nil. #value . nil. nil })
	}.
	
	"the additional attributes of widgets"
	aView morphsSecondaryPropertiesSpecs: {
		'sourceText' -> { #classOrMetaClass: -> { viewModel classSelected }.  #hResizing: -> { #spaceFill} . #vResizing: -> { #spaceFill}}.
		'instanceButton' -> { #label: -> { 'instance methods'}}.
		'classButton' -> { #label: -> { 'class methods'}}.
		'classList' -> { #hResizing: -> { #spaceFill} . #vResizing: -> { #spaceFill}}.
		'methodList' -> { #hResizing: -> { #spaceFill} . #vResizing: -> { #spaceFill}}
	}.
	
	^aView ! !

!SimpleImplicitMorphicView methodsFor: 'accessing' stamp: 'Skrish 7/8/2012 13:29'!
viewCategory

	^viewCategory ! !

!SimpleImplicitMorphicView methodsFor: 'accessing' stamp: 'Skrish 7/8/2012 13:29'!
viewCategory: aCategory
	
	viewCategory := aCategory! !

!SimpleImplicitMorphicView methodsFor: 'accessing' stamp: 'Skrish 7/8/2012 13:28'!
viewName
	
	^viewName! !

!SimpleImplicitMorphicView methodsFor: 'accessing' stamp: 'Skrish 7/8/2012 13:28'!
viewName: aName
	
	viewName := aName! !

!SimpleImplicitMorphicView methodsFor: 'accessing' stamp: 'Skrish 7/8/2012 13:33'!
viewSpecs: viewSpecsArray
"flow / absolute layout, controller class / model class name / creating view attributes / "

	viewSpecs := viewSpecsArray! !

!SimpleImplicitMorphicView methodsFor: 'accessing' stamp: 'Skrish 8/22/2012 09:51'!
windowSpecs
	
	^windowSpecs ifNil: [ super windowSpecs ]! !

!SimpleImplicitMorphicView methodsFor: 'accessing' stamp: 'Skrish 7/11/2012 23:25'!
windowSpecs: anOrderedCollection 
	windowSpecs := anOrderedCollection ! !

AbstractSimpleMorphicView subclass: #TableLayoutSimpleComposedView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Examples'!

!TableLayoutSimpleComposedView methodsFor: 'user-interface' stamp: 'skrish 2/12/2012 01:08'!
createMorphsSpecs 
"self open"
^{

('Panel2'->#TableLayoutSimplePanelTwo ).
(#TableLayoutSimplePanelOne->#TableLayoutSimplePanelOne).
(#TableLayoutSimplePanelThree->#TableLayoutSimplePanelThree)
}! !

!TableLayoutSimpleComposedView methodsFor: 'user-interface' stamp: 'skrish 2/12/2012 01:05'!
initialize

super initialize.
self useDefaultBounds: true.
self windowType: #Dialog.
self panelType: #newRow ! !

AbstractSimpleMorphicView subclass: #TableLayoutSimplePanelOne
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Examples'!

!TableLayoutSimplePanelOne methodsFor: 'user-interface' stamp: 'skrish 2/12/2012 01:43'!
createMorphsSpecs
" (self new windowType: #Window ) open "
	^ {('Label' -> #LabelMorph).
	('DisabledLabel' -> #LabelMorph).
	('NormalButton' -> #PluggableButtonMorph).
	('DefaultButton' -> #PluggableButtonMorph).
	('DisabledButton' -> #PluggableButtonMorph).
	('SelectedButton' -> #PluggableButtonMorph).
	('SelectedDisabledButton' -> #PluggableButtonMorph).
	('Label2' -> #LabelMorph).
	('CheckBox' -> #CheckboxMorph).
	('DisabledCheckBox' -> #CheckboxMorph).
	('Label3' -> #LabelMorph).	
	('RadioButtonGroup' -> #RadioButtonGroup ).
	('Label13' -> #LabelMorph).	
	('DisabledRadioButton' -> #RadioButtonMorph ).
	('Label4' -> #LabelMorph).
	('Text' -> #PluggableTextFieldMorph).
	('DisabledText' -> #PluggableTextFieldMorph).
	('Label5' -> #LabelMorph).
	('Slider' -> #PluggableSliderMorph).
	('DisabledSlider' -> #PluggableSliderMorph)}! !

!TableLayoutSimplePanelOne methodsFor: 'user-interface' stamp: 'skrish 2/12/2012 01:14'!
initialize

super initialize.
self bounds: (20@20 corner: 600@780).
self useDefaultBounds: true.
self windowType: #Morph.
self panelType: #newColumn! !

!TableLayoutSimplePanelOne methodsFor: 'user-interface' stamp: 'skrish 2/12/2012 01:50'!
morphsSecondaryPropertiesSpecs
	"self open"

	super morphsSecondaryPropertiesSpecs.
	^ {('Label' -> {(#contents: -> {('A Label' getLocaleString)})}).
	('DisabledLabel' -> {(#contents: -> {('A Disabled Label' getLocaleString)}).
			(#enabled: -> {false})}).
	'NormalButton' -> {(#label: -> {('A Button' getLocaleString)}). 
			}.
	'DefaultButton' -> {(#label: -> {('Default Button' getLocaleString)}).
			 }.
	'DisabledButton' -> {(#label: -> {('Disabled Button' getLocaleString)}).
			(#disable -> {}).
			 }.
	'SelectedButton' -> {(#label: -> {('Selected Button' getLocaleString)}).
			 } .
	'SelectedDisabledButton' -> {(#label: -> {('Disabled Selected Button' getLocaleString)}).
			 }.
	('Label2' -> {(#contents: -> {('CheckBox' getLocaleString)})}).
	('CheckBox' -> {(#label: -> {'A Checkbox'}).
	#hResizing: -> { #rigid }.
	}).
	'DisabledCheckBox' -> {(#label: -> {'A Disabled Checkbox'}).
			 }.
	('Label3' -> {(#contents: -> {('Radio Buttons' getLocaleString)})}).
	'RadioButtonGroup' -> { #extent: -> {(200 @ 30)}.  #vResizing: -> { #rigid }
			 }.
	('DisabledRadioButton' -> {(#label: -> {'three'}).		
			(#disable -> {})}).
	'Label13' -> { #contents: -> { 'Testing'}  }. 
	('Label4' -> {(#contents: -> {('Text Boxes' getLocaleString)})}).
	('Text' -> {(#extent: -> {(200 @ 30)}).
			 }).
	'DisabledText' -> {(#disable -> {}).
			(#extent: -> {(200 @ 30)}).
			 }.
	('Label5' -> {(#contents: -> {('Sliders' getLocaleString)})}).
	('DisabledSlider' -> {(#disable -> {}).
			(#extent: -> {(200 @ 30)}).
			 }).
	('Slider' -> {(#extent: -> {(200 @ 30)}).
			 })}! !

!TableLayoutSimplePanelOne methodsFor: 'user-interface' stamp: 'Skrish 8/25/2012 11:17'!
panelViewInitializeSpecs

^{ 'RadioButtonGroup' -> { #list: -> {{'one'. 'two'. 'three'}}
		}  } ! !

AbstractSimpleMorphicView subclass: #TableLayoutSimplePanelThree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Examples'!

!TableLayoutSimplePanelThree methodsFor: 'user-interface' stamp: 'Priya 2/6/2012 21:03'!
createMorphsSpecs
	^{
	('Label1' -> #LabelMorph).
	('Text1' -> #PluggableTextMorph).
	('Label2' -> #LabelMorph).
	('Text2' -> #PluggableTextMorph).
	}! !

!TableLayoutSimplePanelThree methodsFor: 'user-interface' stamp: 'Skrish 8/25/2012 11:18'!
initialize
"self open"
	super initialize.
	self useDefaultBounds: true.
	windowType := #Dialog.
	self panelType:#newColumn! !

!TableLayoutSimplePanelThree methodsFor: 'user-interface' stamp: 'Priya 2/6/2012 21:05'!
morphsPrimaryPropertiesSpecs
	"super morphsPrimaryPropertiesSpecs."
	^{
	 'Text1' ->   ( #on:text:accept:readSelection:menu: -> {(ValueHolder new contents: 'Hello') . #contents. #contents: . nil . nil } ).
	 'Text2' ->   ( #on:text:accept:readSelection:menu: -> {(ValueHolder new contents: 'Hello') . #contents. #contents: . nil . nil } ).
	}! !

!TableLayoutSimplePanelThree methodsFor: 'user-interface' stamp: 'skrish 2/15/2012 00:37'!
morphsSecondaryPropertiesSpecs
"self open"
	^ {
	('Label1' -> 	{(#contents: -> {'Text Editor'}). 	 }). 
	('Text1' -> 	{(#hResizing: -> {#spaceFill}). (#extent: -> {400@200})}). 
	('Label2' -> 	{(#contents: -> {'Disabled Text Editor'}). 	 }).
	('Text2' -> 	{(#enabled: -> {false}). 	(#extent: -> {400@200})}). 	
	}! !

AbstractSimpleMorphicView subclass: #TableLayoutSimplePanelTwo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Examples'!

!TableLayoutSimplePanelTwo methodsFor: 'user-interface' stamp: 'Skrish 8/25/2012 11:20'!
createMorphsSpecs
	"self open"

	^ {('DropDown' -> #DropListMorph).
	('DisabledDropDown' -> #DropListMorph).
	('EditableDropDown' -> #EditableDropListMorph).
	('MorphDropDown' -> #MorphDropListMorph).
	('NormalList' -> #PluggableListMorph).
	('DisabledList' -> #PluggableListMorph).
	('MorphList' -> #MorphDropListMorph ).
	('Tree' -> #TreeListMorph)}! !

!TableLayoutSimplePanelTwo methodsFor: 'user-interface' stamp: 'pooja 2/8/2012 16:02'!
elementList
	^ {'One'.
	'Two'.
	'Three'.
	'Four'}! !

!TableLayoutSimplePanelTwo methodsFor: 'user-interface' stamp: 'pooja 2/8/2012 16:02'!
fontList
^TextStyle actualTextStyles explorerContents! !

!TableLayoutSimplePanelTwo methodsFor: 'user-interface' stamp: 'Skrish 8/25/2012 11:18'!
initialize
"self open"
	super initialize.
	self useDefaultBounds: true.
	windowType := #Dialog.
	panelType := #newColumn! !

!TableLayoutSimplePanelTwo methodsFor: 'user-interface' stamp: 'Skrish 8/25/2012 11:24'!
morphList

	^ (Color red wheel: 20)
		collect: [ :ea | 
			Morph new
				extent: 70 @ 12;
				color: ea ]! !

!TableLayoutSimplePanelTwo methodsFor: 'user-interface' stamp: 'Skrish 8/25/2012 11:23'!
morphsPrimaryPropertiesSpecs
	"self open"

	super morphsPrimaryPropertiesSpecs.
	^ {('DropDown' -> 	(#on:list:selected:changeSelected: -> 	{self. 	#elementList. 	nil. 	nil})).
	('DisabledDropDown' -> 	(#on:list:selected:changeSelected: -> 	{self. 	#elementList. 	nil. 	nil})).
	('EditableDropDown' -> 	(#on:list:selected:changeSelected: -> 	{nil. 	nil. 	nil. 	nil})).
	('MorphDropDown' -> 	(#on:list:selected:changeSelected: -> 	{nil. 	{(Morph new  extent: 70 @ 12; color: Color red). 	(Morph new  extent: 70 @ 12; 		color: Color green). 	(Morph new extent: 70 @ 12;  color: Color blue)}. 	nil. 	nil})).
	('NormalList' -> 	(#on:list:selected:changeSelected:menu:keystroke: -> 	{self. 	#elementList. 	nil. 	nil. 	nil. 	nil})).
	('DisabledList' -> 	(#on:list:selected:changeSelected:menu:keystroke: -> 	{self. 	#elementList. 	nil. 	nil. 	nil. 	nil})).
	('MorphList' -> 	(#on:list:selected:changeSelected: -> 	{self. 	#morphList. 	nil. 	nil})).
	('Tree' -> 	(#on:list:selected:changeSelected:menu:keystroke: -> 	{self. 	#fontList. 	nil. 	nil. 	nil. 	nil}))}! !

!TableLayoutSimplePanelTwo methodsFor: 'user-interface' stamp: 'Skrish 8/25/2012 11:26'!
morphsSecondaryPropertiesSpecs
	"self open"

	super morphsSecondaryPropertiesSpecs.
	^ {('DropDown' -> {(#extent: -> {(150 @ 30)})}).
	('DisabledDropDown'
		->
			{(#listSelectionIndex: -> {3}).
			(#enabled: -> {false}).
			(#extent: -> {(150 @ 30)})}).
	('EditableDropDown'
		->
			{(#ghostText: -> {'Enter new Items '}).
			(#extent: -> {(150 @ 50)})}).
	('MorphDropDown' -> {(#extent: -> {(150 @ 30)})}).
	('NormalList'
		->
			{(#selectionIndex: -> {3}).
			(#extent: -> {(150 @ 60)})}).
	('DisabledList'
		->
			{(#selectionIndex: -> {3}).
			(#enabled: -> {false}).
			(#extent: -> {(150 @ 60)})}).
	'Tree' ->
		{ #extent: -> { 500@250}}.
	('MorphList' -> {(#extent: -> {(150 @ 30)})})}! !

AbstractSimpleMorphicView subclass: #TestNewDockingBarMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Tests'!

!TestNewDockingBarMenu methodsFor: 'private' stamp: 'Skrish 2/26/2013 09:39'!
buildToolBarWidgets

	^{ primaryWindow
			newButtonFor: self "if we had a model it would go here"
			getState: nil
			action: #openFile
			arguments: nil
			getEnabled: nil
			labelForm: primaryWindow theme smallOpenIcon
			help: 'Open file' translated.
		primaryWindow
			newButtonFor: self
			getState: nil
			action: #saveFile
			arguments: nil
			getEnabled: nil
			labelForm: primaryWindow theme smallSaveIcon
			help: 'Save file' translated.
		primaryWindow 
			newButtonFor: self
			getState: nil
			action: #print
			arguments: nil
			getEnabled: nil
			labelForm: primaryWindow  theme smallPrintIcon
			help: 'Print' translated }! !

!TestNewDockingBarMenu methodsFor: 'private' stamp: 'Skrish 2/26/2013 09:39'!
createFileMenuArray

	| fileMenu |
	fileMenu := primaryWindow newMenu.
	fileMenu
		addToggle: 'Open' translated
		target: self "would be model"
		selector: #openFile.
	fileMenu lastItem
		font: primaryWindow  theme menuFont;
		icon: primaryWindow  theme smallOpenIcon;
		keyText: 'Ctrl+O'.
	fileMenu
		addToggle: 'Save' translated
		target: self
		selector: #saveFile
		getStateSelector: nil
		enablementSelector: nil.
	fileMenu lastItem
		font: primaryWindow  theme menuFont;
		keyText: 'Ctrl+S'.
	fileMenu
		addToggle: 'Print...' translated
		target: self
		selector: #print.
	fileMenu lastItem
		font: primaryWindow  theme menuFont;
		icon: primaryWindow  theme smallPrintIcon;
		keyText: 'Ctrl+P'.
	
	^{'File' . primaryWindow theme menuBarFont . primaryWindow theme smallOpenIcon . 'File Open' . fileMenu }! !

!TestNewDockingBarMenu methodsFor: 'private' stamp: 'Skrish 8/13/2012 11:58'!
createMenuArray

	^{self createFileMenuArray }! !

!TestNewDockingBarMenu methodsFor: 'subclass responsibility' stamp: 'Skrish 8/14/2012 09:07'!
createMorphsSpecs 

	^{ 'test1' -> #Text}! !

!TestNewDockingBarMenu methodsFor: 'subclass responsibility' stamp: 'Skrish 8/13/2012 12:40'!
initialize
"self open"
	super initialize.
	windowType := #StandardWindow.
	panelType := #newRow.
! !

!TestNewDockingBarMenu methodsFor: 'subclass responsibility' stamp: 'skrish 1/19/2012 12:42'!
morphsSecondaryPropertiesSpecs

^{}! !

!TestNewDockingBarMenu methodsFor: 'private' stamp: 'Skrish 2/26/2013 09:41'!
openFile

	UIManager default inform: 'Not Implemented'! !

!TestNewDockingBarMenu methodsFor: 'subclass responsibility' stamp: 'Skrish 8/14/2012 09:08'!
postCreateInitialize 

	self createScrollPaneMorph .! !

!TestNewDockingBarMenu methodsFor: 'private' stamp: 'Skrish 2/26/2013 09:41'!
print

	UIManager default inform: 'Not Implemented'! !

!TestNewDockingBarMenu methodsFor: 'private' stamp: 'Skrish 2/26/2013 09:41'!
saveFile

	UIManager default inform: 'Not Implemented'! !

AbstractSimpleMorphicView subclass: #TestNewSimpleMorphicFromSpecsView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Tests'!

!TestNewSimpleMorphicFromSpecsView class methodsFor: 'as yet unclassified' stamp: 'Skrish 2/26/2013 09:48'!
guiConstants

	^super guiConstants 
		at: 'label1Font' ifAbsentPut:  (( (TextStyle named: #Accuny) ifNil: [ TextStyle default]) fontOfPointSize: 12 );
		yourself! !

!TestNewSimpleMorphicFromSpecsView methodsFor: 'tests' stamp: 'skrish 1/17/2012 00:18'!
createMorphsSpecs
	"self open"
	^{
	 'label1' -> #LabelMorph.
	 'text1' -> #PluggableTextMorph.
	 'button1' -> #PluggableButtonMorph.
	} ! !

!TestNewSimpleMorphicFromSpecsView methodsFor: 'tests' stamp: 'Skrish 1/18/2012 15:57'!
initialize
	" self open"
	super initialize.
	windowType := #Window.
	self registerKeyboardShortcuts.! !

!TestNewSimpleMorphicFromSpecsView methodsFor: 'tests' stamp: 'skrish 1/18/2012 22:57'!
keyEventInfoArray
	"funny keycodes... for combined special keys with another key press:
	need to build a clean documentation on this..per OS"
	^ {{64. $L. self. #keyAltOrCTRLAndCapsLPressed}. {8. $G. self. #keyShiftAndCapsGPressed}. {0. $j. self. #keyWinKeyAndSmallJPressed}}! !

!TestNewSimpleMorphicFromSpecsView methodsFor: 'tests' stamp: 'skrish 1/17/2012 00:49'!
morphsPrimaryPropertiesSpecs
	"Primary mode, action and other setters that supply default values otherwise non-settable attributes
	nil for some args to default them, look at more complete
	implementation to use this better."
	
	super morphsPrimaryPropertiesSpecs.
	^{
	 'button1' ->  ( #on:getState:action:label:menu: -> { [self primaryWindow delete]. nil. #value . nil . nil } ) .
	}
! !

!TestNewSimpleMorphicFromSpecsView methodsFor: 'tests' stamp: 'skrish 1/18/2012 18:04'!
morphsSecondaryPropertiesSpecs
	"Other properties to be initialized at view startup"
	
	^{'label1' -> {#contents: -> {'label1' getLocaleString}. #font: -> {self class guiConstants at: 'label1Font'}}. 'text1' -> {#hResizing: -> {#spaceFill}. #vResizing: -> {#spaceFill}}. 'button1' -> {#label: -> {'Button 1' getLocaleString}. #extent: -> {120 @ 60}}}"#label: -> { 'Button 1' getLocaleString}."! !

!TestNewSimpleMorphicFromSpecsView methodsFor: 'tests' stamp: 'Skrish 8/24/2012 20:46'!
windowSpecs
	
	^{
		#bounds: -> { 50@50 corner: 500@ 300}
	}! !

AbstractSimpleMorphicView subclass: #TestNewSimpleMorphicView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Tests'!

!TestNewSimpleMorphicView class methodsFor: 'as yet unclassified' stamp: 'Skrish 2/26/2013 09:48'!
guiConstants

	^super guiConstants 
		at: 'label1Font' ifAbsentPut:  (( (TextStyle named: #Accuny) ifNil: [ TextStyle default]) fontOfPointSize: 12 );
		yourself! !

!TestNewSimpleMorphicView methodsFor: 'tests' stamp: 'Skrish 8/24/2012 20:51'!
createMorphsDictionary
"self open"
	super createMorphsDictionary .
	"morphsDictionary
		at: 'label1'
		put: (LabelMorph
				contents:  'label1' getLocaleString);
		 at: 'text1' put: PluggableTextFieldMorph new;
		
		at: 'button1'
		put: (PluggableButtonMorph new
				label:  'Button 1' getLocaleString)"! !

!TestNewSimpleMorphicView methodsFor: 'tests' stamp: 'Skrish 8/24/2012 20:50'!
createMorphsSpecs
	
	^{
	 'label1' -> #LabelMorph.
	 'text1' -> #PluggableTextMorph.
	 'button1' -> #PluggableButtonMorph.
	} ! !

!TestNewSimpleMorphicView methodsFor: 'tests' stamp: 'Skrish 8/24/2012 20:48'!
initialize
	"self open"
	super initialize.
	windowType := #Window.
	self eventHandler: TestEventHandler new! !

!TestNewSimpleMorphicView methodsFor: 'tests' stamp: 'skrish 1/17/2012 01:32'!
setMorphsPrimaryProperties
	"nil for mode, action, accept, read selectors, look at more complete
	examples to use this better. Blank are required for
	PluggableTextMorph to work as it sends navigate messages and
	throws up the debugger"
	(morphsDictionary at: 'text1')
		on: self
		text: nil
		accept: nil
		readSelection: nil
		menu: nil.
	(morphsDictionary at: 'button1')
		on: [self primaryWindow delete]
		getState: nil
		action: #value
		label: nil
		menu: nil! !

!TestNewSimpleMorphicView methodsFor: 'tests' stamp: 'skrish 1/17/2012 01:42'!
setMorphsSecondaryProperties
"Other properties to be initialized at view startup"
	(morphsDictionary at: 'label1')
		font: (self class guiConstants at: 'label1Font' ).
	(morphsDictionary at: 'text1') hResizing: #spaceFill;
		 vResizing: #spaceFill! !

!TestNewSimpleMorphicView methodsFor: 'tests' stamp: 'Skrish 8/24/2012 20:48'!
windowSpecs
	
	^{
		#bounds: -> { 50@50 corner: 500@ 300}
	}! !

AbstractMorphicView subclass: #BankAccountView
	instanceVariableNames: 'reportMorph controller runsNum bankAccount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-Examples-BankAccount'!

!BankAccountView commentStamp: 'skr 1/6/2012 21:32' prior: 0!
A BankAccountView a test view.. the main view/ UI should be created properly in the main package..

Good example built up of the layout capabilities of the basic Pharo Morphic.. .. 

read through the category for user interface.. and also its abstract super class..

Instance Variables
	bankAccount:		<Object>

bankAccount
	- xxxxx
!

!BankAccountView class methodsFor: 'user interface' stamp: 'skrish 1/20/2012 00:17'!
applicationWindow
	"override to provide the model , controller to the view"
	| view |
	view := self new: BankAccount createNewAccount .
	"should we have this cyclical..? and only one controller..?"
	view
		controller: (BankAccountViewController new: view).
	^ view createPrimaryView! !

!BankAccountView class methodsFor: 'user interface' stamp: 'skrish 1/19/2012 10:20'!
guiConstants

	^super guiConstants
		at: 'bankAccountViewExtent' ifAbsentPut: 750@250;
		at: 'panelWindowColor' ifAbsentPut: (Color blue lighter alpha: 0.8);
		yourself! !

!BankAccountView class methodsFor: 'user interface' stamp: 'skr 1/9/2012 10:16'!
new

	self shouldNotImplement! !

!BankAccountView class methodsFor: 'user interface' stamp: 'skr 1/9/2012 11:24'!
new: anAccount 
	"instantiate this view only with its model"
	^ self basicNew initialize bankAccount: anAccount! !

!BankAccountView class methodsFor: 'user interface' stamp: 'Skrish 8/14/2012 20:02'!
open
	"self open"
	| inst |
	inst := self applicationWindow.
	inst primaryWindow extent: (self guiConstants at: 'bankAccountViewExtent').
	inst postCreateOpen ; postOpen .
	^inst! !

!BankAccountView methodsFor: 'accessing' stamp: 'skr 1/9/2012 22:04'!
bankAccount
	^ bankAccount! !

!BankAccountView methodsFor: 'accessing' stamp: 'skrish 1/19/2012 20:40'!
bankAccount: account 
	bankAccount := account.
	account ifNotNil: [
	bankAccount addDependent: self]! !

!BankAccountView methodsFor: 'user interface' stamp: 'skrish 1/12/2012 08:34'!
composeMorphs
"self open"
	"Future modifications if required.. overridden here.."
	super composeMorphs! !

!BankAccountView methodsFor: 'user interface' stamp: 'skrish 1/12/2012 08:56'!
composePanelWindow
"override in case you want to intervene later.."
		super composePanelWindow	! !

!BankAccountView methodsFor: 'accessing' stamp: 'skrish 1/11/2012 10:04'!
controller

^controller! !

!BankAccountView methodsFor: 'accessing' stamp: 'skr 1/9/2012 09:53'!
controller: aController

	controller := aController! !

!BankAccountView methodsFor: 'actions' stamp: 'skrish 1/19/2012 12:25'!
createHistoryMorph: account 
	| report |
	reportMorph
		ifNotNil: [reportMorph delete].
	report := BankAccountReportView new: account.
	reportMorph := report historyMorph.

	^ report! !

!BankAccountView methodsFor: 'user interface' stamp: 'Skrish 8/14/2012 19:56'!
createMorphsSpecs
	"list out all the morphs required in the primary window.. use further
	composition methods if there are complex compositions"

	^{
		 'accountNameLabel' -> #LabelMorph.
		 'accountNameText'  -> #PluggableTextFieldMorph.
		'tranNumLabel' -> #LabelMorph.
		 'runsText'  -> #PluggableTextFieldMorph.
		'openAccountDetailsButton'-> #PluggableButtonMorph.
		'resetHistoryButton'-> #PluggableButtonMorph.
		'statusField'-> #PluggableTextFieldMorph.
		}! !

!BankAccountView methodsFor: 'user interface' stamp: 'skrish 2/13/2012 23:27'!
createPrimaryWindow
	"should work on with options to switch between SystemWindow and
	DialogWindow..."
	primaryWindow := (SystemWindow
				labelled: self class name getLocaleString )
				color: (self class guiConstants at: 'primaryWindowColor')! !

!BankAccountView methodsFor: 'user interface' stamp: 'skrish 1/16/2012 01:10'!
layoutSpecsArray
"self open "
	"set the layout for all specs:
	two columns and with their respective extents..."
	| col1xPos col2xPos |
	col1xPos := 4.
	col2xPos := 250.
	^{
	 'accountNameLabel' -> {
			#fractions -> (0 @ 0 corner: 0 @ 0).
			#offsets -> (col1xPos @ 10 corner: 100 @ 30)
			}.	
	 'accountNameText' -> {
			#fractions -> (0 @ 0 corner: 0 @ 0).
			#offsets -> (col2xPos @ 10 corner: col2xPos+400 @ 30)
			}.	
	 'tranNumLabel' -> {
			#fractions -> (0 @ 0 corner: 0 @ 0).
			#offsets -> (col1xPos @ 60 corner: col1xPos+ 200 @ 80)
			}.	
	 'runsText' -> {
			#fractions -> (0 @ 0 corner: 0 @ 0).
			#offsets -> (col2xPos @ 60 corner: col2xPos +400 @ 90)
			}.	
	 'openAccountDetailsButton' -> {
			#fractions -> (0 @ 1 corner: 0 @ 1).
			#offsets -> (col1xPos @ -110 corner: col1xPos+ 150 @ -80)
			}.	
	 'resetHistoryButton' -> {
			#fractions -> (0 @ 1 corner: 0 @ 1).
			#offsets -> (col1xPos @ -70 corner: col1xPos+150 @ -40)
			}.	
	 'statusField' -> {
			#fractions -> (0 @ 1 corner: 1 @ 1).
			#offsets -> (col1xPos @ -30 corner: -4 @ -4)
			}.	
	}! !

!BankAccountView methodsFor: 'user interface' stamp: 'skrish 1/17/2012 03:54'!
morphsPrimaryPropertiesSpecs
	"set the basic action, with models for all morphs required"
	"morphsDictionary keys ; modelsDictionary keys"
	| accountNameMorph runsTextMorph |
	^{
	 'accountNameText' -> ( #on:text:accept:readSelection:menu: -> { controller . #name . #name: . nil . nil } ).
	 'runsText' -> (  #on:text:accept:readSelection:menu: -> { self . #runsNum . #runsNum: . nil . nil } ).
	'openAccountDetailsButton' -> ( #on:getState:action:label:menu: -> { controller . nil . #openHistoryMorph . nil. nil . }) .
	 'resetHistoryButton' -> ( #on:getState:action:label:menu: -> { controller . nil . #resetHistory . nil. nil . }) .
	}! !

!BankAccountView methodsFor: 'user interface' stamp: 'skrish 1/17/2012 10:56'!
morphsSecondaryPropertiesSpecs
"self open "
	"set the secondary properties"
	"morphsDictionary keys"
	"if we have a proportionalLayout instead of LayoutFrame based
	composition use #wrapDirection: and #cellPositioning:" 
	
	super morphsSecondaryPropertiesSpecs.
	^{
	'accountNameLabel' -> {
	        #contents: ->  {  'Account Name' getLocaleString}.
		}.
	'tranNumLabel' -> {
	        #contents: ->  { 'Run Transactions Num:  (1 to 10)' getLocaleString}.
		}.		
	'accountNameText' -> {
		 #convertTo: -> { String }.
		 #autoAccept: -> {  true }.
		 #acceptOnCR: -> { true }.
		}.
	'runsText' -> {
		 #convertTo: -> { Float } .
		 #autoAccept: ->  { true }.
		 #acceptOnCR: ->  { true }.
		}.
	'openAccountDetailsButton' -> {
		#cornerStyle: ->  { #square }.
		#label: ->  { 'Account Details' getLocaleString} .
		}.
	'resetHistoryButton' -> {
		#cornerStyle: ->  { #square }.
		#label: -> { 'Reset Account' getLocaleString}.	
			}.
	'statusField' -> {
		#contents: -> { '' } .
		 #color: ->  { Color lightGray }.
		 #readOnly: -> { true  }
		}
	}! !

!BankAccountView methodsFor: 'actions' stamp: 'skrish 1/19/2012 19:22'!
openHistoryMorph: account 
	^(self createHistoryMorph: account) openHistoryMorph! !

!BankAccountView methodsFor: 'init' stamp: 'skrish 1/19/2012 23:42'!
reinitialize
	"all data and fields, bare view.initialzied"
		bankAccount
		ifNotNil: [ bankAccount := nil.
		self resetFields.
		self resetRunsNum]! !

!BankAccountView methodsFor: 'actions' stamp: 'skrish 2/13/2012 23:27'!
resetFields
	| name |
	morphsDictionary isEmpty
		ifTrue: [^ self].
	bankAccount  isNil
		ifTrue: [name := '']
		ifFalse: [name := bankAccount name].
	(morphsDictionary at: 'accountNameText')
		setText: name.
	self resetStatusField! !

!BankAccountView methodsFor: 'actions' stamp: 'skr 1/13/2012 22:02'!
resetFieldsLinkedModel: account 
	"Need this if we reuse the same view for other accounts, need to
	reset the fields with the new model. For now validate if the account
	is the same as bankAccount for integrity of the view"
	account = bankAccount
		ifFalse: [self
				error:  'Account Model are out of synch' getLocaleString].
	morphsDictionary ifEmpty: [ ^self].
	(morphsDictionary at: 'accountNameText')
		on: account
		text: #name
		accept: #name:
		readSelection: nil
		menu: nil! !

!BankAccountView methodsFor: 'actions' stamp: 'skrish 1/19/2012 23:40'!
resetRunsNum
	morphsDictionary isEmpty
		ifTrue: [^ self].
	(morphsDictionary at: 'runsText')
		setText: '0'.
	self runsNum: '0'! !

!BankAccountView methodsFor: 'actions' stamp: 'Skrish 8/14/2012 19:56'!
resetStatusField

	(morphsDictionary at: 'statusField')
		setText: '.'.! !

!BankAccountView methodsFor: 'accessing' stamp: 'skrish 1/11/2012 10:32'!
runsNum
	^ runsNum
		ifNil: [0]
		! !

!BankAccountView methodsFor: 'accessing' stamp: 'skrish 1/11/2012 10:31'!
runsNum: aNumText 
	runsNum := aNumText asInteger.

	! !

!BankAccountView methodsFor: 'actions' stamp: 'skr 1/9/2012 22:08'!
saveTextData

	^ morphsDictionary
		do: [:ea | (ea respondsTo: #accept)
				ifTrue: [ea accept]]! !

!BankAccountView methodsFor: 'actions' stamp: 'skrish 1/11/2012 23:43'!
update: anAccount 
	morphsDictionary ifEmpty: [ ^self ].
	(morphsDictionary at: 'accountNameText')
		setText: anAccount name.
! !

AbstractMorphicView subclass: #BankAccountsDropListView
	instanceVariableNames: 'bankAccountList viewFlag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-Examples-BankAccount'!

!BankAccountsDropListView commentStamp: 'skr 1/9/2012 23:40' prior: 0!
A BankAccountsDropListView is a demo view to show creation, updates and deletes of bankaccounts..

Instance Variables
	bankAccountList:		<OrderedCollection of: BankAccounts>
	viewFlag:		<booleanOrNil > If the bankAccount view singleton is displaying.. just update it else create it in the dialog window open


bankAccountList
	- xxxxx

viewFlag
	- xxxxx
!

!BankAccountsDropListView class methodsFor: 'instance creation' stamp: 'skrish 1/20/2012 06:36'!
exampleWithAccounts
	"self exampleWithAccounts"
	| dropListView aList |
	self open.
	"some example accounts restored if existing or created..modify logic
	to store / retrieve against its id .."
	dropListView := (self named: 'ApplicationFramework.BankAccountsDropListView') reinitialize.
	aList := #('surabhi' 'vaibhav' 'ritwik' )
				collect: [:ea | (BankAccount named: 'BankAccountView.' , ea) name: ea;
						 addDependent: dropListView; yourself].
	dropListView bankAccountList: aList asOrderedCollection.
	dropListView update: aList first! !

!BankAccountsDropListView class methodsFor: 'constants' stamp: 'skrish 1/19/2012 19:44'!
guiConstants
	^ super guiConstants at: 'bankAccountsDropListViewExtent' ifAbsentPut: 750 @ 450;
		
		at: 'bankAccountViewColor'
		ifAbsentPut: (Color darkGray alpha: 0.7);
		 yourself! !

!BankAccountsDropListView class methodsFor: 'instance creation' stamp: 'Skrish 8/14/2012 22:11'!
open
	"BankAccountsDropListView  open"
	| dropListView aList aWin |
	dropListView :=  (self named: 'ApplicationFramework.BankAccountsDropListView') reinitialize .
	dropListView createPrimaryView.
	dropListView primaryWindow 
		extent: (self guiConstants at: 'bankAccountsDropListViewExtent').
	^dropListView postCreateOpen; postOpen! !

!BankAccountsDropListView class methodsFor: 'as yet unclassified' stamp: 'skrish 1/19/2012 23:56'!
prototypeTypeAndName

	^self defaultPrototypeTypeAndName! !

!BankAccountsDropListView class methodsFor: 'as yet unclassified' stamp: 'skrish 1/19/2012 23:58'!
prototypeTypeAndNames

	^self defaultSingletonPrototypeTypeAndNames! !

!BankAccountsDropListView methodsFor: 'accessing' stamp: 'skr 1/9/2012 23:10'!
bankAccountList
	^ bankAccountList ifNil: [ bankAccountList := OrderedCollection new ]! !

!BankAccountsDropListView methodsFor: 'accessing' stamp: 'skrish 2/13/2012 23:28'!
bankAccountList: aList 
	aList do: [ :ea |
			ea addDependent: self].
	bankAccountList := aList! !

!BankAccountsDropListView methodsFor: 'subclass responsibility' stamp: 'skrish 2/13/2012 23:34'!
composeMorphs
	"compose the morphs into the primaryWindow as is with
	morphsDictionary or with further composition in complex layout.
	This takes the default ProportionalLayout and to get TableLayout we need to go for SimpleMorphicView
	"
	primaryWindow
		addMorph: panelWindow
		fullFrame: ( LayoutFrame fractions: ( 0@0 corner: 1@0.4) offsets: ( 4@4 corner: -4 @ -4)).
	panelWindow color: (self class guiConstants at: 'panelWindowColor').
	primaryWindow extent: ( self class guiConstants at: 'bankAccountsDropListViewExtent') 
		! !

!BankAccountsDropListView methodsFor: 'action' stamp: 'Skrish 8/14/2012 22:07'!
createAccount
	"simple create the new account and add it to the list"
	| newAccount |
	
	newAccount := BankAccount createNewAccount.
	newAccount addDependent: self.
	self bankAccountList add: newAccount.
	(morphsDictionary at: 'bankAccountList') updateList.
	self openAccountView: bankAccountList size! !

!BankAccountsDropListView methodsFor: 'subclass responsibility' stamp: 'skrish 1/19/2012 20:25'!
createMorphsDictionary
	LoggerManager current log: 'createMorphsDictionary'.
	morphsDictionary
		at: 'createAccount'
		put: (PluggableButtonMorph new label: 'Create Account' getLocaleString);
		 at: 'bankAccountList' put: PluggableListMorph new! !

!BankAccountsDropListView methodsFor: 'creation' stamp: 'skrish 1/19/2012 18:37'!
getBankAccountView
	"unique instance for this list view"
	| view |
	LoggerManager current log: self hash asString.
	view := BankAccountView named: 'BankAccountView.' , self hash asString.
	view
		controller: (BankAccountViewController new: view).
	^ view! !

!BankAccountsDropListView methodsFor: 'init' stamp: 'skrish 1/19/2012 18:46'!
initialize
	super initialize.
	self windowType: #Window! !

!BankAccountsDropListView methodsFor: 'subclass responsibility' stamp: 'skrish 1/16/2012 01:20'!
layoutSpecsArray
"the widgets layout specs "
"self open"
	^{
	 'createAccount' -> {
		#fractions -> (0 @ 0 corner: 0 @0).
		#offsets -> ( 2 @ 2 corner: 110 @ 40)
		}.
	'bankAccountList' -> {
		#fractions -> (0 @ 0 corner: 1 @ 1).
		#offsets ->  (2 @ 50 corner: -2 @ -2)
		}
	}! !

!BankAccountsDropListView methodsFor: 'action' stamp: 'skrish 2/13/2012 23:33'!
openAccountView: aSelectionIndex 
	"self open"
	| view account cm |
	view := self getBankAccountView reinitialize.
	account := bankAccountList at: aSelectionIndex.
	view
		bankAccount: (bankAccountList at: aSelectionIndex).
	view resetFieldsLinkedModel: account.
	viewFlag
		ifNil: [viewFlag := true.
			view createPrimaryView.
			self primaryWindow
				addMorph: view panelWindow
				fullFrame: (LayoutFrame
						fractions: (0 @ 0.4 corner: 1 @ 1)
						offsets: (4 @ 4 corner: -4 @ -50)).
			view panelWindow
				color: (self class guiConstants at: 'bankAccountViewColor')]! !

!BankAccountsDropListView methodsFor: 'accessing' stamp: 'skrish 2/15/2012 10:25'!
reinitialize

	bankAccountList
		ifNotNil: [bankAccountList removeAll.
			self getBankAccountView reinitialize]! !

!BankAccountsDropListView methodsFor: 'subclass responsibility' stamp: 'skrish 1/17/2012 03:57'!
setMorphsPrimaryProperties

	self setAllMorphsToResizeOrWrap: #spaceFill . 
	(morphsDictionary at: 'bankAccountList')
		on: self
		list: #bankAccountList
		selected: nil
		changeSelected: #openAccountView:
		menu: nil
		keystroke: nil.

	(morphsDictionary at: 'createAccount')
		on: self
		getState: nil
		action: #createAccount
		label: nil
		menu: nil! !

!BankAccountsDropListView methodsFor: 'subclass responsibility' stamp: 'skr 1/9/2012 23:06'!
setMorphsSecondaryProperties
	(morphsDictionary at: 'createAccount') 
		 cornerStyle: #square! !

!BankAccountsDropListView methodsFor: 'updating' stamp: 'skrish 1/19/2012 20:48'!
update: anAccount 
	"actually need to just validate if the valid update for this action, the
	list already has additional item"
	(anAccount isKindOf: BankAccount)
		ifTrue: [(morphsDictionary at: 'bankAccountList') updateList].
	self getBankAccountView bankAccount: anAccount; resetFields.! !

!BankAccountsDropListView methodsFor: 'accessing' stamp: 'skrish 1/19/2012 18:24'!
viewFlag: aFlag

  viewFlag := aFlag! !

AbstractMorphicView subclass: #MorphicViewPackageBrowser
	instanceVariableNames: 'packageNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Examples'!

!MorphicViewPackageBrowser commentStamp: 'skrish 2/2/2012 19:34' prior: 0!
A MorphicViewBrowser is ambituous target to have a single tabbed panes window to show multiple classes in their windows with all methods in one window traversable more easily than now.

Instance Variables
!

!MorphicViewPackageBrowser class methodsFor: 'interface' stamp: 'skrish 2/3/2012 12:55'!
openOn: packageName
" self openOn: 'PharoMorphicView' "
	(self new packageName: packageName) open! !

!MorphicViewPackageBrowser methodsFor: 'user-interface' stamp: 'skrish 2/23/2012 08:48'!
canOpenInTabbedPane

	^true! !

!MorphicViewPackageBrowser methodsFor: 'user-interface' stamp: 'skrish 2/23/2012 07:19'!
createMorphsSpecs

	^{
	'packageNameLabel' -> #DropListMorph .
	'classList' -> #PluggableListMorph.
	'methodsList' -> #PluggableListMorph.
	'methodSource' -> #PluggableTextMorph.
	} ! !

!MorphicViewPackageBrowser methodsFor: 'user-interface' stamp: 'Skrish 2/26/2013 10:05'!
initialize
"(self new packageNames: {'PharoMorphicView-Core' . 'Morphic' . 'Kernel'}) open"
	super initialize.
	windowType := #Window.
	self useDefaultBounds: true.
	self viewModel: MorphicViewBrowserModel new.
	viewModel addDependent: self.
! !

!MorphicViewPackageBrowser methodsFor: 'user-interface' stamp: 'skrish 2/23/2012 07:37'!
layoutSpecsArray
"self open"
	^{
	'packageNameLabel' -> {
				#fractions -> (0@0 corner: 0.5@0).
				#offsets: -> ( 4@0 corner: 0@25)}.
				
	'classList' -> {
				#fractions -> (0 @ 0 corner: 0.5 @ 0.5).  
				#offsets -> ( 4 @ 30 corner: 0 @ 0).    
				}.
	'methodsList' -> {
				#fractions -> (0.5 @ 0 corner: 1 @ 0.5).  
				#offsets -> (2 @ 30 corner: 0 @ 0).   
				}.
	'methodSource' -> {
				#fractions -> (0 @ 0.5 corner: 1 @ 1). 
				#offsets -> ( 4 @ 2 corner: (-4 @ -4)).   
				}.
		}
	! !

!MorphicViewPackageBrowser methodsFor: 'user-interface' stamp: 'skrish 2/14/2012 00:06'!
methodSourceClass: aClassOrNil

	(morphsDictionary at: 'methodSource' ) classOrMetaClass: aClassOrNil! !

!MorphicViewPackageBrowser methodsFor: 'user-interface' stamp: 'Skrish 2/26/2013 10:49'!
morphsPrimaryPropertiesSpecs

	super morphsPrimaryPropertiesSpecs.
	
	^{
		'packageNameLabel' -> (#on:list:selected:changeSelected:  -> { viewModel  . #packageNamesList.  #packageNameIndex. #packageNameIndex: }) .
	
		'classList' -> ( #on:list:selected:changeSelected:menu:keystroke: -> { viewModel. #classList. #classSelectionIndex . #classSelectionIndex: . nil. nil } ).
	
		'methodsList' ->  ( #on:list:selected:changeSelected:menu:keystroke: -> { viewModel. #methodList. #methodSelectionIndex . #methodSelectionIndex: . nil. nil } ).
		
		'methodSource' -> ( #on:text:accept:readSelection:menu: -> { viewModel. #methodSource . #methodSource: . nil . nil } ).	
	}! !

!MorphicViewPackageBrowser methodsFor: 'user-interface' stamp: 'Skrish 2/26/2013 10:49'!
morphsSecondaryPropertiesSpecs
"Redundant but just an example"

	super morphsSecondaryPropertiesSpecs.
	
	^{

	 'methodSource' ->{
		 #font: -> { StandardFonts codeFont} .	}.
	
	}! !

!MorphicViewPackageBrowser methodsFor: 'user-interface' stamp: 'skrish 2/23/2012 08:49'!
packageNames: aPackageNamesArray

	| classes pkgColl |
	packageNames := aPackageNamesArray.
	
	pkgColl := OrderedCollection with: 'All'.
	classes := aPackageNamesArray inject: OrderedCollection new into: [ :clsCol :ea | | pkgInfo |
			pkgInfo := PackageOrganizer default packageNamed: ea ifAbsent: [ ^nil ].
			pkgColl addAll: pkgInfo systemCategories.
			clsCol addAll: pkgInfo classes asSet; yourself ].
	viewModel packageNamesList: pkgColl.
	viewModel classList:  classes! !

!MorphicViewPackageBrowser methodsFor: 'user-interface' stamp: 'skrish 2/3/2012 11:46'!
update: aSymbol

	aSymbol = #methodSource 
		ifTrue: [ self  methodSourceClass: viewModel classSelected]! !

!MorphicViewPackageBrowser methodsFor: 'user-interface' stamp: 'Skrish 2/26/2013 10:50'!
windowTitle
	^ packageNames
		ifNil: [ self class name ]
		ifNotNil: [ 
			'Package Browser: '
				, (((packageNames copyFrom: 1 to: (3 min: packageNames size)) joinUsing: Character space) , '. . . ') ]! !

AbstractMorphicView subclass: #ProportionalPanelOne
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Examples'!

!ProportionalPanelOne methodsFor: 'user-interface' stamp: 'skrish 2/9/2012 22:52'!
createMorphsSpecs
	^ {('Label' -> #LabelMorph).
	('DisabledLabel' -> #LabelMorph).
	('NormalButton' -> #PluggableButtonMorph).
	('DefaultButton' -> #PluggableButtonMorph).
	('DisabledButton' -> #PluggableButtonMorph).
"	('SelectedButton' -> #PluggableButtonMorph).
	('SelectedDisabledButton' -> #PluggableButtonMorph)."
	('Label2' -> #LabelMorph).
	('CheckBox' -> #CheckboxMorph).
	('DisabledCheckBox' -> #CheckboxMorph).
	('Label3' -> #LabelMorph).	
	('RadioButtonGroup' -> #RadioButtonGroup ).
	('DisabledRadioButton' -> #RadioButtonMorph ).
	('Label4' -> #LabelMorph).
	('Text' -> #PluggableTextMorph).
	('DisabledText' -> #PluggableTextMorph).
	('Label5' -> #LabelMorph).
	('Slider' -> #PluggableSliderMorph).
	('DisabledSlider' -> #PluggableSliderMorph)}! !

!ProportionalPanelOne methodsFor: 'user-interface' stamp: 'Skrish 8/24/2012 21:37'!
initialize
"(self new windowType: #Dialog ) open"
super initialize.
useDefaultBounds := true.
self windowType: #Morph.! !

!ProportionalPanelOne methodsFor: 'user-interface' stamp: 'Skrish 8/24/2012 22:21'!
layoutSpecsArray 
"self open"
^{
'Label' -> {
	#fractions -> ( 0 @ 0 corner: 0 @ 0).
	#offset -> ( 20 @ 0 corner: 200 @ 20 )
	}.
	'DisabledLabel' -> {
	#fractions -> ( 0 @ 0 corner: 0 @ 0).
	#offset -> ( 20 @ 40 corner: 200 @ 60 )
	}.
	'NormalButton' -> {
	#fractions -> ( 0 @ 0 corner: 0 @ 0).
	#offset -> ( 20 @ 80 corner: 200 @ 110 )
	}.
	'DefaultButton' -> {
	#fractions -> ( 0 @ 0 corner: 0 @ 0).
	#offset -> ( 20 @ 120 corner: 200 @ 150 )
	}.
	'DisabledButton' -> {
	#fractions -> ( 0 @ 0 corner: 0 @ 0).
	#offset -> ( 20 @ 160 corner: 200 @ 190 )
	}.
"	'SelectedButton' -> {
	#fractions -> ( 0 @ 0 corner: 0 @ 0).
	#offset -> ( 20 @ 230 corner: 200 @ 260 )
	}.
	'SelectedDisabledButton' -> {
	#fractions -> ( 0 @ 0 corner: 0 @ 0).
	#offset -> ( 20 @ 280 corner: 200 @ 310 )
	}."
	'Label2' -> {
	#fractions -> ( 0 @ 0 corner: 0 @ 0).
	#offset -> ( 20 @ 200 corner: 200 @ 220 )
	}.
	'CheckBox' -> {
	#fractions -> ( 0 @ 0 corner: 0 @ 0).
	#offset -> ( 20 @ 230 corner: 200 @ 250 )
	}.
	'DisabledCheckBox' -> {
	#fractions -> ( 0 @ 0 corner: 0 @ 0).
	#offset -> ( 20 @ 260 corner: 200 @ 280 )
	}.
	'Label3' -> {
	#fractions -> ( 0 @ 0 corner: 0 @ 0).
	#offset -> ( 20 @ 300 corner: 200 @ 320 )
	}.
	'RadioButtonGroup' -> {
	#fractions -> ( 0 @ 0 corner: 0 @ 0).
	#offset -> ( 20 @ 340 corner: 400 @ 360 )
	}.
	'DisabledRadioButton' -> {
	#fractions -> ( 0 @ 0 corner: 0 @ 0).
	#offset -> ( 20 @ 370 corner: 200 @ 390 )
	}.
	'Label4' -> {
	#fractions -> ( 0 @ 0 corner: 0 @ 0).
	#offset -> ( 20 @ 410 corner: 200 @ 430 )
	}.
	'Text' -> {
	#fractions -> ( 0 @ 1 corner: 0 @ 1).
	#offset -> ( 20 @ -180 corner: 200 @ -140 )
	}.
	'DisabledText' -> {
	#fractions -> ( 0 @ 1 corner: 0 @ 1).
	#offset -> ( 20 @ -135 corner: 200 @ -100 )
	}.
	'Label5' -> {
	#fractions -> ( 0 @ 1 corner: 0 @ 1).
	#offset -> ( 20 @ -80 corner: 200 @ -60 )
	}.
	'Slider' -> {
	#fractions -> ( 0 @ 1 corner: 0 @ 1).
	#offset -> ( 20 @ -40 corner: 200 @ -30 )
	}.
	'DisabledSlider' -> {
	#fractions -> ( 0 @ 1 corner: 0 @ 1).
	#offset -> ( 20 @ -20 corner: 200 @ -10 )
	}.
	}! !

!ProportionalPanelOne methodsFor: 'user-interface' stamp: 'skrish 2/9/2012 21:01'!
morphsSecondaryPropertiesSpecs
	"self open"
super morphsSecondaryPropertiesSpecs. 
	^ {('Label' -> {(#contents: -> {('A Label' getLocaleString)})}).
	('DisabledLabel'
		->
			{(#contents: -> {('A Disabled Label' getLocaleString)}).
			(#enabled: -> {false})}).
	('NormalButton' -> {(#label: -> {('A Button' getLocaleString)})}).
	('DefaultButton'
		->
			{(#label: -> {('Default Button' getLocaleString)}).
			(#isDefault: -> {true})}).
	('DisabledButton'
		->
			{(#label: -> {('Disabled Button' getLocaleString)}).
			(#disable -> {})}).
"	('SelectedButton' -> {(#label: -> {('Selected Button' getLocaleString)})}).
	('SelectedDisabledButton' -> {(#label: -> {('Disabled Selected Button' getLocaleString)})}).
"	('Label2' -> {(#contents: -> {('CheckBox' getLocaleString)})}).
	('CheckBox' -> {(#label: -> {'A Checkbox'})}).
	('DisabledCheckBox'
		->
			{(#label: -> {'A Disabled Checkbox'}).
			(#disable -> {})}).
	('Label3' -> {(#contents: -> {('Radio Buttons' getLocaleString)})}).
	('DisabledRadioButton' -> {(#label: -> {'three'}).(#disable -> {})}).
	('Label4' -> {(#contents: -> {('Text Boxes' getLocaleString)})}).
	('DisabledText' -> {(#disable -> {})}).
	('Label5' -> {(#contents: -> {('Sliders' getLocaleString)})}).
	('DisabledSlider' -> {(#disable -> {})})}! !

!ProportionalPanelOne methodsFor: 'user-interface' stamp: 'Skrish 8/24/2012 20:53'!
panelViewInitializeSpecs

^{'RadioButtonGroup' -> { #list: -> {{'one'. 'two'. 'three'}}}}! !

!ProportionalPanelOne methodsFor: 'user-interface' stamp: 'Skrish 8/24/2012 22:19'!
windowSpecs 
"self open"
	^{
		#bounds: -> { 50@10 corner: 350@ 750}
		}! !

AbstractMorphicView subclass: #ProportionalPanelThree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Examples'!

!ProportionalPanelThree methodsFor: 'user-interface' stamp: 'Skrish 8/24/2012 22:21'!
createMorphsSpecs
"self open"
	^{
	('Label1' -> #LabelMorph).
	('Text1' -> #PluggableTextMorph).
	('Label2' -> #LabelMorph).
	('Text2' -> #PluggableTextMorph).
	}! !

!ProportionalPanelThree methodsFor: 'user-interface' stamp: 'Priya 2/7/2012 10:52'!
initialize
	super initialize.
	windowType := #Dialog.
	! !

!ProportionalPanelThree methodsFor: 'user-interface' stamp: 'Priya 2/7/2012 11:00'!
layoutSpecsArray
	"self open"
	^{
	'Label1' -> {
				#fractions ->  (0 @ 0 corner: 1@ 0.03).
				#offsets ->  (0 @0 corner: 0 @ 0).
				}.
	'Text1' -> {
				#fractions ->  (0 @ 0.03 corner: 1@ 0.47).
				#offsets ->  (0 @0 corner: 0 @ 0).
				}.
	'Label2' -> {
				#fractions ->  (0 @ 0.47 corner: 1@ 0.50).
				#offsets ->  (0 @0 corner: 0 @ 0).
				}.
	'Text2' -> {
				#fractions ->  (0 @ 0.50 corner: 1@ 1).
				#offsets ->  (0 @0 corner: 0 @ -40).
				}.
	}! !

!ProportionalPanelThree methodsFor: 'user-interface' stamp: 'Priya 2/7/2012 10:51'!
morphsPrimaryPropertiesSpecs
	"super morphsPrimaryPropertiesSpecs."
	^{
	 'Text1' ->   ( #on:text:accept:readSelection:menu: -> {(ValueHolder new contents: 'Hello') . #contents. #contents: . nil . nil } ).
	 'Text2' ->   ( #on:text:accept:readSelection:menu: -> {(ValueHolder new contents: 'Hello') . #contents. #contents: . nil . nil } ).
	}! !

!ProportionalPanelThree methodsFor: 'user-interface' stamp: 'Priya 2/7/2012 11:03'!
morphsSecondaryPropertiesSpecs
"self open"
	^ {('Label1'
		->
			{(#contents: -> {'Text Editor'}).
			(#hResizing: -> {#spaceFill}).
			}).
		('Text1'
		->
			{(#hResizing: -> {#spaceFill}).
			(#vResizing: -> {#spaceFill})}).
		
	('Label2'
		->
			{(#contents: -> {'Disabled Text Editor'}).
			(#hResizing: -> {#spaceFill}).
			}).
	('Text2'
		->
			{(#enabled: -> {false}).
			(#hResizing: -> {#spaceFill}).
			(#vResizing: -> {#spaceFill})}).
	
			}! !

!ProportionalPanelThree methodsFor: 'user-interface' stamp: 'Skrish 8/24/2012 22:21'!
windowSpecs 
"self open"
	^{
		#bounds: -> { 50@10 corner: 350@ 750}
		}! !

AbstractMorphicView subclass: #ProportionalPanelTwo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Examples'!

!ProportionalPanelTwo methodsFor: 'user-interface' stamp: 'Skrish 8/24/2012 22:23'!
createMorphsSpecs
	"self open"

	^ {('DropDown' -> #DropListMorph).
	('DisabledDropDown' -> #DropListMorph).
	('EditableDropDown' -> #EditableDropListMorph).
	('MorphDropDown' -> #MorphDropListMorph).
	('NormalList' -> #PluggableListMorph).
	('DisabledList' -> #PluggableListMorph).
	"('MorphList' -> #PluggableMorphListMorphOfMany)."
	('Tree' -> #TreeListMorph)}! !

!ProportionalPanelTwo methodsFor: 'user-interface' stamp: 'pooja 2/8/2012 10:36'!
font
^TextStyle actualTextStyles explorerContents! !

!ProportionalPanelTwo methodsFor: 'user-interface' stamp: 'Skrish 8/24/2012 22:22'!
initialize
"self open"
	super initialize.
	windowType := #Dialog.
! !

!ProportionalPanelTwo methodsFor: 'user-interface' stamp: 'Skrish 8/25/2012 11:16'!
layoutSpecsArray 
"self open"
^{'DropDown'->
{
				#fractions -> (0 @ 0 corner: 0 @ 0).  
				#offsets -> (0 @ 0 corner: 150 @ 30).    
				}.
'DisabledDropDown'->
{
				#fractions -> (0 @ 0 corner: 0 @ 0).  
				#offsets -> (0 @ 40 corner: 150 @ 70).    
				}.
				'EditableDropDown'->
{
				#fractions -> (0 @ 0 corner: 0 @ 0).  
				#offsets -> (0 @ 80 corner: 150 @ 100).     
				}.
				'MorphDropDown'->
{
				#fractions -> (0 @ 0 corner: 0 @ 0).  
				#offsets -> (0 @ 110 corner: 150@ 140).    
				}.
				'NormalList'->
{
				#fractions -> (0 @ 0 corner: 0 @ 0).  
				#offsets -> (0 @ 150 corner: 150@ 210).    
				}.
				'DisabledList'->
{
				#fractions -> (0 @ 0 corner: 0 @ 0).  
				#offsets -> (0 @ 220 corner: 150 @ 280).    
				}.
				"'MorphList'->
{
				#fractions -> (0 @ 0 corner: 0 @ 0).  
				#offsets -> (0 @ 290 corner: 150 @ 370).    
				}."
				'Tree'->
{
				#fractions -> (0 @ 0 corner: 0 @ 0).  
				#offsets -> (0 @ 380 corner: 250 @ 600).    
				}.


}! !

!ProportionalPanelTwo methodsFor: 'user-interface' stamp: 'pooja 2/8/2012 10:36'!
morphList
	^ (Color red wheel: 20)
		collect: [ :ea | 
			Morph new
				extent: 70 @ 12;
				color: ea ]! !

!ProportionalPanelTwo methodsFor: 'user-interface' stamp: 'Skrish 8/25/2012 11:13'!
morphsPrimaryPropertiesSpecs
	"self open"

	super morphsPrimaryPropertiesSpecs.
	^ {('DropDown'
		->
			(#on:list:selected:changeSelected:
				->
					{self.
					#newList.
					nil.
					nil})).
	('DisabledDropDown'
		->
			(#on:list:selected:changeSelected:
				->
					{self.
					#newList.
					nil.
					nil})).
	('EditableDropDown'
		->
			(#on:list:selected:changeSelected:
				->
					{nil.
					nil.
					nil.
					nil})).
	('MorphDropDown'
		->
			(#on:list:selected:changeSelected:
				->
					{nil.
					{(Morph new
						extent: 70 @ 12;
						color: Color red).
					(Morph new
						extent: 70 @ 12;
						color: Color green).
					(Morph new
						extent: 70 @ 12;
						color: Color blue)}.
					nil.
					nil})).
	('NormalList'
		->
			(#on:list:selected:changeSelected:menu:keystroke:
				->
					{self.
					#newList.
					nil.
					nil.
					nil.
					nil})).
	('DisabledList'
		->
			(#on:list:selected:changeSelected:menu:keystroke:
				->
					{self.
					#newList.
					nil.
					nil.
					nil.
					nil})).
	"('MorphList'
		->
			(#on:list:selected:changeSelected:menu:keystroke:
				->
					{self.
					#morphList.
					nil.
					nil.
					nil.
					nil}))."
	('Tree'
		->
			(#on:list:selected:changeSelected:menu:keystroke:
				->
					{self.
					#font.
					nil.
					nil.
					nil.
					nil}))}! !

!ProportionalPanelTwo methodsFor: 'user-interface' stamp: 'Skrish 8/25/2012 11:14'!
morphsSecondaryPropertiesSpecs
	"self open"
super morphsSecondaryPropertiesSpecs.
	^ {('DropDown' -> {"(#extent: -> {(150 @ 30)})"}).
	('DisabledDropDown'
		->
			{(#listSelectionIndex: -> {3}).
			(#enabled: -> {false}).
			"(#extent: -> {(150 @ 30)})"}).
	('EditableDropDown'
		->
			{(#ghostText: -> {'Enter new Items '}).
			"(#extent: -> {(150 @ 30)})"}).
	('MorphDropDown' -> {"(#extent: -> {(150 @ 30)})"}).
	('NormalList'
		->
			{(#selectionIndex: -> {3}).
			"(#extent: -> {(150 @ 60)})"}).
	('DisabledList'
		->
			{(#selectionIndex: -> {3}).
			(#enabled: -> {false}).
			"(#extent: -> {(150 @ 60)})"}).
	"('MorphList' -> {(#extent: -> {(150 @ 80)})})"
	}! !

!ProportionalPanelTwo methodsFor: 'user-interface' stamp: 'pooja 2/8/2012 10:36'!
newList
	^ {'One'.
	'Two'.
	'Three'.
	'Four'}! !

!ProportionalPanelTwo methodsFor: 'user-interface' stamp: 'Skrish 8/24/2012 22:22'!
windowSpecs 
"self open"
	^{
		#bounds: -> { 50@10 corner: 350@ 750}
		}! !

AbstractMorphicView subclass: #TestNewProportionalMorphicFromSpecsView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Tests'!

!TestNewProportionalMorphicFromSpecsView class methodsFor: 'as yet unclassified' stamp: 'Skrish 2/26/2013 09:47'!
guiConstants

	^super guiConstants 
		at: 'label1Font' ifAbsentPut:  (( (TextStyle named: #Accuny) ifNil: [ TextStyle default]) fontOfPointSize: 12 );
		yourself! !

!TestNewProportionalMorphicFromSpecsView methodsFor: 'tests' stamp: 'skrish 1/17/2012 01:28'!
createMorphsSpecs
"self open"
"need to ensure the primaryProperties are correctly configured"
	^{
	'label1' -> #LabelMorph.
	 'text1' -> #PluggableTextMorph.
	 'button1' -> 	#PluggableButtonMorph.
		}! !

!TestNewProportionalMorphicFromSpecsView methodsFor: 'tests' stamp: 'skrish 1/17/2012 01:31'!
initialize
	" self open"
	super initialize.
	windowType := #Window.! !

!TestNewProportionalMorphicFromSpecsView methodsFor: 'tests' stamp: 'skrish 1/17/2012 01:55'!
layoutSpecsArray
	"self open"
	" Ensure the composing morph is Proportional Layout
	based in the #composeMorphs"
	^{
	  'label1' -> {
		#fractions ->  (0 @ 0 corner: 0 @ 0).
		#offsets  ->  (40 @ 20 corner: 350 @ 40)
		}.
	'text1' -> {
		#fractions ->  (0 @ 0 corner: 0.95 @ 0.4).
		#offsets  ->  (40 @ 40 corner: 0 @ 0)
		}.
	'button1' -> {
		#fractions ->  (0.95 @ 0.4 corner: 0.95 @ 0.4).
		#offsets  ->  (-80 @ 40 corner:  0 @ 70)
		}.
	}! !

!TestNewProportionalMorphicFromSpecsView methodsFor: 'tests' stamp: 'skrish 1/17/2012 01:29'!
morphsPrimaryPropertiesSpecs
	"Primary mode, action and other setters that supply default values otherwise non-settable attributes
	nil for some args to default them, look at more complete
	implementation to use this better."
	
	super morphsPrimaryPropertiesSpecs.
	^{
	 'button1' ->  ( #on:getState:action:label:menu: -> { [self primaryWindow delete]. nil. #value . nil . nil } ) .
	}
! !

!TestNewProportionalMorphicFromSpecsView methodsFor: 'tests' stamp: 'skrish 1/17/2012 01:57'!
morphsSecondaryPropertiesSpecs
	"Other properties to be initialized at view startup
	the super call sets the resizing to #spaceFill by default.."
	super morphsSecondaryPropertiesSpecs.
	^{
	 'label1'-> { 
	      #contents: -> { 'label1' getLocaleString }. 
	      #font: ->  {(self class guiConstants at: 'label1Font' ) }.
	     }.
	
	'button1' -> {
		#label: -> { 'Button 1' getLocaleString}.
		}
	}
		
	! !

!TestNewProportionalMorphicFromSpecsView methodsFor: 'tests' stamp: 'Skrish 8/24/2012 20:45'!
windowSpecs
	
	^{
		#bounds: -> { 50@50 corner: 500@ 300}
	}! !

AbstractMorphicView subclass: #TestNewProportionalMorphicView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Tests'!

!TestNewProportionalMorphicView class methodsFor: 'as yet unclassified' stamp: 'Skrish 2/26/2013 09:48'!
guiConstants

	^super guiConstants 
		at: 'label1Font' ifAbsentPut:  (( (TextStyle named: #Accuny) ifNil: [ TextStyle default]) fontOfPointSize: 12 );
		yourself! !

!TestNewProportionalMorphicView methodsFor: 'subclass responsibility' stamp: 'skr 1/13/2012 22:06'!
createMorphsDictionary
"self open"
"need to ensure the primaryProperties are correctly configured"
	morphsDictionary
		at: 'label1'
		put: (LabelMorph
				contents:  'label1' getLocaleString );
		 at: 'text1' put: PluggableTextMorph new;
		
		at: 'button1'
		put: (PluggableButtonMorph new
				label:  'Button 1'  getLocaleString)! !

!TestNewProportionalMorphicView methodsFor: 'init' stamp: 'skrish 1/16/2012 01:39'!
initialize
	" self open"
	super initialize.
	windowType := #Dialog.! !

!TestNewProportionalMorphicView methodsFor: 'subclass responsibility' stamp: 'skrish 1/17/2012 01:55'!
layoutSpecs
	"self open"
	" Ensure the composing morph is Proportional Layout
	origins are relative to the panelWindow"
	(morphsDictionary at: 'label1')
		layoutFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 0 @ 0)
				offsets: (40 @ 20 corner: 350 @ 40)).
	(morphsDictionary at: 'text1')
		layoutFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 0.95 @ 0.4)
				offsets: (40 @ 40 corner: 0 @ 0)).
	(morphsDictionary at: 'button1')
		layoutFrame: (LayoutFrame
				fractions: (0.95 @ 0.4 corner: 0.95 @ 0.4)
				offsets: (-80 @ 40 corner:  0 @ 70))! !

!TestNewProportionalMorphicView methodsFor: 'subclass responsibility' stamp: 'skrish 1/11/2012 18:50'!
setMorphsPrimaryProperties
	"nil for mode, action, accept, read selectors, look at more complete
	examples in UITheme class>> examples category to use this better.
	Blank are required for PluggableTextMorph to work as it sends
	navigate messages and throws up the debugger"
	(morphsDictionary at: 'text1')
		on: self
		text: nil
		accept: nil
		readSelection: nil
		menu: nil.
	(morphsDictionary at: 'button1')
		on: [self primaryWindow delete]
		getState: nil
		action: #value
		label: nil
		menu: nil! !

!TestNewProportionalMorphicView methodsFor: 'subclass responsibility' stamp: 'skrish 1/17/2012 01:56'!
setMorphsSecondaryProperties
"Other properties to be initialized at view startup"

	self setAllMorphsToResizeOrWrap: #spaceFill.
	(morphsDictionary at: 'label1') font: (self class guiConstants at: 'label1Font' )
! !

!TestNewProportionalMorphicView methodsFor: 'subclass responsibility' stamp: 'Skrish 8/24/2012 20:46'!
windowSpecs
	
	^{
		#bounds: -> { 50@50 corner: 500@ 300}
	}! !

PharoMorphicObject subclass: #AbstractMorphicViewParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App'!

!AbstractMorphicViewParser methodsFor: 'parser' stamp: 'Skrish 7/11/2012 09:06'!
parseMorphsSpec: specString
	"(AbstractMorphicViewParser named: 'View.singleton') parseMorphsSpec: '^{ ''key1''-> #Text. #row1 -> { ''key9'' -> #TextField.  #row2 -> {''key8'' -> #DropList}}. ''key2''-> #Button. }. '"

	| aView  |
	aView := SimpleImplicitMorphicView new createMorphsSpecs: ( Compiler evaluate: specString).
	^aView createMorphsDictionary ; morphsDictionary  ! !

!AbstractMorphicViewParser methodsFor: 'parser' stamp: 'Skrish 9/3/2012 09:59'!
parsePropertiesSpec: specString
	"Got to redo this method for proper parsing.. but hacked in for now..
	(AbstractMorphicViewParser named: 'View.singleton') parsePropertiesSpec: '^{ ''key1''-> { #con->{123}. }.  ''key2''-> { #con2 ->{987}. }. }'"

	| str specAssocs |
	str := ReadStream on: specString.
	specAssocs := OrderedCollection new.
	str skipTo: ${.
	[ str atEnd ]
		whileFalse: [ 
			| k v vt |
			k := (str upToAll: '->') trimBoth copyReplaceAll: '''' with: ''.
			str atEnd
				ifFalse: [ 
					v := WriteStream on: ''.
					v nextPut: ${.
					v nextPutAll: (str upTo: ${).
					[ (vt := str upToAll: '}.') includes: ${ ]
						whileTrue: [ 
							v
								nextPutAll: vt;
								nextPutAll: '}.' ].
					v
						nextPutAll: (vt copyReplaceAll:'}' with: '');
						nextPutAll: '}.' ;
						cr.
					specAssocs add: k -> v contents ] ].
	^ specAssocs! !

!AbstractMorphicViewParser methodsFor: 'parser' stamp: 'Skrish 7/12/2012 09:40'!
writePropertiesSpec: specAssocs
	"| p | ( p := (AbstractMorphicViewParser named: 'View.singleton') )writePropertiesSpec: 
    (p parsePropertiesSpec: 
 '^{ ''key1''-> { #con->{123}. }.  ''key2''-> { #con2 ->{987}. }. }') "
 
	| str |
	str := WriteStream on: ''.
	str
		nextPutAll: '^{';
		cr.
	specAssocs
		do: [ :ea | 
			str
				nextPutAll: ea key printString;
				nextPutAll: '->';
				nextPutAll: ea value ].
	str nextPut: $}.
	^ str contents! !

PharoMorphicObject subclass: #ApplicationFrameworkDocumentation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core'!

!ApplicationFrameworkDocumentation class methodsFor: 'Documentation' stamp: 'skrish 1/31/2012 07:27'!
A_Intent
	^ 'The purpose of this framework is to have one comprehensive Pharo Application hierarchy that makes it easy to quickly construct an enterprise ready application, that is easily scalable and can be built component by component right from the initiation easy and scalable.

Need an Application Framework that integrates what Pharo provides into a coherent hierarchy of classes that link easily:

References:

1. Various other implementation of Smalltalk leading to the Supervisory Controller architecture of MVP.
2. Spring Framework
3. General Enterprise Architecture patterns

Eventually the goal is to have this plug and play within an enterprise with existing IT assets seamlessly communicating/ interacting with them.

Refer to PharoProvides next '! !

!ApplicationFrameworkDocumentation class methodsFor: 'Documentation' stamp: 'skrish 1/31/2012 07:29'!
B_PharoProvides
	^ '
Pharo provides for lots of frameworks: 

* Morphic: Less said about its beauty, fun the better, but lesser about some of the awkwardness in its tiny issues/ bugs, conflicts in various class approaches, deprecation of class usage not announced and not known till it bites some time later.. etc.. Nonetheless is great fun and need to make it easier to extend and use in a standard enterprise world. Ideally looking at this framework extending to provide a Tablet like View framework and even a marketplace that anyone can download a contributed Pharo code archive ( along with icons, other support files) to have it fully play on its interface runtime.

* Seaside, Aida, : The best of webapplication frameworks that should make it a snap to construct web apps but atleast for Seaside the application framework still is left out.. You have to figure it out. Should look at this framework mature to handle the morphic view completely and extend to provide support for web enabling the view reusing the controller/ model in an extensible/ flexible manner

* Locale/ Language translation: Does not really exist.. needs to be fully explored

* Database framework: SqueakDBX... need to explore and allow for integration with this framework

* Logging: Toothpick is great tool..  But would look at plugging in any alternatives into the LoggingManager to use whatever is needed.. But extend / and complete the features that we are accustomed to seeing in Log4J. Some I have extended/ fixed in Toothpick to show class>method that is raising the log message, timestamp prefix..

* Events Framework : Announcements is there, but its getting confusing to have blank classes to announce events.. should have been a simpler registery dictionary with trigger to perform the event when required..  Would like to bring in a simple registry that holds the events symbols and triggers the action...

* OSProcess/ CommandShell / ProcessWrapper: Limitations for Windows for the first two and the last only on Windows.. with no real eval-loop built in.. 
Need to explore a complete pipeline based two way channel framework to enable tons of capability that can ensure: viz: as Jenkins with Java does..

* GLORP: ORM that is very much needed.. but it needs to couple it up with the XMLRPC-Jdbc or the .Net world if reqd.  

* XML RPC: Important minimal interface to talk to the external world,

* MarkupBuilder: Should leverage and extend this framework to support a performant export capability

* Margritte: Cool and capable MDA, believe it can live independent of the View framework, but can explore plugging it in for the rest of the capability of this framework

* FFI/ Alien/ NativeBoost: Leave it to the user to plugin.. what/ when they need.. 

* Serialization: Fuel ... 


Refer to Comparative frameworks in the external world: 
'! !

!ApplicationFrameworkDocumentation class methodsFor: 'Documentation' stamp: 'skrish 1/31/2012 07:26'!
D_ComparativeFrameworks
	^ '
Taglient MVP/ Dolphin MVP:

	MVC made simpler, flexible and extensible.. need to explore them a lot more along with Martin Fowlers note on SupervisingController that I believe I am adapting to.
	
Patterns in Enterprise Architecture:

	* UI as stated above
	* Model: Tabular Data/ Persistent Data/ Identity Model / ...
	* Loggers, translation, error handling that is configured on runtime type
	* DataSet/ RecordSet and others to optimize working with volumes of data
	* Plugin / Lazy Load / Unit Of Work / DTO .. 
	* Simpler and basic: Money 	

Many others from behavioral/ distributed / that can be independent of the View Framework and can be plugged in as modules.. to the View Framework to bring up a full / complete enterprise app		

Spring in Java and now in .Net...

Reams are written about Spring, Minimally to speak of we need to integrate are:

* Named Prototypes: Singletons, prototypes, factory rolled into one..  beans in Spring

* Configuration: for all external access for DB, interfaces etc.. : ini , xml readers for starters and others easily pluggable 

* Language translations, constant values/ default values 

* Plug and play with components : ORM: GLORP, Loggers, webapp stack, UI frameworks, rules engine, Modularize the application stack in a neat structure

* Transactions framework: This is a big one.. 

* Simplified error handler that degrades on category basis

* Integrate framework for neat out of container unit testing capabilities.. 

* Reporting

* Easy JDBC..!!.. complete gateway to hassle free DBMS works..

* Enterprise Patterns that should never require should implement API / subclassing hierarchy but simple injection based 

* Remote message interface to start with between Pharo vms/ instances.. that works clean and scalably., failure handling cleanly done

* Most important of all: eventually a clean framework for server architecture with load balanced multiplexing system

* The server architecture that can subscribe and run the required services to be scalable for the raising client load: More akin to a server fabric architecture 

'! !

!ApplicationFrameworkDocumentation class methodsFor: 'Documentation' stamp: 'skrish 1/31/2012 07:28'!
E_WhatIsAttemptedNow
	^ '

* Morphic View Framework: Simplify creating Morphic UI with creating views from AbstractMorphicView / SimpleMorphicView that links all of the capabilites of:

	* Components/ Parts / Modular UI construction: Create multiple pieces of independent views and push it into one composite view easily
	
	* Link: actions/ delegate or controller / model to the view
	
* Logger, Language Translations, constants access from external configuration / defaults code based.. 
	
* Named Prototype based to optimize space/ time complexities
	
* Reports in XML , CSV, JSON ..  easily from class/ propertiesbean : Need to use the MarkupBuilder that is to be updated... 

* Leverage as much of the base features and capabilities of Pharo and streamline its use / api / into a clean exposed framework

* Build up a Pharo Tablet User Interface that can scale from a desktop / laptop to a tablet  along with its own Marketplace to seek/ distribute Pharo applications to all users..

* Immediate goal is to construct a modular infrastructure that can work to deliver the app to be consumable as a service through GUI, Web or as a server system or as a proper Service on contract eventually through XMLRPC/ ST RMI/ Web SOA style.. 

'! !

!ApplicationFrameworkDocumentation class methodsFor: 'Documentation' stamp: 'skrish 1/18/2012 23:37'!
F_Roadmap
	^ '
	To be specified in detail
	
* Get the core Application Framework out.. that helps construct an app in days.. 

* Complete the Tablet UI framework, both production and dev systems that is simple and usable with minimal documentation

* Delivery system / build / compile is simplified to a single click generation

* Runtime is customized image that can run it on Tablet Interface, commandline standalone .. mode

* Hook up Groovy XMLRPC based JDBC interface for all DBMS work for now..

* Integrate MarkupBuilder, simple rules engine to start with

* Bring in Fuel based serialization for RMI communication...

* Peer-Peer networking capabilities to run message queue on a failsafe delivery / consume cycle..

* '! !

!ApplicationFrameworkDocumentation class methodsFor: 'Documentation' stamp: 'skrish 1/31/2012 08:28'!
Z_MiscNotes
	^ '
* Need to have a Projects structure that formalizes:

	* config
	* files: images , icons, bin/packages, input, output, reports folders

* Have the Classes browser that shows: per class all methods instance/ class side with tabbed panes for multiple classes in one browser to easily navigate

* integrate a Projects browser that cleanly exposes the file folder structure and the external configs viz: DB / XMLRPC end points etc..

* be able to load a zip of the folder structure and create an app folder to link the app to...

* Dev image should have the ConfigurationOfPharoApplicationFramework that auto loads the current latest packages if dirty from the marked location on start up and save image with the backup created.. if flag is set.

* Auto runs the Unit test cases on startup

* Disallow save image once the image has started.. unless you switch the flag

* Simple wizard to create runtime delivery package.. with similar folders structure

* Build up a tabbed class browser that displays all methods in a single window: class/ instance side together , allow easier switching between methods/ classes.. 
Infact why not recreate an eclipse in Pharo.. with perspectives to change between Projects Browser, Class Browser, and others..

* Create a UIBuilder that is simple drag n drop widgets / panels to create the spec based View class

'! !

PharoMorphicObject subclass: #BankAccount
	instanceVariableNames: 'balance history name accountId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-Examples-BankAccount'!

!BankAccount class methodsFor: 'accessing' stamp: 'skrish 1/20/2012 00:10'!
assignAccountId
	^ (Random new next * BankAccount maxId) asInteger! !

!BankAccount class methodsFor: 'accessing' stamp: 'skrish 1/20/2012 00:39'!
createNewAccount
	| accountId newAccount newName prototypes |
	accountId := self assignAccountId .
	newName := 'NewAccount' , accountId asString.
	newAccount := self
				named: 'BankAccountView.', accountId asString.
	newAccount initialize;
		 accountId: accountId;
		 name: newName.
	^ newAccount! !

!BankAccount class methodsFor: 'accessing' stamp: 'skr 1/5/2012 09:32'!
maxId
	^123456! !

!BankAccount class methodsFor: 'accessing' stamp: 'skr 1/5/2012 09:32'!
minId
	^0! !

!BankAccount methodsFor: 'accessing' stamp: 'skr 1/5/2012 09:31'!
accountId
	^ accountId! !

!BankAccount methodsFor: 'accessing' stamp: 'skrish 1/19/2012 23:51'!
accountId: anID
	 accountId := anID! !

!BankAccount methodsFor: 'accessing' stamp: 'skr 1/5/2012 08:40'!
balance

       "Return the balance"

       ^ balance! !

!BankAccount methodsFor: 'accessing' stamp: 'skrish 1/11/2012 23:56'!
balance: newBalance 
	balance := newBalance.
	history addLast: newBalance..
	self changed: self! !

!BankAccount methodsFor: 'operations' stamp: 'skr 1/5/2012 08:43'!
deposit: amount 
	self balance: balance + amount! !

!BankAccount methodsFor: 'printing' stamp: 'skr 1/5/2012 18:26'!
detailsString
	| details |
	details := WriteStream on: ''.
	details nextPutAll: 'Bank Account Name: ';
		 nextPutAll: name;
		 cr;
		 nextPutAll: 'AccountId: ';
		 nextPutAll: accountId asString;
		 cr;
		 nextPutAll: 'Balance: ';
		 nextPutAll: balance asString;
		 cr.
	^ details contents! !

!BankAccount methodsFor: 'accessing' stamp: 'skr 1/5/2012 08:47'!
history
	^ history! !

!BankAccount methodsFor: 'initialize-release' stamp: 'skrish 1/20/2012 00:10'!
initialize
	balance := 0.
	history := OrderedCollection new.
	accountId ifNil: [
		accountId := self class assignAccountId].! !

!BankAccount methodsFor: 'testing' stamp: 'skr 1/5/2012 09:25'!
name
	"Return the name"
	^ name! !

!BankAccount methodsFor: 'accessing' stamp: 'skrish 1/10/2012 22:37'!
name: aName 
	""
	name := aName.
	self changed: self! !

!BankAccount methodsFor: 'printing' stamp: 'skrish 1/12/2012 00:00'!
printOn: aStream 
	aStream tab; nextPutAll: (name asString padded: #right to: 30 with: Character space ); tab; 
			nextPutAll: '   AccountID: '; nextPutAll: (accountId asString padded: #right to: 8 with: Character space) ; 
			nextPutAll: ' Balance: ';  nextPutAll: ( balance asString padded: #left to: 6 with: Character space).! !

!BankAccount methodsFor: 'testing' stamp: 'skr 1/5/2012 10:44'!
validate
	(name isNil) | (balance < 0) | (history isEmpty)
		ifTrue: [self error: 'Invalid Account']! !

!BankAccount methodsFor: 'operations' stamp: 'skr 1/5/2012 17:22'!
withdraw: amount 
	self validate.
	amount > balance
		ifTrue: [^ self error: 'Withdrawal: Exceeds Funds Available'].
	self balance: balance - amount! !

PharoMorphicObject subclass: #BasicIniReader
	instanceVariableNames: 'iniDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Others'!

!BasicIniReader commentStamp: 'Skrish 8/15/2012 07:56' prior: 0!
Read ini files and be able to return value of parameter at a given [ section ]

Class intention
	* Reading and Parsing ini files
	* Storing the ini file content in a dictionary
	* api to retrieve the parameter value

Class collaborations
	TODO: 
	* If we do have XML Reader make it pattern driven.
	* Probably for more complex needs could have a parser separately

Class main API
	* getValueAt:  atSection: 
!

!BasicIniReader class methodsFor: 'prototype-access' stamp: 'skrish 1/19/2012 18:39'!
prototypeTypeAndNames
	"app and the names allowed
	#types -> one of #definedNames #singleton #factory #prototype ...
	others we will think through
	
	#names -> key is the app name and value is the known names"
	^ {#type -> #definedNames. #names -> {'ApplicationFramework' -> #('configIniReader' ). 'ApplicationFrameworkTests' -> #('configIniReader' ). 'ApplicationFrameworkDev' -> #('configIniReader' )}}! !

!BasicIniReader methodsFor: 'readIni' stamp: 'skrish 1/19/2012 01:03'!
evaluate: evalText 
	 ! !

!BasicIniReader methodsFor: 'readIni' stamp: 'skrish 1/19/2012 01:09'!
evaluate: evalText for: key 
	
	
	| text |
	key = 'viewExtent'
		ifTrue: [ 
			( '*( #RealEstateAgent #maximumUsableAreaInWorld: )*'
				match: evalText )
				ifTrue: [ 
					text := evalText  copyReplaceAll: '#RealEstateAgent #maximumUsableAreaInWorld: ' with: 'RealEstateAgent maximumUsableAreaInWorld: World' ]
				].
		^Compiler evaluate: text.! !

!BasicIniReader methodsFor: 'getKeySection' stamp: 'skrish 1/31/2012 06:27'!
getValueAt: key atSection: sectionName 
	^(iniDictionary
		at: sectionName
		ifAbsent: [self error: 'section name not found' getLocaleString.
			Dictionary new])
		at: key
		ifAbsent: [self error: 'value not found for key' getLocaleString]! !

!BasicIniReader methodsFor: 'accessing' stamp: 'skrish 1/19/2012 00:16'!
iniDictionary
	
	^ iniDictionary ifNil: [ 
			iniDictionary := Dictionary new]! !

!BasicIniReader methodsFor: 'readIni' stamp: 'skrish 1/20/2012 06:20'!
parseIniText: text 
	
	| linesOfText stream eaLine key value  |
	
	iniDictionary := nil.
	linesOfText := text subStrings: (String cr).
	stream := ReadStream on: linesOfText.
	
	[ stream atEnd ] whileFalse: [
		eaLine := stream next trimBoth.
		( eaLine beginsWith: '#' ) 
			ifFalse: [ 
		 ( (eaLine beginsWith: '[' ) and: [ eaLine endsWith: ']' ] )
				ifTrue: [
					key ifNotNil: [ 
						self iniDictionary at: key put: value ].
					key := (eaLine copyFrom: 2 to: eaLine size -1) trimBoth.
					value := Dictionary new]
				ifFalse: [ 
					value at: ( eaLine subStrings: '=' ) first trimBoth put: ( eaLine subStrings: '=' ) last trimBoth ].
					]
				].
	self iniDictionary at: key put: value .
	! !

!BasicIniReader methodsFor: 'read' stamp: 'skrish 1/19/2012 19:38'!
readApplicationConstants: filename 
	| aFs text |
	"Configuration applicationConstants caches what it needs.. so can it be for others using iniReader"
	[aFs := FileStream fileNamed: filename.
	text := aFs contents]
		ensure: [aFs close].
	self parseIniText: text! !

!BasicIniReader methodsFor: 'reset' stamp: 'skrish 1/19/2012 16:01'!
resetIniDictionary
"Be wary of reset unless you know what you are doing"
	iniDictionary := nil! !

PharoMorphicObject subclass: #CheckboxModel
	instanceVariableNames: 'checkBoxSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App'!

!CheckboxModel methodsFor: 'accessing' stamp: 'skrish 2/13/2012 11:12'!
checkBoxSelected

	^checkBoxSelected ifNil: [ false]! !

!CheckboxModel methodsFor: 'accessing' stamp: 'skrish 2/13/2012 11:06'!
checkBoxSelected: bool

	checkBoxSelected := bool! !

PharoMorphicObject subclass: #Configuration
	instanceVariableNames: 'iniDictionary iniReader readerAndFilename applicationConstants'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Others'!

Configuration class
	instanceVariableNames: 'instance'!

!Configuration commentStamp: 'Skrish 8/15/2012 08:04' prior: 0!
The holder for all external configuration files: 
	* Ini parameters
	* NLS support csv files
	* Future for others including XML file support

Class intention
	Holding the instances of the configuration files application wide

Class collaborations
	I usually do not work in isolation but with the help of ...

Class main API
	readApplicationConstants:
!

Configuration class
	instanceVariableNames: 'instance'!

!Configuration class methodsFor: 'config' stamp: 'skrish 1/19/2012 00:50'!
configurationFiles

	^Dictionary new
		at: 'application_ constants' put: { #iniReader . 'application_properties.ini'} ;
		at: 'nls_text_suffix' put: { #csvReader . '_PharoNLS.csv' };
		yourself! !

!Configuration class methodsFor: 'instance creation' stamp: 'skrish 1/20/2012 00:58'!
named: appAndName
	
	^instance := super named: appAndName.
	! !

!Configuration class methodsFor: 'instance creation' stamp: 'skrish 1/19/2012 23:58'!
prototypeTypeAndNames
	"app and the names allowed
	#types -> one of #definedNames #singleton #factory #prototype ...
	others we will think through
	
	#names -> key is the app name and value is the known names"
	^self defaultSingletonPrototypeTypeAndNames! !

!Configuration class methodsFor: 'instance creation' stamp: 'skrish 1/29/2012 12:26'!
resetConfigurations
	NamedPrototype instance resetFlag: true;
		 resetNamedPrototypeAt: 'ApplicationFrameworkTests'.
	(Configuration named: 'ApplicationFramework.Configuration') resetApplicationConstants! !

!Configuration methodsFor: 'accessing' stamp: 'skrish 1/19/2012 10:24'!
applicationConstants
	applicationConstants
		ifNil: [self readApplicationConstants].
	^ applicationConstants! !

!Configuration methodsFor: 'accessing' stamp: 'skrish 1/19/2012 00:59'!
iniReader

	^ iniReader! !

!Configuration methodsFor: 'readIni' stamp: 'skrish 1/19/2012 09:19'!
readApplicationConstants
	
		self readApplicationConstants: #default.! !

!Configuration methodsFor: 'readIni' stamp: 'skrish 2/8/2012 15:03'!
readApplicationConstants: type 
	| readerAndfilename aFs text |
	iniReader
		ifNil: [iniReader := BasicIniReader named: 'ApplicationFramework.configIniReader'].
	readerAndfilename := self class configurationFiles at: 'application_ constants'.
	type =#tests
		ifTrue: [readerAndfilename at: 2 put: readerAndfilename last , '.test'].
	readerAndfilename first = #iniReader
		ifTrue: [iniReader readApplicationConstants: readerAndfilename last].
	applicationConstants := iniReader iniDictionary! !

!Configuration methodsFor: 'accessing' stamp: 'skrish 1/19/2012 19:38'!
resetApplicationConstants
	applicationConstants := nil! !

PharoMorphicObject subclass: #CsvStreamReader
	instanceVariableNames: 'lineEnd fieldDelimiter quoteString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Others'!

!CsvStreamReader commentStamp: 'Skrish 8/15/2012 08:06' prior: 0!
Parsing and reading csv stream with as much as know excel file kind of capability

Class intention
	* Reading and Parsing Csv stream to OrderedCollection of  Array of data cells

Class collaborations
	I usually do not work in isolation but with the help of ...

Class main API
	* readCsvToHeaderAndRowsCollection: csvStream
!

!CsvStreamReader class methodsFor: 'prototype-access' stamp: 'skrish 1/19/2012 19:39'!
prototypeTypeAndNames
	"app and the names allowed
	#types -> one of #definedNames #singleton #factory #prototype ...
	others we will think through
	
	#names -> key is the app name and value is the known names"
	^ {#type -> #definedNames. #names -> {'ApplicationFramework' -> #('csvReader' ). 'ApplicationFrameworkTests' -> #('csvReader' ). 'ApplicationFrameworkDev' -> #('csvReader' )}}! !

!CsvStreamReader methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 01:04'!
fieldDelimiter
	fieldDelimiter ifNil: [ fieldDelimiter := ',' ].
	^ fieldDelimiter! !

!CsvStreamReader methodsFor: 'accessing' stamp: 'Skrish 7/23/2010 10:15'!
fieldDelimiter: fieldDelimiterChar 


fieldDelimiter := fieldDelimiterChar
! !

!CsvStreamReader methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 01:04'!
lineEnd
	lineEnd ifNil: [ lineEnd := String cr ].	" should make the default be picked from Platform preference"
	^ lineEnd! !

!CsvStreamReader methodsFor: 'accessing' stamp: 'Skrish 7/23/2010 10:15'!
lineEnd: crOrCrLf 


lineEnd := crOrCrLf! !

!CsvStreamReader methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 01:04'!
lineEnd: crOrCrLf fieldDelimiter: fieldDelimiterStr quoteString: quoteStr
	lineEnd := crOrCrLf.
	fieldDelimiter := fieldDelimiterStr.
	quoteString := quoteStr! !

!CsvStreamReader methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 01:04'!
quoteString
	quoteString ifNil: [ quoteString := '"' ].
	^ quoteString! !

!CsvStreamReader methodsFor: 'accessing' stamp: 'Skrish 7/23/2010 10:22'!
quoteString: quoteStr

quoteString := quoteStr! !

!CsvStreamReader methodsFor: 'read' stamp: 'Skrish 7/26/2010 01:21'!
readCsvToHeaderAndRowsCollection: csvReadStream
	" Presume for now:
* The first row is a header and a row with no CR within any cell..
* All other row cells have either int/primitive type with or without quotes.. and quotes are removed for cell values"

	|  firstRow headerRow columnCount rowsColl row |
	firstRow := csvReadStream upToAll: self lineEnd.
	headerRow := (firstRow subStrings: self fieldDelimiter) collect: [ :ea | ea trimBoth withoutQuoting ].
	columnCount := headerRow size.
	rowsColl := OrderedCollection with: headerRow.
	[ csvReadStream atEnd ] whileFalse: [ rowsColl add: (self readEachRow: csvReadStream upto: columnCount) ].
	^ rowsColl! !

!CsvStreamReader methodsFor: 'read' stamp: 'Skrish 7/26/2010 01:22'!
readEachRow: csvReadStream upto: columnCount
	| row |
	row := OrderedCollection new.
	1 to: columnCount do: [ :indx | 
		| elems |
		csvReadStream peek = self quoteString first
			ifTrue: [	elems := self quoteString.
					csvReadStream next ]
			ifFalse: [ 
				indx = columnCount
					ifFalse: [ elems := self fieldDelimiter ]
					ifTrue: [ elems := self lineEnd ] ].
		row add: (csvReadStream upToAll: elems) trimBoth withoutQuoting.
		self
			skipEndChars: elems
			for: columnCount
			on: csvReadStream
			at: indx.
		(row last hasWideCharacterFrom: 1 to: row last size)
			ifTrue: [ row
						removeLast;
						add: 'ERROR: CELL HAD WIDE CHAR' ]	"need to recheck on this.. to handle it better" ].
	^ row! !

!CsvStreamReader methodsFor: 'read' stamp: 'Skrish 7/26/2010 01:20'!
skipEndChars: elems for: columnCount on: csvReadStream at: indx
	"skip chars: ',' or crOrCrlf at end of fields..'"

	elems = self quoteString
		ifTrue: [ 
			indx ~= columnCount
				ifTrue: [ 
					| aChar |
					aChar := Character space.
					[ aChar = Character space ] whileTrue: [ aChar := csvReadStream next ].
					aChar = self fieldDelimiter first
						ifFalse: [ self halt	"it must get the fieldDelimiter here and skip ahead" ]	" skip $," ].
			indx = columnCount
				ifTrue: [ csvReadStream upToAll: self lineEnd	" remove the crORcrlf " ] ]! !

PharoMorphicObject subclass: #DynamicModel
	instanceVariableNames: 'variableStore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Others'!

!DynamicModel commentStamp: 'Skrish 8/15/2012 08:08' prior: 0!
A dynamic mock class that will store values in a dictionary akin to instance variable. For almost any RAD work can use this to obviate creating basic model classes that have nothing better than to store and retrieve values: aka PropertyBean

Class intention
	Nothing much

Class collaborations
	I usually do not work in isolation but with the help of ...

Class main API
	My main public API is ...My subclasses may want to override such specific hooks ...
Implementation notes
!

!DynamicModel class methodsFor: 'nil' stamp: 'skrish 7/5/2012 11:37'!
named: aName
	
	^self basicNew initialize name: aName asSymbol ! !

!DynamicModel methodsFor: 'as yet unclassified' stamp: 'Skrish 8/5/2012 23:24'!
doesNotUnderstand: aMessage

	| aSymbol aValue |
	(aSymbol := aMessage  selector )isUnary
		 ifTrue: [
				 self variableStore at: aSymbol  ifAbsent: [^nil].
				^variableStore at: aSymbol  ]. 
	aSymbol numArgs = 1
		ifTrue: [ aSymbol :=( aSymbol asString copyReplaceAll: ':' with: '' ) asSymbol .
				"self variableStore at: aSymbol   ifAbsent: [ self error: 'no variable of this value']."
				variableStore at: aSymbol put: aMessage arguments first]
		ifFalse: [
				self error: 'Does not understand more than 1 arg methods']
	! !

!DynamicModel methodsFor: 'as yet unclassified' stamp: 'skrish 7/5/2012 11:36'!
initialize

	self variableStore at: #name put: nil.! !

!DynamicModel methodsFor: 'as yet unclassified' stamp: 'Skrish 8/2/2012 11:10'!
propertyValue

	(self propertyName = #extent:)
		ifTrue: [" self halt"].
	^variableStore at: #propertyValue ! !

!DynamicModel methodsFor: 'as yet unclassified' stamp: 'skrish 7/5/2012 11:13'!
variableStore 

	^variableStore ifNil: [
		variableStore := Dictionary new]! !

PharoMorphicObject subclass: #LoggerManager
	instanceVariableNames: 'defaultLevel'
	classVariableNames: 'LogFile LoggerCollection TranscriptWindow'
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Others'!

!LoggerManager commentStamp: 'Skrish 8/15/2012 08:10' prior: 0!
Interface to Toothpick for now.. can be flexible to play with others in future..

Class intention
	* log strings to a stream, file , socket etc.. through Toothpick or any other interface later on..

Class collaborations
	I usually do not work in isolation but with the help of ...

Class main API
	My main public API is ...My subclasses may want to override such specific hooks ...
Implementation notes
!

!LoggerManager class methodsFor: 'Misc' stamp: 'skr 1/13/2012 17:08'!
add: aLogger 
	LoggingMultiplexer current
		addLogger: aLogger! !

!LoggerManager class methodsFor: 'Misc' stamp: 'skrish 1/31/2012 06:12'!
current

	^ self  named: 'Logger.Current' ! !

!LoggerManager class methodsFor: 'Misc' stamp: 'skrish 1/17/2012 00:03'!
defaultFormatPolicy
	LoggingMultiplexer current loggers
		do: [:logger | logger format: SimpleLoggingFormatter defaultFormat;
				
				policy: (LoggingPolicy category: #default level: self current defaultLevel )]! !

!LoggerManager class methodsFor: 'Misc' stamp: 'skr 1/13/2012 16:42'!
fileLogger

  ^(NamedPrototype instance new: #FileLogger 
	namedOrExisting: 'Logger.file')
	fileName: self logFile! !

!LoggerManager class methodsFor: 'Misc' stamp: 'skrish 1/19/2012 10:20'!
guiConstants
	^ super guiConstants
		at: #transcriptBounds
		ifAbsentPut: (20 @ 20 corner: 400 @ 300);
		 yourself! !

!LoggerManager class methodsFor: 'Misc' stamp: 'skr 1/13/2012 16:43'!
logFile
	^ LogFile
		ifNil: ['pharologger.log']! !

!LoggerManager class methodsFor: 'Misc' stamp: 'skrish 1/17/2012 00:10'!
logFile: logFileName
	LogFile := logFileName
! !

!LoggerManager class methodsFor: 'Misc' stamp: 'skrish 1/17/2012 00:10'!
loggerTypes
	"for future not used for now used by another obsolete method
	#validate: types of loggers allowed: will check on adding others viz:
	cmd shell,database and other extensions as reqd"
	^ {#singleton -> #(#transcript #stream ). #multi -> #(#file #socket )}! !

!LoggerManager class methodsFor: 'api' stamp: 'skr 1/13/2012 21:34'!
loggersStart: typeArray 
	"self loggersStart: #( transcript file)	"
	"#( file transcript stream ) is the super set for now"
	typeArray
		do: [:type | self
				add: (self new: type)].
	self defaultFormatPolicy; start! !

!LoggerManager class methodsFor: 'api' stamp: 'skr 1/13/2012 20:10'!
loggersStop
			
		LoggingMultiplexer current  stopAllLoggers
		! !

!LoggerManager class methodsFor: 'Misc' stamp: 'skr 1/13/2012 16:38'!
new
	self shouldNotImplement! !

!LoggerManager class methodsFor: 'Misc' stamp: 'skrish 1/17/2012 00:11'!
new: type 
	"create instance of the given type"
	"cmdShell, socketStream, dbms are extensions for future.."
	type = #transcript
		ifTrue: [^ self transcriptLogger name: type].
	type = #file
		ifTrue: [^ self fileLogger name: type].
	type = #stream
		ifTrue: [^ self streamLogger name: type].! !

!LoggerManager class methodsFor: 'Misc' stamp: 'skrish 1/16/2012 23:34'!
openTranscript
	(TranscriptWindow isNil
			or: [TranscriptWindow owner isNil])
		ifTrue: [TranscriptWindow := Transcript open]
		ifFalse: [TranscriptWindow openInWorld
				bounds: (self guiConstants at: 'transcriptBounds' )]! !

!LoggerManager class methodsFor: 'api' stamp: 'skr 1/13/2012 20:10'!
reset
	LoggingMultiplexer reset! !

!LoggerManager class methodsFor: 'Misc' stamp: 'skrish 1/16/2012 23:35'!
start
	LoggingMultiplexer current startAllLoggers.
	(LoggingMultiplexer current loggerNamed: #transcript)
		ifNotNil: [self openTranscript]! !

!LoggerManager class methodsFor: 'Misc' stamp: 'skr 1/13/2012 17:07'!
streamLogger
	^ (NamedPrototype instance new: #Logger namedOrExisting: 'Logger.stream')
		stream: (WriteStream on: '')! !

!LoggerManager class methodsFor: 'Misc' stamp: 'skrish 1/16/2012 23:41'!
transcriptLogger
	^ (NamedPrototype instance new: #Logger namedOrExisting: 'Logger.transcript')
		stream: Transcript! !

!LoggerManager class methodsFor: 'Misc' stamp: 'skrish 1/31/2012 06:05'!
usage
	"Load ToothPick for this to be usable.. 
	
	Call PharoMorphicObject >>logger :
	 ''see #logger method comment: creates a class var''
	***********************
	logger log: 'Message'.
	logger log: 'Message' level: #debug.
	logger log: 'Message' category: #default level: #debug.
	
	for simultaneous broadcast to all registered channels.
	
	Initialize with: 
	logger class loggersStart: #( transcript file stream ).
	
	and shutdown with: 
	logger class loggersStop; reset. ''(reset if reqd)''
	***********************
	
	Before #loggerStart: you can call:
	logger defaultLogLevel: #info. ''( or any of the LogEvent log levels)''
	logger class logFile: 'newLogFilename.log' 
	
	and for the logger.stream reassign a new stream of your choice.. !!.. 
	
	For more complete control.. use in conjunction the original methods
	of Logger .. LoggerMultiplexer as reqd..
	"! !

!LoggerManager class methodsFor: 'Misc' stamp: 'skr 1/13/2012 16:48'!
validate: aLoggerInstance
"If required.. just retaining this method.. currently not usable"

"Check if its one of the allowed types and if duplicate instances are allowed as for transcript, cmdShell"

| loggerType |
loggerType := aLoggerInstance type.
( (self loggerTypes inject: Set new into: [ :aSet :ea | 
		aSet addAll: ea value] )  includes:  loggerType  ) ifFalse: [ ^false].
"duplication is not permitted"
( ( self loggerTypes at: #singleton ) detect: [ :type | type = loggerType ] ifNone: [] )
	ifNotNil: [ 
			(LoggerCollection detect: [ :logger |
					logger type = loggerType ] ifNone: [] ) 
				ifNotNil: [ ^false ].
				].
^true		! !

!LoggerManager methodsFor: 'accessing' stamp: 'skrish 1/17/2012 00:03'!
defaultLevel
	^ defaultLevel
		ifNil: [#debug]! !

!LoggerManager methodsFor: 'accessing' stamp: 'skr 1/13/2012 21:57'!
defaultLevel: aLevel 
	"there can be a confusion if you change this mid stream and do not
	restart the loggers.. but in most cases should be fine if the change of
	level is downward. Can think of automating this.. viz: if level is levelHigher than current .. restart loggers.."
	defaultLevel := aLevel! !

!LoggerManager methodsFor: 'api' stamp: 'Skrish 2/26/2013 09:26'!
log: aMessage 
	"let us default it for now and extend it..
	self current log: 'testing'
	"
	LoggingEvent ifNotNil: [
		LoggingEvent
			category: #default
			level: self defaultLevel
			message: ((thisContext instVarNamed: #sender) asString , ' :  ' , aMessage)]! !

!LoggerManager methodsFor: 'api' stamp: 'skrish 1/18/2012 20:01'!
log: aMessage category: cat level: levelSymbol 
	"let us default it for now and extend it.."
	LoggingEvent
		category: cat
		level: levelSymbol
		message: ((thisContext instVarNamed: #sender) asString , ' :  ' , aMessage)! !

!LoggerManager methodsFor: 'api' stamp: 'skrish 1/18/2012 20:01'!
log: aMessage level: levelSymbol 
	"let us default it for now and extend it.."
	LoggingEvent
		category: #default
		level: levelSymbol
		message: ((thisContext instVarNamed: #sender) asString , ' :  ' , aMessage)! !

PharoMorphicObject subclass: #MorphicViewController
	instanceVariableNames: 'controllerModel view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Others'!

!MorphicViewController commentStamp: 'skrish 1/29/2012 20:27' prior: 0!
A MorphicViewController is like the SupervisingController Martin Fowler talks of in the MVP style.

We do have differentiated MouseListener and EventHandler that is coupled with the view in this hierarchy

Instance Variables
	controllerModel:		<Object>

controllerModel
	- xxxxx
!

MorphicViewController subclass: #MorphicViewBrowserModel
	instanceVariableNames: 'classSelectionIndex classList methodSelectionIndex methodSource instanceOrClass packageName packageNamesList packageNameIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Examples'!

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/23/2012 08:56'!
allClassList 

	 ^self packageNamesList  inject: OrderedCollection new into: [ :clsCol :ea | | pkgInfo |
			pkgInfo := PackageOrganizer default packageNamed: ea ifAbsent: [].
			pkgInfo ifNotNil: [clsCol addAll: pkgInfo classes asSet; yourself].
			clsCol ].! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/4/2012 00:03'!
classList
	classList
		ifEmpty: [classList := Smalltalk allClasses].
	^ classList! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/4/2012 00:17'!
classList: aClassList 
	classList := aClassList.
	classSelectionIndex := 1.  	
	self changed: #classList! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/14/2012 09:34'!
classSelected
	
	classList ifEmpty: [ ^nil].
	classSelectionIndex = 0 ifTrue: [ ^nil].
	^classList at: classSelectionIndex! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/4/2012 00:13'!
classSelectionIndex

	self changed: #methodList.				
	^ classSelectionIndex! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/23/2012 07:48'!
classSelectionIndex: anIndex 
	classSelectionIndex := anIndex.
	methodSelectionIndex := 0.  
	packageNameIndex := self classSelected ifNotNil: [ self packageNamesList indexOf: (self classSelected) category   ].
	packageNameIndex = 0 ifTrue: [ self packageNamesList: (self packageNamesList  add: (self classSelected) category asString ; yourself). packageNameIndex := self packageNamesList size   ].
	self changed: #packageNamesList.
	self changed: #packageNameIndex.
	self changed: #classSelectionIndex.
! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/14/2012 09:43'!
getClassSource

	self classSelected  ifNil: [ ^''].
	^self classSelected superclass name , ' subclass: #'  , self classSelected name, '
		instanceVariables: ' ,  self classSelected instVarNames asString, '
		classVariables: ', self classSelected classVarNames asString, '
		poolDictionaries: ', self classSelected allSharedPools asString, '
		category: ', self classSelected category asString! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/14/2012 09:28'!
getCurrentMethodSource

	| aClass |
	^ (self methodList isEmpty or: [
	  self methodSelected isNil ]) ifTrue: [ methodSource := self getClassSource]
		ifFalse: [
			 aClass := self instanceOrClass = #instance 
				ifTrue: [self classSelected]
				ifFalse: [ self classSelected class ].
			methodSource :=	aClass sourceCodeAt: self methodSelected ]! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/14/2012 21:17'!
initialize

   classList := {}.
   classSelectionIndex := 1.
   methodSelectionIndex := 1.
   instanceOrClass := #instance.
  ! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/14/2012 09:20'!
instanceOrClass

	^instanceOrClass ifNil: [ ^#instance]! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/14/2012 09:26'!
instanceOrClass: symbol
	
	instanceOrClass := symbol! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/14/2012 09:28'!
methodList
	
	| methods |
	self classSelected ifNil: [ ^{} ].
	 methods := self instanceOrClass = #instance 
				ifTrue: [self classSelected methods]
				ifFalse: [ self classSelected class methods ].
	^( methods	collect: [:ea | ea selector]) asSortedCollection.
! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/15/2012 00:16'!
methodSelected

	((methodSelectionIndex = 0) | (methodSelectionIndex > self methodList size))  ifTrue: [ ^nil ].
	^self methodList at: methodSelectionIndex! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/14/2012 00:25'!
methodSelectionIndex

	self changed: #methodSource.
	^ methodSelectionIndex! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/14/2012 00:26'!
methodSelectionIndex: anIndex

	methodSelectionIndex := anIndex.
	self classSelected ifNotNil: 
		[ self methodSource: self getCurrentMethodSource].
	self changed: #methodSelectionIndex ! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/14/2012 00:05'!
methodSource

	^self getCurrentMethodSource
! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/14/2012 09:36'!
methodSource: aText
" compile and update the compiledMethod"

 	 | cm cat aClass|
	self methodSelected ifNotNil: [
		aClass := instanceOrClass = #instance
			ifTrue: [ self classSelected]
			ifFalse: [ self classSelected class].
		cm := aClass  compiledMethodAt: self methodSelected.
 		cat := cm category.	
		self classSelected compile: aText classified:  cat notifying: nil ].
  	self changed: #methodSource! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/23/2012 00:32'!
packageName

	^packageName ifNil: [ 'Package Name']! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/23/2012 07:28'!
packageNameIndex

	^packageNameIndex ifNil: [1]! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/23/2012 08:52'!
packageNameIndex: anIndex

	packageNameIndex := anIndex.
	(packageNamesList at: packageNameIndex ) = 'All'
		ifTrue: [ self classList: self allClassList  ]
		ifFalse: [ self classList: (Smalltalk globals organization classesInCategory: (packageNamesList at: packageNameIndex) ) ]

! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/23/2012 08:49'!
packageNamesList

	^packageNamesList ifNil: [ #('All') asOrderedCollection ]! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skrish 2/23/2012 07:22'!
packageNamesList: aList

	packageNamesList := aList! !

!MorphicViewBrowserModel methodsFor: 'accessing' stamp: 'skr 2/10/2012 11:27'!
shoutAboutToStyle: aMorph

	^true! !

!MorphicViewController methodsFor: 'accessing' stamp: 'skrish 1/27/2012 16:35'!
controllerModel

	^controllerModel! !

!MorphicViewController methodsFor: 'accessing' stamp: 'skrish 1/27/2012 16:32'!
controllerModel: aModel

	controllerModel := aModel! !

!MorphicViewController methodsFor: 'accessing' stamp: 'skrish 1/30/2012 07:51'!
view: aView

	view := aView! !

PharoMorphicObject subclass: #MorphicViewMouseListener
	instanceVariableNames: 'view dropEnabled viewAcceptDropPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Others'!

!MorphicViewMouseListener commentStamp: 'skrish 1/29/2012 20:31' prior: 0!
A MorphicViewMouseListener takes of the mouseListener handling away from the main view.

easier to handle this in this listener.. and use it as the default listener and toggle the actual handling to the event handler..

Instance Variables
	dropEnabled:	if drop is enabled on the view..
	view:		the pimary view instance
	viewAcceptDropPanel:	 the panel of the view that will accept the drop: the primaryWindow is the default

dropEnabled
	- xxxxx

view
	- xxxxx

viewAcceptDropPanel
	- xxxxx
!

!MorphicViewMouseListener class methodsFor: 'as yet unclassified' stamp: 'skrish 1/28/2012 22:30'!
new 
	
   self shouldNotImplement! !

!MorphicViewMouseListener class methodsFor: 'as yet unclassified' stamp: 'skrish 1/28/2012 22:30'!
view: aView 
" decide if we need to do a NamedPrototype on this"
	^ self basicNew view: aView! !

!MorphicViewMouseListener methodsFor: 'mouse-handler' stamp: 'skrish 1/29/2012 11:21'!
acceptDroppingMorph: aMorph event: anEvent
"This default implementation just adds the given morph to the view primaryWindow or panel set"
	self viewAcceptDropPanel addMorph: aMorph
	! !

!MorphicViewMouseListener methodsFor: 'mouse-handler' stamp: 'skrish 1/29/2012 11:14'!
dropEnabled

	^dropEnabled! !

!MorphicViewMouseListener methodsFor: 'mouse-handler' stamp: 'skrish 1/29/2012 11:14'!
dropEnabled: bool

	dropEnabled := bool! !

!MorphicViewMouseListener methodsFor: 'mouse-handler' stamp: 'skrish 1/29/2012 11:13'!
handleDropMorph: anEvent 
	"Handle a dropping morph into the owning view. 
	Primarily mouse events are handled by Morphs and now with a view handling mouse events through a listener it can be tad confusing. need to ensure a clean view level mouse handling.."
	| aMorph localPt |
	aMorph := anEvent contents.
	"Do a symmetric check if view and  morph are linkedr"
	((self wantsDroppedMorph: aMorph event: anEvent) 
		and: [aMorph wantsToBeDroppedInto: self])		
		ifFalse: [^ self].
	anEvent wasHandled: true.
	"ignoring the localPt transform for now till I understand the use"
	self acceptDroppingMorph: aMorph event: anEvent.
	aMorph justDroppedInto: self event: anEvent.
! !

!MorphicViewMouseListener methodsFor: 'mouse-handler' stamp: 'skrish 1/29/2012 11:36'!
handleMouseDown: anEvent 
	"System level event handling."
	anEvent wasHandled ifTrue:[^self].
	"for now no halos at view level..? "
	anEvent wasHandled: true.
	
	"no right click pop up menu for views... they can be at each widget level itself so cmdGestures are not part of listener
	For now not setting view focus as will require view to probably behave as morphs..	
	let the view eventhandler handle it"
	
	view eventHandler mouseDown: anEvent.
	
	"removing handling for mouseStillDown for now. Let us get basics working to bring that in later"! !

!MorphicViewMouseListener methodsFor: 'mouse-handler' stamp: 'skrish 1/29/2012 12:44'!
handleMouseEnter: anEvent 
	"System level event handling."
	anEvent isDraggingEvent
		ifTrue: [(view eventHandler handlesMouseOverDragging: anEvent)
				ifTrue: [anEvent wasHandled: true.
					view eventHandler mouseEnterDragging: anEvent fromView: view].
			^ self].
	"view has no balloon text"
	(view eventHandler handlesMouseOver: anEvent)
		ifTrue: [anEvent wasHandled: true.
			view eventHandler mouseEnter: anEvent]! !

!MorphicViewMouseListener methodsFor: 'mouse-handler' stamp: 'skrish 1/29/2012 11:41'!
handleMouseLeave: anEvent
	"System level event handling."
	anEvent isDraggingEvent ifTrue:[
		(view eventHandler handlesMouseOverDragging: anEvent) ifTrue:[
			anEvent wasHandled: true.
			 view eventHandler mouseLeaveDragging: anEvent fromView: view ].
		^self].
	(view eventHandler handlesMouseOver: anEvent) ifTrue:[
		anEvent wasHandled: true.
		view eventHandler mouseLeave: anEvent.
	].! !

!MorphicViewMouseListener methodsFor: 'mouse-handler' stamp: 'skrish 1/29/2012 11:44'!
handleMouseMove: anEvent
		"System level event handling."
	anEvent wasHandled ifTrue:[^self].
	"Rules say that by default a morph gets #mouseMove iff
		* the hand is not dragging anything,
			+ and some button is down,
			+ and the receiver is the current mouse focus."
	(anEvent hand hasSubmorphs) ifTrue:[^self].
	(anEvent anyButtonPressed and:[anEvent hand mouseFocus == self]) ifFalse:[^self].
	anEvent wasHandled: true.
	view eventHandler mouseMove: anEvent.
	
	"ignore propogating mouseStillDown event for now"! !

!MorphicViewMouseListener methodsFor: 'mouse-handler' stamp: 'skrish 1/29/2012 12:43'!
handleMouseOver: anEvent 
	"System level event handling."
	anEvent hand mouseFocus == self ifTrue:[
		"Maybe relevant ... so retaining a quick recheck "
		(view viewIsTopWindow: anEvent position ) ifFalse:[^self]].
	anEvent hand noticeMouseOver: self event: anEvent! !

!MorphicViewMouseListener methodsFor: 'mouse-handler' stamp: 'skrish 1/29/2012 11:47'!
handleMouseUp: anEvent
	"System level event handling."
	anEvent wasHandled ifTrue:[^self]. 
	anEvent hand mouseFocus == self ifFalse:[^self]. 
	anEvent hand releaseMouseFocus: self.
	anEvent wasHandled: true.
	anEvent blueButtonChanged
		ifTrue:[view eventHandler blueButtonUp: anEvent]
		ifFalse:[view eventHandler mouseUp: anEvent.
				"no propogating handleMouseStillDown event.."].! !

!MorphicViewMouseListener methodsFor: 'accessing' stamp: 'skrish 1/28/2012 22:14'!
view: aView

	view := aView! !

!MorphicViewMouseListener methodsFor: 'mouse-handler' stamp: 'skrish 1/29/2012 11:21'!
viewAcceptDropPanel 

	^viewAcceptDropPanel ifNil: [ view primaryWindow ]! !

!MorphicViewMouseListener methodsFor: 'mouse-handler' stamp: 'skrish 1/29/2012 11:20'!
viewAcceptDropPanel: aViewPanel

	viewAcceptDropPanel := aViewPanel! !

!MorphicViewMouseListener methodsFor: 'mouse-handler' stamp: 'skrish 1/29/2012 11:14'!
wantsDroppedMorph: aMorph event: anEvent
	^self dropEnabled
! !

PharoMorphicObject subclass: #MorphicViewValueWrapper
	instanceVariableNames: 'morph value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App'!

MorphicViewValueWrapper subclass: #ExtendedViewValueWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-Widgets'!

!ExtendedViewValueWrapper class methodsFor: 'dictionaries' stamp: 'skrish 2/13/2012 19:53'!
morphValueGetMethodDictionary
	"Increment this list with the entire morphs family and their setters"

	^super morphValueGetMethodDictionary 
		at: #NewEntryFieldMorph put: #contents;	
		at: #NewTextMorph put: #text ; 	
		at: #DropListMorph put: #listMorph ;
		at: #EditableDropListMorph put: #content ;		
	      at: #MorphDropListMorph put: #listMorph ;
		at: #EdgeGripMorph put: #target ;
		at: #PluggableMorphListMorph put: #selection ;
		at: #PluggableMorphListMorphOfMany  put: #selection ;
		at: #PluggableIconListMorph put: #selection ;	
		at: #PluggableIconListMorphOfMany put: #selection ;			
		yourself! !

!ExtendedViewValueWrapper class methodsFor: 'dictionaries' stamp: 'skrish 2/13/2012 19:53'!
morphValueSetterMethodDictionary
	"Increment this list with the entire morphs family and their setters"

	^super morphValueSetterMethodDictionary 
		at: #NewEntryFieldMorph put: #contents: ;	
		at: #NewTextMorph put: #text: ; 
		at: #DropListMorph put: #listMorph: ;
		at: #EditableDropListMorph put: #listMorph: ;		
	      at: #MorphDropListMorph put: #listMorph: ;
		at: #EdgeGripMorph put: #target: ;
		at: #PluggableMorphListMorph put: #selection: ;
		at: #PluggableMorphListMorphOfMany  put: #selection: ;
		at: #PluggableIconListMorph put: #selection: ;	
		at: #PluggableIconListMorphOfMany put: #selection: ;			
		yourself! !

!MorphicViewValueWrapper class methodsFor: 'instance creation' stamp: 'skrish 5/29/2012 22:44'!
getClassInstance: partOfClassSymbol

	| aClass |
	
	{  ( 'Pluggable', partOfClassSymbol, 'Morph' )  .  (partOfClassSymbol, 'Morph')  . partOfClassSymbol . ( partOfClassSymbol , 'ViewMorph') }
			detect: [ :ea | (aClass := Smalltalk at: ea asSymbol ifAbsent: []) notNil ] ifNone: [].
		
	^aClass new! !

!MorphicViewValueWrapper class methodsFor: 'instance creation' stamp: 'Skrish 9/3/2012 10:04'!
instantiateMorph: partOfClassSymbol

	| morph |
	morph := ( self getClassInstance: partOfClassSymbol).
	morph class name = #CheckboxMorph 
		ifTrue: [ morph on: CheckboxModel new selected: #checkBoxSelected changeSelected: #checkBoxSelected:  ].
	 ^self basicNew morph: morph! !

!MorphicViewValueWrapper class methodsFor: 'instance creation' stamp: 'skrish 5/4/2012 10:05'!
morphFrom: aClassSymbol

	"this is redundant for now"
	((self morphValueGetMethodDictionary keys includes: aClassSymbol) or: [ (self getClassInstance: aClassSymbol) isKindOf: AbstractMorphicView ])
			ifTrue: [ "Should log this for future" ].
     ^self instantiateMorph: aClassSymbol! !

!MorphicViewValueWrapper class methodsFor: 'dictionaries' stamp: 'Skrish 8/2/2012 10:06'!
morphValueGetMethodDictionary
	"Increment this list with the entire morphs family and their setters"
	
	"Always check self morphValueGetMethodDictionary keys = self morphValueSetterMethodDictionary keys"

	^Dictionary new
		at: #Morph put: #none;
		at: #PanelMorph put: #none;
		at: #LabelMorph put: #contents ;
		at: #StringMorph put: #contents ;
		at: #PluggableButtonMorph  put: #label ;
		at: #PluggableTextMorph  put: #getText ;
		at: #PluggableListMorph  put: #selection ;
		at: #DropListMorph  put: #selectedItem ;
		at: #PluggableTextFieldMorph  put: #getText ;
		at: #NewTextMorph put: #contents ;
		at: #EntryFieldMorph put: #contents ;
		at: #CheckboxMorph put: #isSelected ;
		at: #RadioButtonMorph put: #isSelected ;
		at: #RadioButtonGroup put: #selectionIndex;
		at: #PluggableListMorph put: #selection ;
		at: #MorphTreeMorph put: #selectedMorph ;		
		at: #ImageMorph put: #image ;	
		at: #AlphaImageMorph  put: #image ; 
		at: #CheckboxButtonMorph put: #selected ;	
		at: #AlphaImageMorph  put: #selected ; 		
		at: #StringMorph put: #contents ;
		at: #TextMorph put: #contents ;	
		at: #PluggableSliderMorph put: #scaledValue ;	
		at: #SearchMorph put: #content ;				
		yourself! !

!MorphicViewValueWrapper class methodsFor: 'dictionaries' stamp: 'Skrish 8/2/2012 10:06'!
morphValueSetterMethodDictionary
	"Increment this list with the entire morphs family and their setters"
	^Dictionary new
		at: #LabelMorph put: #contents: ;
		at: #StringMorph put: #contents: ;
		at: #PluggableButtonMorph  put: #label: ;
		at: #PluggableTextMorph  put: #setText: ;
		at: #PluggableListMorph  put: #selection: ;
		at: #PluggableTextFieldMorph  put: #setText: ;
		at: #NewTextMorph put: #contents: ;
		at: #EntryFieldMorph put: #contents: ;
		at: #CheckboxMorph put: #selected:  ;
		at: #RadioButtonGroup put: #selectionIndex;
		at: #PluggableListMorph put: #selection: ;
		at: #MorphTreeMorph put: #setSelectedMorph: ;
		at: #ImageMorph put: #image: ;	
		at: #AlphaImageMorph  put: #image: ; 
		at: #CheckboxButtonMorph put: #selected: ;	
		at: #StringMorph put: #contents: ;
		at: #TextMorph put: #contents: ;		
		at: #PluggableSliderMorph put: #scaledValue: ;		
		at: #SearchMorph put: #content:;			
		yourself! !

!MorphicViewValueWrapper class methodsFor: 'instance creation' stamp: 'skrish 2/11/2012 09:40'!
new
"use morphFrom: "
	^self shouldNotImplement ! !

!MorphicViewValueWrapper methodsFor: 'error handling' stamp: 'skrish 2/11/2012 06:54'!
doesNotUnderstand: aMessage

	^morph perform: aMessage selector withArguments: aMessage arguments! !

!MorphicViewValueWrapper methodsFor: 'class membership' stamp: 'skrish 5/19/2012 19:48'!
isKindOf: aClass

	^morph isKindOf: aClass! !

!MorphicViewValueWrapper methodsFor: 'testing' stamp: 'skrish 2/11/2012 20:17'!
isMorph
	
	^self isMorphicView not
	! !

!MorphicViewValueWrapper methodsFor: 'testing' stamp: 'skrish 2/11/2012 20:21'!
isMorphicView 

	^morph isKindOf: AbstractMorphicView ! !

!MorphicViewValueWrapper methodsFor: 'testing' stamp: 'skrish 2/11/2012 06:58'!
isValueWrapper

	^true! !

!MorphicViewValueWrapper methodsFor: 'accessing' stamp: 'skrish 2/11/2012 07:55'!
morph

	^morph! !

!MorphicViewValueWrapper methodsFor: 'accessing' stamp: 'skrish 2/11/2012 06:56'!
morph: aMorph

	morph := aMorph! !

!MorphicViewValueWrapper methodsFor: 'accessing' stamp: 'skrish 2/11/2012 09:43'!
morphValueGetMethod

	^self class morphValueGetMethodDictionary at: morph class name! !

!MorphicViewValueWrapper methodsFor: 'accessing' stamp: 'skrish 2/11/2012 09:29'!
morphValueSetterMethod
	^self class morphValueSetterMethodDictionary at: morph class name! !

!MorphicViewValueWrapper methodsFor: 'accessing' stamp: 'skrish 5/16/2012 20:29'!
owner
"guess should be the current World"
	^morph owner! !

!MorphicViewValueWrapper methodsFor: 'printing' stamp: 'skrish 5/21/2012 13:38'!
printOn: aStream

	aStream nextPutAll: 
		morph asString;
			nextPutAll: '(Wrapper)'! !

!MorphicViewValueWrapper methodsFor: 'class membership' stamp: 'Skrish 8/10/2012 15:26'!
respondsTo: aSymbol 
	"Answer whether the method dictionary of the receiver's class contains 
	aSymbol as a message selector."

	^morph class canUnderstand: aSymbol! !

!MorphicViewValueWrapper methodsFor: 'evaluating' stamp: 'skrish 5/30/2012 01:32'!
value
"what if the model is not set with this value..? or if the value is updated independent of wrapper call.."

"should do away with this hack for checkbox and make it generic "

	(AbstractMorphicView isView: morph class)
		ifTrue: [ ^morph value ].
	^(morph isKindOf: CheckboxMorph )
				ifTrue: [ morph  perform: self morphValueGetMethod ]
				ifFalse: [ morph perform:  self morphValueGetMethod ]! !

!MorphicViewValueWrapper methodsFor: 'accessing' stamp: 'skrish 5/30/2012 01:31'!
value: aValue
"wrapper for the actual value setter for different morphs and automatic call for update:..???"

	(AbstractMorphicView isView: morph class)
		ifTrue: [ ^morph value: aValue ].
	aValue ifNil:[ morph perform:  self morphValueSetterMethod]
		     ifNotNil: [
				"should do away with this hack for checkbox have default model and its getter/setter for value  and make it generic "
				(morph isKindOf: CheckboxMorph )
				ifTrue: [ morph buttonMorph perform: self morphValueSetterMethod with: aValue]
				ifFalse: [ morph perform:  self morphValueSetterMethod with: aValue]
				].
	value := aValue.
	"morph update: self morphValueGetMethod "! !

!PharoMorphicObject class methodsFor: 'instance creation' stamp: 'skrish 1/19/2012 23:58'!
defaultSingletonPrototypeTypeAndNames
	^ {#type -> #singleton. #names -> {'ApplicationFramework' -> {self name}. 'ApplicationFrameworkTests' -> {self name}. 'ApplicationFrameworkDev' -> {self name}}}! !

!PharoMorphicObject class methodsFor: 'constants' stamp: 'skrish 2/2/2012 10:58'!
guiConstants
	^ GuiConstants
		ifNil: [Dictionary new]! !

!PharoMorphicObject class methodsFor: 'constants' stamp: 'skrish 1/31/2012 06:14'!
logger
	"Call this once viz: in #startUp:  to obtain the singleton instance for the image to use it
	across all class/ instance side methods in subclass hierarchy of
	this class
	
	Ref LoggerManager #usage for details
	
	Note: Do not call this method ( or any subclass instantiation with #named: call)
	in PharoMorphicObject #initialize instance side as it will cause a
	recursive infinite loop"
	
	Logger
		ifNil: [Logger := LoggerManager current]! !

!PharoMorphicObject class methodsFor: 'instance creation' stamp: 'skrish 2/2/2012 11:00'!
named: appAndName 
	"Create a NamedPrototype or return existing, with app.name format
	viz: Can be app or module or namespace as you wish to use it as..
	MyMorphicView named: 'MyApp.myname"
	| instance type |
	(type := self validatePrototypeAndNames: appAndName)
		ifNil: [^ nil].
	instance := (Smalltalk at: #NamedPrototype) instance new: self name namedOrExisting: appAndName.
	instance instVarNamed: 'prototypeName' put: appAndName.
	"avoid creating a confusing setter that should not be used from
	anywhere else"
	^ instance! !

!PharoMorphicObject class methodsFor: 'instance creation' stamp: 'skrish 1/19/2012 09:40'!
prototypeTypeAndNames
	"app and the names allowed
	#types -> one of #definedNames #singleton #factory #prototype ...
	others we will think through
	
	#names -> key is the app name and value is the known names"
	^ {#type -> #factory. #names -> {}}! !

!PharoMorphicObject class methodsFor: 'constants' stamp: 'skrish 2/2/2012 10:59'!
useConfigurationGUIConstants
	"invoke in initialization routine for the application"
	GuiConstants := ((Smalltalk at: #Configuration) named: 'ApplicationFramework.Configuration') applicationConstants.
	GuiConstants
		ifNil: [GuiConstants := Dictionary new]! !

!PharoMorphicObject class methodsFor: 'validate' stamp: 'Skrish 7/10/2012 09:33'!
validatePrototypeAndNames: appAndName 
	"validate if its only #definedNames for now.. will work through others"
	| typeAndNames |
	(typeAndNames := self prototypeTypeAndNames) first value = #definedNames
		ifTrue: [typeAndNames last value
				do: [:eaAppAndNames | ((eaAppAndNames value
							collect: [:ea | eaAppAndNames key , '.' , ea])
							detect: [:eaName | eaName = appAndName]
							ifNone: []) notNil
						ifTrue: [^ typeAndNames first]]].
	"singletons are actually singleton per app basis.. not really a singleton"
	typeAndNames first value = #singleton 
		ifTrue: [((typeAndNames last value
					collect: [:eaAppsAssoc | eaAppsAssoc key , '.' , eaAppsAssoc value first])
					includes: appAndName)
				ifTrue: [^ typeAndNames first]].
	( appAndName subStrings: '.') last = 'singleton'
		ifTrue: [^#singleton].
	"for now all factory types return new instances as requested as many
	times requested.. we could expand to have a check logic on number of instances created and deleted/ removed.. to get optimal performance"
	typeAndNames first value = #factory
		ifTrue: [^ typeAndNames first].
	^ nil! !

!PharoMorphicObject methodsFor: 'error' stamp: 'skrish 1/31/2012 07:01'!
error: aMessage 
	"Place holder to work ahead with in conjunction with
	MorphicViewException"
	^ MorphicViewException new signal: aMessage! !

!PharoMorphicObject methodsFor: 'error' stamp: 'skrish 1/31/2012 07:00'!
error: aMessage type: aType 
	"Place holder to work ahead with in conjunction with
	MorphicViewException"
	^ MorphicViewException new type: aType; signal: aMessage! !

!PharoMorphicObject methodsFor: 'accessing' stamp: 'skrish 2/2/2012 11:03'!
newNamed: appAndName 
	"create a deep copy of the current instance and return as a new
	instance"
	^(Smalltalk at:  #NamedPrototype) instance copy: self to: appAndName! !

!PharoMorphicObject methodsFor: 'accessing' stamp: 'skr 1/13/2012 12:57'!
prototypeName

 ^prototypeName! !

PharoMorphicObject subclass: #Reporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Others'!

!Reporter commentStamp: 'skrish 1/17/2012 10:46' prior: 0!
A Reporter is to create external reports for the application in XML , JSON, CSV , HTML  possibly pdf formats with an external hook.
Can follow the logger framework to create multiple channels/ formats of output, category based capability As its primarily a streaming markup builder 
with #tag:text:with:  call to push the data to the output formats..

Instance Variables
!

PharoMorphicObject subclass: #SimpleImplicitMorphicViewExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoMorphicView-Core-App-Examples'!

!SimpleImplicitMorphicViewExample class methodsFor: 'tests-examples' stamp: 'Skrish 7/12/2012 22:36'!
browserOnClass: aClass

	| brow fs |
	brow := Browser  new.
	brow setClass: aClass selector: nil.
	fs := FullscreenMorph new openInWorld color: Color transparent  .
	^fs addMorph: (UIManager default openBrowser: brow asMorphEditing: nil) 
		fullFrame: ( LayoutFrame fractions: ( 0@0 corner: 1@1) offsets: ( 0@0 corner: 0@0))! !

!SimpleImplicitMorphicViewExample class methodsFor: 'tests-examples' stamp: 'Skrish 7/12/2012 22:36'!
test
	" self test"

	| aView |
	aView := SimpleImplicitMorphicView new windowType: #Dialog.
	aView useDefaultBounds: true.
	aView
		createMorphsSpecs:
			{('label1' -> #LabelMorph).
			('text1' -> #PluggableTextMorph).
			('button1' -> #PluggableButtonMorph).
			('check1' -> #CheckboxMorph).
			('textField' -> #PluggableTextFieldMorph)}.
	aView
		morphsPrimaryPropertiesSpecs:
			{('button1'->
					(#on:getState:action:label:menu:->
							{[ UIManager default inform: 'Welcome to MorphicView Framework' ]. nil. #value. nil. nil}))}.
	aView
		morphsSecondaryPropertiesSpecs:
			{('button1' ->
					{
					(#label: -> {'Button B'})}).	
			('check1' ->
					{(#label: -> {'one'})})	}.
	aView open.
"	aView primaryWindow imageForm writeJPEGfileNamed: 'BasicSpecs.jpg'"! !

!SimpleImplicitMorphicViewExample class methodsFor: 'tests-examples' stamp: 'Skrish 2/26/2013 13:39'!
testCreateRadioButtons
" self testCreateRadioButtons"
	| aView |
 	aView := SimpleImplicitMorphicView new windowType: #Morph.

	aView createMorphsSpecs: 
	{
		'label1' -> #LabelMorph .
		'check1' -> #CheckboxMorph.
		'radio' -> #RadioButtonGroup.
		'textField' -> #PluggableTextFieldMorph.
		}.
		
	aView morphsSecondaryPropertiesSpecs: {
	'check1' -> { #label: ->{ 'check1' } } 
	}.
	
	aView panelViewInitializeSpecs: {
	'radio' -> { #list: ->  {{ 'one' . 'two' . 'three' }}}
	}.

 	aView open.
	"aView primaryWindow imageForm writeJPEGfileNamed: 'MorphWindowSpecs.jpg'	"! !

!SimpleImplicitMorphicViewExample class methodsFor: 'tests-examples' stamp: 'Skrish 2/26/2013 13:44'!
testCreateRowAndColPanels
" self testCreateRowAndColPanels"
	| aView labelBlock anImageForm |
	
 	aView := SimpleImplicitMorphicView new windowType: #Dialog. "Choose any of #Window, #Dialog, #StandardWindow , #Morph"
	"aView valueWrapperClass: ExtendedViewValueWrapper . " "or any subclass you create: MorphicViewValueWrapper is the default"
	aView windowTitle: 'Have Fun with Pharo'.	
		
	aView createMorphsSpecs: 
	{
		'check1' -> #CheckboxMorph.
		#row -> {  'label1' -> #LabelMorph.  'text1' -> #PluggableTextFieldMorph.	'button1' -> #PluggableButtonMorph. }.
		"radio's do not have a common model use RadioButtonGroup for that capability"
		#col -> {   'radio1' -> #CheckboxMorph.  'radio2' -> #CheckboxMorph.  'radio3' -> #CheckboxMorph.	}.
		'textField' -> #PluggableTextFieldMorph.
		'image'  -> #AlphaImageMorph 
		}.
	
	anImageForm := PolymorphSystemSettings pharoLogoForm .
	"for the button action.. refactor if reqd with your own controller class:
		aViewController := YourViewController new.
		and  set controller - actionSel directly in the button primaryProperties ."
	labelBlock := [	| md setMorphBlock |
					md := aView morphsDictionary .
					(md at: 'radio1') toggleSelected.
					
					setMorphBlock :=[ :valuesArray | 
							{ 'check1' . 'text1' . 'textField' . 'image'} 
								with: valuesArray do: [ :sym :eaValue | (md at: sym) value: eaValue ] .
									].
								
					(md at: 'radio1') value 
						ifTrue: [ setMorphBlock
									 value: { true. 'Welcome to Pharo..!!' .  'Enter your name, I will do nothing !!' . (Morph new color: Color transparent; extent: anImageForm extent) imageForm }.]
						ifFalse: [ setMorphBlock 
									value: { false. 'Have fun playing with Pharo..!!' .  'I did not even store the name in any model..!!' . anImageForm }	.
								(md at: 'text1') textColor: Color red 	]									
							].
			
	aView morphsPrimaryPropertiesSpecs: {
		'button1' -> (#on:getState:action:label:menu:  -> {labelBlock. nil. #value. nil. nil} ).
		}.	
	
	aView morphsSecondaryPropertiesSpecs: {
		'button1' -> { #label: -> { 'Button Basic Action' } }.
		'check1' -> {  #label: -> { 'CheckOne' }  }.
		'radio1' -> { #beRadioButton -> {} . #label: -> { 'RadioOne' }  }.
		'radio2' -> { #beRadioButton -> {} .  #label: -> { 'RadioTwo' }  }.
		'radio3' -> {#beRadioButton -> {} .  #label: -> { 'RadioThree' }  }.
		'image' -> { #value: -> { anImageForm }}
	}.
	
 	aView open.
	"aView primaryWindow imageForm writeJPEGfileNamed: 'RowAndColPanels.jpg'"! !

!SimpleImplicitMorphicViewExample class methodsFor: 'tests-examples' stamp: 'Skrish 7/12/2012 22:38'!
testCreateViewBasicPackageBrowser
" self testCreateViewBasicPackageBrowser"

	| aView viewModel packageName packageNamesList index classesList |
	aView := SimpleImplicitMorphicView new windowType: #Window.

	"create a model instance and set attributes for view"
	viewModel := MorphicViewBrowserModel new.

	classesList :=  (PackageOrganizer default packageNamed: 'Morphic' ifAbsent: [ ^self error: 'package name unknown' ]) classes  .

	viewModel classList: classesList.
	aView windowTitle: 'Morphic'.
	aView useDefaultBounds: true.
	
	"list of widgets on your screen:"	
	aView createMorphsSpecs: 
	{
		#row1-> { 'classList' -> #PluggableListMorph . 	'methodList' -> #PluggableListMorph .}.
		'sourceText' -> #PluggableTextMorph .
		}.
	
	"basic model and action setters"
	aView morphsPrimaryPropertiesSpecs:  {
		'classList' -> (#on:list:selected:changeSelected:menu:keystroke: -> { viewModel. #classList . #classSelectionIndex . #classSelectionIndex: . nil . nil} ).
		'methodList' -> ( #on:list:selected:changeSelected:menu:keystroke: -> {viewModel . #methodList . #methodSelectionIndex . #methodSelectionIndex: . nil . nil }).
		'sourceText' -> ( #on:text:accept:readSelection:menu: -> {viewModel . #methodSource . #methodSource: . nil . nil  }).
	}.
	
	"the additional attributes of widgets"
	aView morphsSecondaryPropertiesSpecs: {
		'sourceText' -> { #classOrMetaClass: -> { viewModel classSelected }.  #hResizing: -> { #spaceFill} . #vResizing: -> { #spaceFill}}.
		'classList' -> { #hResizing: -> { #spaceFill} . #vResizing: -> { #spaceFill}}.
		'methodList' -> { #hResizing: -> { #spaceFill} . #vResizing: -> { #spaceFill}}
	}.
	
	aView open .
"		aView primaryWindow imageForm writeJPEGfileNamed: 'BasicPackageBrowser.jpg'"! !

!SimpleImplicitMorphicViewExample class methodsFor: 'tests-examples' stamp: 'Skrish 7/12/2012 22:37'!
testCreateViewPackageBrowser
" self testCreateViewPackageBrowser"

	| aView viewModel packageName packageNamesList index classesList |
	aView := SimpleImplicitMorphicView new windowType: #Window.

	"create a model instance and set attributes for view"
	viewModel := MorphicViewBrowserModel new.

	packageNamesList := PackageOrganizer default packageNames asSortedCollection .
	index := UIManager default chooseFrom: packageNamesList  lines: #(1).
	classesList :=  (PackageOrganizer default packageNamed: (packageNamesList at: index) ifAbsent: [ ^self error: 'package name unknown' ]) classes  .

	viewModel classList: classesList.
	aView windowTitle: (packageNamesList at: index).
	aView useDefaultBounds: true.
	
	"list of widgets on your screen:"	
	aView createMorphsSpecs: 
	{
		#row1-> { 'classList' -> #PluggableListMorph . 	'methodList' -> #PluggableListMorph .}.
		#row2 -> { #resizing -> #shrinkWrap. 'instanceButton' -> #PluggableButtonMorph . 'classButton' -> #PluggableButtonMorph }.
		'sourceText' -> #PluggableTextMorph .
		}.
	
	"basic model and action setters"
	aView morphsPrimaryPropertiesSpecs:  {
		'classList' -> (#on:list:selected:changeSelected:menu:keystroke: -> { viewModel. #classList . #classSelectionIndex . #classSelectionIndex: . nil . nil} ).
		'methodList' -> ( #on:list:selected:changeSelected:menu:keystroke: -> {viewModel . #methodList . #methodSelectionIndex . #methodSelectionIndex: . nil . nil }).
		'sourceText' -> ( #on:text:accept:readSelection:menu: -> {viewModel . #methodSource . #methodSource: . nil . nil  }).
		'instanceButton' -> ( #on:getState:action:label:menu:  -> { [viewModel instanceOrClass: #instance. viewModel classSelectionIndex: viewModel classSelectionIndex ] . nil. #value . nil. nil }).
		'classButton' -> ( #on:getState:action:label:menu:  -> { [viewModel instanceOrClass: #class. viewModel classSelectionIndex: viewModel classSelectionIndex ] . nil. #value . nil. nil })
	}.
	
	"the additional attributes of widgets"
	aView morphsSecondaryPropertiesSpecs: {
		'sourceText' -> { #classOrMetaClass: -> { viewModel classSelected }.  #hResizing: -> { #spaceFill} . #vResizing: -> { #spaceFill}}.
		'instanceButton' -> { #label: -> { 'instance methods'}}.
		'classButton' -> { #label: -> { 'class methods'}}.
		'classList' -> { #hResizing: -> { #spaceFill} . #vResizing: -> { #spaceFill}}.
		'methodList' -> { #hResizing: -> { #spaceFill} . #vResizing: -> { #spaceFill}}
	}.
	
	aView open .
"	aView primaryWindow imageForm writeJPEGfileNamed: 'ExtendedPackageBrowser.jpg'	"! !

!SimpleImplicitMorphicViewExample class methodsFor: 'tests-examples' stamp: 'Skrish 2/26/2013 13:46'!
testCreateViewPackageBrowserView: packageName
"( self testCreateViewPackageBrowserView: 'PharoMorphicView-Core' ) open "

	| aView viewModel  packageNamesList index classesList |
	aView := SimpleImplicitMorphicView new windowType: #Window.

	"create a model instance and set attributes for view"
	viewModel := MorphicViewBrowserModel new.

	classesList :=  (PackageOrganizer default packageNamed: packageName ifAbsent: [ ^self error: 'package name unknown' ]) classes  .

	viewModel classList: classesList.
	aView windowTitle: packageName.
	aView useDefaultBounds: true.
	
	"list of widgets on your screen:"	
	aView createMorphsSpecs: 
	{
		#row1-> { 'classList' -> #PluggableListMorph . 	'methodList' -> #PluggableListMorph .}.
		#row2 -> { #resizing -> #shrinkWrap. 'instanceButton' -> #PluggableButtonMorph . 'classButton' -> #PluggableButtonMorph }.
		'sourceText' -> #PluggableTextMorph .
		}.
	
	"basic model and action setters"
	aView morphsPrimaryPropertiesSpecs:  {
		'classList' -> (#on:list:selected:changeSelected:menu:keystroke: -> { viewModel. #classList . #classSelectionIndex . #classSelectionIndex: . nil . nil} ).
		'methodList' -> ( #on:list:selected:changeSelected:menu:keystroke: -> {viewModel . #methodList . #methodSelectionIndex . #methodSelectionIndex: . nil . nil }).
		'sourceText' -> ( #on:text:accept:readSelection:menu: -> {viewModel . #methodSource . #methodSource: . nil . nil  }).
		'instanceButton' -> ( #on:getState:action:label:menu:  -> { [viewModel instanceOrClass: #instance. viewModel classSelectionIndex: viewModel classSelectionIndex ] . nil. #value . nil. nil }).
		'classButton' -> ( #on:getState:action:label:menu:  -> { [viewModel instanceOrClass: #class. viewModel classSelectionIndex: viewModel classSelectionIndex ] . nil. #value . nil. nil })
	}.
	
	"the additional attributes of widgets"
	aView morphsSecondaryPropertiesSpecs: {
		'sourceText' -> { #classOrMetaClass: -> { viewModel classSelected }.  #hResizing: -> { #spaceFill} . #vResizing: -> { #spaceFill}}.
		'instanceButton' -> { #label: -> { 'instance methods'}}.
		'classButton' -> { #label: -> { 'class methods'}}.
		'classList' -> { #hResizing: -> { #spaceFill} . #vResizing: -> { #spaceFill}}.
		'methodList' -> { #hResizing: -> { #spaceFill} . #vResizing: -> { #spaceFill}}
	}.
	
	^aView ! !

!SimpleImplicitMorphicViewExample class methodsFor: 'tests-examples' stamp: 'Skrish 7/12/2012 20:34'!
workspace

| window pane wsp |
	wsp := Workspace new.
	window := (SystemWindow labelled: 'labelString') model: wsp.
	pane := wsp buildTextMorph.
	"window addMorph: pane frame: (0@0 corner: 1@1)."
	^pane! !

!SimpleImplicitMorphicViewExample methodsFor: 'user-interface' stamp: 'Skrish 7/12/2012 20:33'!
exampleTabGroupOn: aWindow

	^{
		(aWindow newRow: {aWindow newImage: UITheme current smallLeftFlushIcon.
			aWindow newLabel: 'PharoMorphicView'})->
							((self class testCreateViewPackageBrowserView: 'PharoMorphicView' ) createPrimaryView ; panelWindow ).
				'Morphic'->((self class testCreateViewPackageBrowserView: 'Morphic' ) createPrimaryView ; panelWindow ).
				'PharoTablet'->((self class testCreateViewPackageBrowserView: 'PharoTablet' ) createPrimaryView ; panelWindow ).
				'Workspace'->(self class workspace  )}.
				! !

!SimpleImplicitMorphicViewExample methodsFor: 'user-interface' stamp: 'Skrish 7/12/2012 23:09'!
openTabbedSystemWindows
" Convert this into SimpleMorphic ASAP, make it generate tabs on the fly.. and for each package and class as required..+ other tools.. "
"self new openTabbedSystemWindows"

| view dialog |
	view := SimpleImplicitMorphicView new windowTitle:  'Tabbed Browsers' ; windowType: #Dialog.
	view createMorphsSpecs: {}; useDefaultBounds: true.
	dialog := (view createPrimaryView ; primaryWindow ) beResizeable; addEdgeGrips .
	dialog bounds: ( 100@50 corner: (1200@750)) .
	
	self openTabbedSystemWindows: view with: (self exampleTabGroupOn: dialog).
	view composePanelWindow.
	view panelWindow   vResizing: #spaceFill; hResizing: #spaceFill .
	view  postCreateOpen  ! !

!SimpleImplicitMorphicViewExample methodsFor: 'user-interface' stamp: 'Skrish 7/12/2012 23:10'!
openTabbedSystemWindows: view with: tabGroup
" Convert this into SimpleMorphic ASAP, make it generate tabs on the fly.. and for each package and class as required..+ other tools.. "
"self new openTabbedSystemWindows"

	view createMorphsSpecs: { 'tabs' -> #TabGroupMorph  }.
	view morphsDictionary at: 'tabs' put: (( view primaryWindow  newRow: {
		(view primaryWindow newTabGroup: tabGroup ) } )  vResizing: #spaceFill; hResizing: #spaceFill )

		
! !
